2010-07-22  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditorData.cs: fix build.

2010-07-22  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditorData.cs: Added some delegation
	  methods.

2010-07-22  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Cache line offsets in
	  performance critical sections.

2010-07-21  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs: Fixed issue with folding
	  update.

2010-07-21  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/SyntaxMode.cs: Cached stack top
	  elements.

2010-07-21  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/GapBuffer.cs:
	* SyntaxModes/DiffSyntaxMode.xml:
	* SyntaxModes/MakefileSyntaxMode.xml:
	* SyntaxModes/ChangeLogSyntaxMode.xml:
	* Mono.TextEditor.Highlighting/Span.cs:
	* Mono.TextEditor.Highlighting/SyntaxMode.cs:
	* Mono.TextEditor.Highlighting.Regex/Regex.cs:
	* Mono.TextEditor.Highlighting/JaySyntaxMode.cs: Tried to
	  speed up highlighting.

2010-07-21  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/LineSegment.cs: fixed 'regression Bug 615624
	  - Pressing DOWN after RETURN moves cursor to beginning of
	  blank lines instead of to the indent'.

2010-07-20  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/SyntaxModeService.cs: Fixed
	  highlighting bug.

2010-07-20  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/LineSegment.cs: fix build.

2010-07-20  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/LineSegment.cs:
	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor.Highlighting/SyntaxMode.cs:
	* Mono.TextEditor/FoldingScreenbackgroundRenderer.cs: Tweaked
	  text editor performance.

2010-07-20  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/SyntaxMode.cs:
	* Mono.TextEditor.Highlighting/SyntaxModeService.cs: Optimized
	  highlighting thread.

2010-07-19  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/SimpleEditMode.cs: 

2010-07-18  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditorData.cs: Added SetCaretTo
	  delegation.

2010-07-18  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditorData.cs: SelectionRange is now
	  always != null.

2010-07-18  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextEditorData.cs: Added some delegation
	  methods to the texteditordata to make its usage easier -
	  moved the advanced setcaret (with highlight & pulse) to the
	  texteditor.

2010-07-18  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/SyntaxModeService.cs:
	  comment-in span remove code.

2010-07-17  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/SyntaxMode.cs: pop span before
	  end tag.

2010-07-17  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/SyntaxMode.cs:
	* Mono.TextEditor.Highlighting/JaySyntaxMode.cs:
	* Mono.TextEditor.Highlighting/SyntaxModeService.cs: Worked on
	  syntax highlighting.

2010-07-17  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/Chunk.cs:
	* Mono.TextEditor.Highlighting/SyntaxMode.cs: Changed
	  highlighting.

2010-07-16  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Check span stack.

2010-07-16  Mike Krüger  <mkrueger@novell.com>

	* Makefile.am:
	* Mono.TextEditor.csproj:
	* Styles/TangoLightStyle.xml:
	* Mono.TextEditor/LineSegment.cs:
	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor/ClipboardActions.cs:
	* Mono.TextEditor.Highlighting/Chunk.cs:
	* Mono.TextEditor.Highlighting/SyntaxMode.cs:
	* Mono.TextEditor.Highlighting/JaySyntaxMode.cs:
	* Mono.TextEditor.Highlighting/CloneableStack.cs:
	* Mono.TextEditor.Highlighting/SyntaxModeService.cs: Worked on
	  highlighting - it's now more speed & memory efficient and
	  fixed 'Bug 622108 - Background color issues'.

2010-07-15  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Added null check.

2010-07-14  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Highlighting/Style.cs: Fix colours.

2010-07-14  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Caret.cs:
	* Mono.TextEditor/TextEditorData.cs: Caret now exposes it's
	  TextEditorData.

2010-07-13  Michael Hutchinson  <mhutchinson@novell.com>

	* SyntaxModes/AspNetSyntaxMode.xml:
	* Mono.TextEditor.Highlighting/Style.cs: Added styles for
	  templated regions in files, e.g. ASP.NET and T4.

2010-07-13  Mike Krüger  <mkrueger@novell.com>

	* Makefile.am:
	* Mono.TextEditor.csproj:
	* Mono.TextEditor/Document.cs:
	* Mono.TextEditor.Highlighting/WorkerThread.cs: Replaced
	  custom workerthread with
	  system.compontentmodel.backgroundworker.

2010-07-12  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Fixed 'Bug 621483 - MD
	  hangs for a few seconds when searching'.

2010-07-12  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs:
	* Mono.TextEditor/FoldSegment.cs: Optimized fold segment
	  updating/fixed 'Bug 621484 - Editor repaints multiple times
	  after "resolve using"'.

2010-07-12  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/DefaultEditActions.cs: Implemented 'Bug
	  621461 - shift+tab should outdent a code line without
	  selecting it' / shift-tab behaves now like in gedit.

2010-07-09  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: fixed build.

2010-07-09  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: Added some gdk window checks.

2010-07-09  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/DefaultEditActions.cs: Fixed indent
	  selection.

2010-07-09  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/Rule.cs: Fixed 'Bug 620977 -
	  Special characters in source code crashes MD'.

2010-07-08  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/DeleteActions.cs: Fixed 'Bug 620854 -
	  "delete to end of line" messes up edited file'.

2010-07-08  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextMarker.cs: Changed the isVisible flag
	  setting.

2010-07-07  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextMarker.cs: Text marker now defaults to
	  visible.

2010-07-05  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Theatrics/SmartScrolledWindow.cs: Fixed GTK
	  critical when closing a text editor.

2010-07-05  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/DefaultEditActions.cs: Fixed single line
	  indent/outdent (Bug 619798 - Outdent a selected line selects
	  the next line).

2010-07-02  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Theatrics/SmartScrolledWindow.cs: Fixed text
	  editor splitting.

2010-07-01  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Caret.cs:
	* Mono.TextEditor/TextEditor.cs: Fixed some issues.

2010-07-01  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextLinkEditMode.cs: Fixed text link
	  markers.

2010-06-29  Mike Krüger  <mkrueger@novell.com>

	* Styles/BrownStyle.xml:
	* Styles/IrBlackStyle.xml:
	* Styles/OblivionStyle.xml:
	* Styles/TangoLightStyle.xml:
	* Mono.TextEditor/Document.cs:
	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor.Highlighting/Style.cs: Some styling changes
	  for the version control gui.

2010-06-24  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextMarker.cs:
	* Mono.TextEditor/TextViewMargin.cs: Fixed 'Bug 616949 -
	  Message bubbles prevents the background color of selected
	  text to change'.

2010-06-24  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/DefaultEditActions.cs: Fixed 'Bug 616921 -
	  "Move the line or highlighted selection up" command deletes
	  selection'.

2010-06-24  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/SyntaxModeService.cs: Check if
	  line is valid.

2010-06-23  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs: Fixed 'Bug 616128 - Text editor
	  hiccoughs every 2 seconds (approx.)'.

2010-06-23  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs: Update line after unregistering
	  text marker.

2010-06-21  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs: Fixed 'Bug 615624 - Pressing
	  DOWN after RETURN moves cursor to beginning of blank lines
	  instead of to the indent'.

2010-06-21  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextLinkEditMode.cs:
	* Mono.TextEditor/InsertionCursorEditMode.cs: Text link edit
	  mode can now show mode help windows as well.

2010-06-18  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditorData.cs:
	* Mono.TextEditor/DefaultEditActions.cs: Improved virtual
	  space return key behavior.

2010-06-18  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Vi/ViCommandBuilder.cs: Some simple
	  multiplier support.

2010-06-18  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/DefaultEditActions.cs: Fixed 'Bug 615191 -
	  When using multiline selection to indent/outdent, the
	  indenter selects too much'.

2010-06-18  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditorData.cs:
	* Mono.TextEditor/ClipboardActions.cs: Fixed 'Bug 615196 -
	  Pasting a chunk of text into the virtual whitespace fracks
	  everything up'.

2010-06-18  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Fixed 'Bug 615342 -
	  Source code highlighting behaves badly on cyrillic text'.

2010-06-17  Mike Krüger  <mkrueger@novell.com>

	* Makefile.am:
	* Mono.TextEditor.csproj:
	* Mono.TextEditor.PopupWindow/ListWindow.cs:
	* Mono.TextEditor/InsertionCursorEditMode.cs:
	* Mono.TextEditor.PopupWindow/ModeHelpWindow.cs:
	* Mono.TextEditor/FoldingScreenbackgroundRenderer.cs: Added
	  help window for insertion mode.

2010-06-16  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/SyntaxMode.cs: Fixed
	  highlighting bug.

2010-06-16  Mike Krüger  <mkrueger@novell.com>

	* SyntaxModes/JavascriptSyntaxMode.xml: Added mime type for
	  java script.

2010-06-16  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/SyntaxMode.cs: Corrected a
	  highlighting bug (visible in the CTAGS section in xml
	  highlighting).

2010-06-16  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Vi/ViCommandBuilder.cs: Remove debug code,
	  tidy.

	* Mono.TextEditor.Vi/ViEditorContext.cs: Basic input
	  processing.

2010-06-16  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/TextEditor.cs: Use mapped modifier values
	  for the IM commit. Modifiers and keys received by editor
	  extensions and editor modes are now always post keyboard
	  mapping.

	* Mono.TextEditor/SimpleEditMode.cs: Moved
	  modifier-permits-input check here. Much simpler now that
	  modifiers are consumed.

2010-06-16  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/Platform.cs: Track MapRawKeys from Ide -
	  don't restore consumed modifiers, since that breaks vi
	  stuff.

2010-06-16  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Vi/ViCommandBuilder.cs: Work around a gmcs
	  bug.

2010-06-15  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Vi/ViEditorContext.cs:
	* Mono.TextEditor.Vi/ViCommandBuilder.cs: Merged ViEditor and
	  ViEditorContext. Added method for building commands.

2010-06-15  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Vi/ViCommandBuilder.cs: Fix build, add more
	  actions.

2010-06-15  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Vi/ViKeyNotation.cs: Remove full ctor that
	  could create invalid keys.

	* Mono.TextEditor.Vi/ViCommandBuilder.cs: Add some more action
	  maps.

2010-06-15  Michael Hutchinson  <mhutchinson@novell.com>

	* Makefile.am:
	* Mono.TextEditor.csproj: Added file to project.

2010-06-15  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Vi/ViKeyNotation.cs: Implement equality
	  members on ViKey.

	* Mono.TextEditor.Vi/ViCommandBuilder.cs: Parse motions,
	  multipliers, registers.

2010-06-15  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Vi/ViKeyNotation.cs:
	* Mono.TextEditor.Vi/ViEditorContext.cs:
	* Mono.TextEditor.Vi/ViCommandBuilder.cs: New vi command
	  builder architecture (incomplete)

2010-06-15  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: made some functions
	  public.

2010-06-15  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/GutterMargin.cs: Fixed a bug where the
	  gutter margin with isn't calculated correctly.

2010-06-14  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.TextEditor.Vi/ViKeyNotation.cs: Really fix the windows
	  build.

2010-06-14  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.TextEditor.Vi/ViKeyNotation.cs: Fix windows build.

2010-06-14  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor/TextEditorData.cs: Fixed 'Bug 609674 -
	  Selection changes on middle-click after selection'.

2010-06-14  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/DeleteActions.cs: Fixed 'Bug 613770 -
	  Backspace inconsistently deletes entire lines when using
	  "virtual spaces"'.

2010-06-12  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Vi/ViKeyNotation.cs: Use explicit
	  dictionaries instead of switches, to make code more
	  readable.

2010-06-11  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Vi/ViKeyNotation.cs: Added vi key notation
	  parsing and stringifying.

	* Mono.TextEditor.Vi/ViCommandBuilder.cs: Added vi command
	  builder stub.

	* Makefile.am:
	* Mono.TextEditor.csproj: Added files.

2010-06-11  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Fix super for block
	  select.

2010-06-11  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor/CaretMoveActions.cs: Fixed 'Bug 612001 -
	  "Virtual tab" line spacing is incorrect'.

2010-06-10  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Vi/ViActions.cs: Fix some buglets in the
	  selection line pivoting.

2010-06-10  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Vi/ViMode.cs: Fix mouse selection enabling
	  visual mode.

2010-06-10  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Vi/ViMode.cs:
	* Mono.TextEditor.Vi/ViActions.cs: Fix the visual mode
	  selection when pivoting around the anchor char and anchor
	  line.

2010-06-10  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Vi/ViActions.cs: Fix line end text object.

2010-06-10  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/Document.cs: Add RemoveMarker overloads
	  allowing to skip line updates.

2010-06-10  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs:
	* Mono.TextEditor.Vi/ViMark.cs: Fixed 'Bug 613114 - NRE in
	  editor means error marker never goes away'.

2010-06-05  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/SyntaxMode.cs: Fixed 'Bug
	  611947 - XML highlighting broken'.

2010-06-04  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextEditorAccessibility.cs: Disabled
	  accessibility (produces a compile error on linux - on mac it
	  works - the Atk.ObjectFactory implementation differs between
	  my two systems).

2010-06-04  Mike Krüger  <mkrueger@novell.com>

	* Makefile.am:
	* Mono.TextEditor.csproj:
	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextEditorAccessibility.cs: Worked on
	  accessibility.

2010-06-04  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: atk impl. improvements

2010-06-04  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: Added accessibility support.

2010-06-04  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/SyntaxMode.cs:
	* Mono.TextEditor.Highlighting/JaySyntaxMode.cs: Fixed syntax
	  highlighting bug.

2010-06-03  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/InsertionCursorEditMode.cs: Don't start
	  insertion cursor mode without insertion points.

2010-06-02  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor/SelectionActions.cs: Fixed virtual space
	  drawing.

2010-06-02  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Vi/ViActions.cs: Fix navigation in visual
	  mode.

	* Mono.TextEditor/SelectionActions.cs: Fix pivot around origin
	  for line selection actions.

2010-06-02  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/InsertionCursorEditMode.cs: Corrected
	  indenting of insertion.

2010-06-01  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Vi/ViMode.cs: Fix tests.

2010-06-01  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/InsertionCursorEditMode.cs: Worked on
	  insertion cursor mode.

2010-06-01  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/InsertionCursorEditMode.cs: Worked on
	  insertioncursoreditmode.

2010-06-01  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Vi/ViMode.cs: Reset on external caret change
	  if not in insert/replace mode.

2010-05-31  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Vi/ViMode.cs: Better handling of '*'.

2010-05-31  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Vi/ViMode.cs: Improve testability. Fix dd
	  and cc behaviour.

	* Mono.TextEditor/EditMode.cs: Made RunActions take params,
	  not just two.

2010-05-31  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Vi/ViActionMaps.cs: New EditObject map for
	  'c' to use word start/end instead of word navigation
	  boundaries.

	* Mono.TextEditor/EmacsWordFindStrategy.cs:
	* Mono.TextEditor.Vi/ViWordFindStrategy.cs:
	* Mono.TextEditor/SharpDevelopWordFindStrategy.cs: Move code
	  to abstract base class.

	* Mono.TextEditor.Vi/ViActions.cs: Added WordStart and WordEnd
	  move actions.

	* Mono.TextEditor.Vi/ViMode.cs: Implemented '*'. Also, 'c'
	  uses the EditObject map.

	* Mono.TextEditor/TextEditorData.cs: Added FindCurrentWordEnd
	  and FindCurrentWordStart methods that use the
	  IWordFindStrategy.

	* Mono.TextEditor/IWordFindStrategy.cs: New abstract base
	  class. Added new FindCurrentWordEnd and FindCurrentWordStart
	  methods to interface, with default implementation taken from
	  TextViewMargin.

	* Mono.TextEditor/TextViewMargin.cs: Use the WordFindStrategy
	  for word selection.

2010-05-31  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Vi/ViActions.cs: Fix possible exception.

2010-05-31  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Vi/ViMode.cs: Single-char offset should not
	  move caret position.

2010-05-31  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Vi/ViMode.cs: Smart casing for searches. Fix
	  'cw' insertion position.

2010-05-31  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Vi/ViMode.cs: Retreat from line end after x
	  and on reset. Don't allow x to delete line delimiters.

2010-05-31  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Vi/ViActionMaps.cs: Use vi up/down/end
	  commands with arrow and end keys too.

	* Mono.TextEditor.Vi/ViActions.cs: RetreatFromLineEnd now only
	  retreats in caret is in block mode.

	* Mono.TextEditor.Vi/ViMode.cs: Retreat after exiting insert
	  mode. Retreat from line end after caret placed with mouse.
	  Fix 'a' at line end.

	* Mono.TextEditor/EditMode.cs:
	* Mono.TextEditor/TextEditor.cs: Added a caret position change
	  notification for edit modes.

2010-05-31  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/InsertionCursorEditMode.cs: Worked on
	  insertion cursor mode.

2010-05-31  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: added new scroll to overload.

2010-05-31  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Vi/ViMode.cs: Use OnAdded/OnRemoved to
	  change caret.

	* Mono.TextEditor/TextEditorData.cs: Properly implement the
	  mode OnAdded/OnRemoved calls.

	* Mono.TextEditor/EditMode.cs: Don't access Editor unless
	  necessary. Improves testability. Also properly implement the
	  OnAdded/OnRemoved calls

2010-05-30  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/InsertionCursorEditMode.cs: Worked on
	  insertion cursor mode.

2010-05-29  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextViewMargin.cs: Fixed 'Bug 610099 -
	  Typing in lines with bubbles very slow'.

2010-05-29  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Fixed 'Bug 610050 - Ruler
	  position wrong in unselected text'.

2010-05-29  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/DefaultEditActions.cs: Fixed 'Bug 610045 -
	  Moving line with url alt-up/down leaves url markers'.

2010-05-29  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Changed middle click
	  paste.

2010-05-28  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Margin.cs:
	* Mono.TextEditor/InsertionCursorEditMode.cs: Worked on
	  insertion cursor edit mode.

2010-05-28  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Caret.cs:
	* Mono.TextEditor/TextViewMargin.cs: Fixed 'Bug 609188 -
	  Middle-click paste jumps to source location'.

2010-05-27  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Theatrics/SmartScrolledWindow.cs: Provided
	  intptr constructor.

2010-05-27  Mike Krüger  <mkrueger@novell.com>

	* Makefile.am:
	* Mono.TextEditor.csproj:
	* Mono.TextEditor/Margin.cs:
	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/MarginDrawer.cs:
	* Mono.TextEditor/DashedLineMargin.cs:
	* Mono.TextEditor/InsertionCursorEditMode.cs: Worked on
	  insertion cursor edit mode.

2010-05-27  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Theatrics/SmartScrolledWindow.cs: Destroy
	  smart scrolled window children.

2010-05-27  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Corrected text coordinate
	  translation.

2010-05-27  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs:
	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/LineSegmentTree.cs: Correctly remove line
	  markers when the line gets removed.

2010-05-27  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor/ClipboardActions.cs: fixed 'Bug 609188 -
	  Middle-click paste jumps to source location'/improved middle
	  click paste behavior.-

2010-05-26  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Theatrics/BounceFadePopupWindow.cs: Fix some
	  properties and calculations.

2010-05-26  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Theatrics/BounceFadePopupWindow.cs: Added
	  some properties to control behaviour.

2010-05-26  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Theatrics/BounceFadePopupWindow.cs: Fix some
	  opacity calculations.

2010-05-26  Michael Hutchinson  <mhutchinson@novell.com>

	* Makefile.am:
	* Mono.TextEditor.csproj:
	* Mono.TextEditor.Theatrics/BounceFadePopupWindow.cs: New
	  class extracted from MessageBubbleHighlightPopupWindow.
	  Tooltip containing an image that "bounces" in size then
	  fades away.

2010-05-26  Mike Krüger  <mkrueger@novell.com>

	* Styles/IrBlackStyle.xml: Fixed 'Bug 608974 - [regression]
	  IrBlack color scheme badly highlights warnings and errors'.

2010-05-26  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextMarker.cs:
	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor/TextLinkEditMode.cs: text markers can now
	  override the selection drawing.

2010-05-25  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/CodeSegmentPreviewWindow.cs: Removed debug
	  code.

2010-05-25  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/GutterMargin.cs:
	* Mono.TextEditor/FoldMarkerMargin.cs: Fixed gutter drawing
	  bug/made change marker smaller.

2010-05-25  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: Ensure that the lineheight is
	  up to date in the optionschanged event chain.

2010-05-25  Mike Krüger  <mkrueger@novell.com>

	* Styles/OblivionStyle.xml:
	* Styles/TangoLightStyle.xml:
	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/GutterMargin.cs:
	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor/DashedLineMargin.cs:
	* Mono.TextEditor/FoldMarkerMargin.cs:
	* Mono.TextEditor.Highlighting/Style.cs: Worked on text editor
	  outfit.

2010-05-25  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/PangoUtil.cs: Fix calling conventions for
	  gtk/pango on Windows.

2010-05-25  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Theatrics/SmartScrolledWindow.cs: Did some
	  minor changes at smartscrolledwindow.

2010-05-25  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor.Theatrics/SmartScrolledWindow.cs: Worked on
	  scrolled window replacement.

2010-05-25  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/DocumentLocation.cs: fixed operator.

2010-05-21  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/Platform.cs:
	* Mono.TextEditor/SimpleEditMode.cs:
	* Mono.TextEditor.Vi/ViActionMaps.cs:
	* Mono.TextEditor/TextLinkEditMode.cs: More shift-tab fixage.

2010-05-21  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Corrected rounding of
	  fold rectangles.

2010-05-21  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: Fixed bug in logical line
	  number calculation.

2010-05-21  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Fixed caret placement
	  bug.

2010-05-21  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: Took out event handler on
	  destroy

	* Mono.TextEditor/TextViewMargin.cs: Try to use the weak caret
	  pos instead of the strong one.

2010-05-21  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Speed up the line
	  decorators a bit.

2010-05-21  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Corrected caret drawing
	  position.

2010-05-20  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/Platform.cs: Fix shift-tab brokenness.

2010-05-20  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: potentially fix search
	  maker update.

2010-05-20  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Corrected pixel rounding.

2010-05-20  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Draw lines using pango
	  coordinates instead of pixels (much better fix for #591459).

2010-05-20  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextLinkEditMode.cs: Correctly adjust end
	  offset.

2010-05-20  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs:
	* Mono.TextEditor/TextLinkEditMode.cs: Fixed 'Bug 607154 -
	  Negative column on rename refactoring'.

2010-05-19  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/TextEditor.cs: Fix typo.

	* Mono.TextEditor/Platform.cs: Copy MapRawKeys changes from
	  KeyBindingManager.

2010-05-19  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextMarker.cs:
	* Mono.TextEditor/TextViewMargin.cs: Advanced text markers can
	  now provide tooltips.

2010-05-19  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/HslColor.cs: Now supports cairo color
	  conversion.

2010-05-19  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs:
	* Mono.TextEditor/TextMarker.cs:
	* Mono.TextEditor/TextViewMargin.cs: Added basic support for
	  extending markers.

2010-05-19  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.PopupWindow/TooltipWindow.cs: fixed gtk
	  criticals.

2010-05-18  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor/CodeSegmentPreviewWindow.cs:
	* Mono.TextEditor.PopupWindow/TooltipWindow.cs: Improved multi
	  monitor support.

2010-05-18  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: Fixed 'Bug 604999 -
	  Horizontal scrolling during search is annoying'.

2010-05-17  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Fixed 'Bug 538800 - Tab
	  positions are at wrong offsets'.


2010-05-17  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditorData.cs: Improved type flow on the
	  mac: convert non breaking space -> standard space.

2010-05-17  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: Dispose animations & fixing
	  'Bug 606206 - Null ref in highlighting'.

2010-05-14  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.TextEditor/TextEditor.cs: Improve the tooltip handling
	  code so that it doesn't create so many glib timeouts. 

2010-05-14  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: Fixed 'Bug 604978 - Error
	  bubbles prevent mouse clicking to move cursor'.

2010-05-14  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Fixed 'Bug 605710 - Caret
	  not deleted when clicking out of the text area'.

2010-05-13  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.PopupWindow/ListWidget.cs: Draw on the
	  expose event's Window. Also cache Allocation and GCs to
	  avoid wasteful transitions and allocations.

2010-05-12  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextMarker.cs: made the squiggly lines a bit
	  smaller / fixed cut&paste error.

2010-05-12  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextMarker.cs:
	* Mono.TextEditor.Highlighting/SemanticRule.cs: Use pango
	  function to draw the squiggly lines - should be faster than
	  the custom version.
	(Bug 604983 - Moving the cursor on a line that has red
	  squiggles is slooooooow)

2010-05-12  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Fixed 'Bug 605118 - Caret
	  position is incorrect with folded code'.

2010-05-12  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor/IBackgroundRenderer.cs:
	* Mono.TextEditor/FoldingScreenbackgroundRenderer.cs: Fixed
	  'Bug 604980 – Code bubbles are draw incorrectly when there
	  is a highlighted region of code'.

2010-05-11  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/PangoUtil.cs: Added CreateLayout overload
	  for PrintContext.

2010-05-11  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/TextEditor.cs: Re-use the scrollwindowtimer
	  to avoid creating so many thousands of objects while
	  drag-selecting. 

2010-05-11  Michael Hutchinson  <mhutchinson@novell.com>

	* Makefile.am:
	* Mono.TextEditor.csproj:
	* Mono.TextEditor/PangoUtil.cs:
	* Mono.TextEditor/PangoUtils.cs:
	* Mono.TextEditor/TextViewMargin.cs: Much more efficient
	  setting of Pango attributes.

2010-05-11  Michael Hutchinson  <mhutchinson@novell.com>

	* Makefile.am:
	* Mono.TextEditor.csproj:
	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/PangoUtils.cs:
	* Mono.TextEditor/IconMargin.cs:
	* Mono.TextEditor/GutterMargin.cs:
	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor/FoldMarkerMargin.cs:
	* Mono.TextEditor.PopupWindow/ListWidget.cs:
	* Mono.TextEditor/CodeSegmentPreviewWindow.cs:
	* Mono.TextEditor.PopupWindow/TooltipWindow.cs: More layout
	  leak fixing.

2010-05-11  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Vi/ViMark.cs:
	* Mono.TextEditor.Vi/ViMode.cs:
	* Mono.TextEditor/DefaultEditActions.cs:
	* Mono.TextEditor.Highlighting/Style.cs:
	* Mono.TextEditor.PopupWindow/ListWidget.cs: Fixed some
	  compiler warnings.

2010-05-11  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Optimized text editor
	  selection drawing a bit.

2010-05-10  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/GutterMargin.cs:
	* Mono.TextEditor.PopupWindow/TooltipWindow.cs: Fix more
	  leaks.

2010-05-10  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Fix crasher introduced by
	  disposing attribute too early.

2010-05-10  Michael Hutchinson  <mhutchinson@novell.com>

	* Makefile.am:
	* Mono.TextEditor.csproj:
	* Mono.TextEditor.dll.config:
	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/PangoUtils.cs:
	* Mono.TextEditor/TextViewMargin.cs: Work around massive
	  memory leak in Gtk.Widget.CreatePangoLayout.

2010-05-10  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/TextEditorOptions.cs: Store the zoom
	  internally as a power, so that steps are always consistent.

2010-05-10  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Fixed little search
	  highlighting display bug.

2010-05-10  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditorOptions.cs: Fixed 'Bug 604052 -
	  View->Normal Size sensitivity is inconsistent'.

2010-05-10  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/ITooltipProvider.cs:
	* Mono.TextEditor/TextLinkEditMode.cs: Implemented 'Bug 603988
	  - Symbol tooltips do not hide when mouse moves away from
	  symbol'.

2010-05-10  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Fixed 'Bug 603982 - Fold
	  tooltips flash up briefly on mouseover'.

2010-05-10  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor/TextEditorData.cs: Fixed 'Bug 603971 -
	  Symbol highlight combined with search highlight looks ugly'.

2010-05-10  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor.Highlighting/Style.cs: Fixed 'Bug 603971 -
	  Symbol highlight combined with search highlight looks ugly'.

2010-05-08  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/TextEditor.cs: Tune search result animation.
	  Restore double buffering accidentally disabled in earlier
	  commit.

2010-05-07  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Highlighting/DefaultStyle.cs: Tone down the
	  current line marker a bit.

2010-05-07  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/TextEditor.cs: Remove the backbuffer hack.

2010-05-07  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Highlighting/Style.cs: Make the default
	  colour definitions a lot easier to read by adding some
	  overloads and constants.

2010-05-07  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Highlighting/ChunkStyle.cs: Added methods
	  for creating Gdk GCs.

	* Mono.TextEditor/CodeSegmentPreviewWindow.cs: Use GCs with
	  the background set when rendering text. Fixes Mac rendering
	  issues.

2010-05-07  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor/TextEditorContainer.cs: Fixed mac drawing
	  bug & added v/hscroll events in the text editor widget.

2010-05-07  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/IAnimationDrawer.cs: Speed up the animation
	  process.

2010-05-06  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextViewMargin.cs: Use CreatePangoLayout
	  insead of new PangoLayout (PangoContext).

2010-05-06  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/TextEditor.cs: Disable back buffer hack as
	  it's very slow on Mac, which is where we used it.

2010-05-06  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/TextEditor.cs: Added an alternative expose
	  buffering system to hack around GTK 2.20 issues on Mac.

2010-05-06  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextEditorData.cs: Check the IsVisible flag
	  for margins.

2010-05-06  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Fixed 'Bug 603274 - Caret
	  is moved to incorrect position when typing'.

2010-05-06  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/EditMode.cs: Fixed editor bug.

2010-05-06  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.TextEditor.csproj: Disable overflow checks.

2010-05-06  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: Removed adjustment update on
	  scroll to caret.

2010-05-06  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: Fixed 'Bug 603110 - Margin
	  doesn't redraw after damaged'.

2010-05-06  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: Fixed 'Bug 603117 -
	  Drag-selection is slow on large file'.

2010-05-06  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/ISearchEngine.cs:
	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor/TextEditorData.cs: Optimized search
	  highlighting updates.

2010-05-06  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Track GTK mouse modifier
	  changes on Mac. Now block selection could be cmd or control,
	  depending on GTK version.

2010-05-06  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/TextEditor.cs: Fix cmd-scroll zoom on Mac.
	  Use more conventional direction for zooming.

2010-05-05  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/TextEditor.cs: Add some (disabled) debug
	  code.

2010-05-05  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: Made scrolling faster.

2010-05-05  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/FoldMarkerMargin.cs: fixed little issue with
	  toggle code focus command.

2010-05-05  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/FoldMarkerMargin.cs:
	* Mono.TextEditor/DocumentUpdateRequest.cs: Fixed 'Bug 602615
	  - Editor responds very slowly to quick mousewheel
	  scrolling'.

2010-05-04  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.TextEditor/TextEditorContainer.cs: Don't create a text
	  editor unless required. Unsubscribe adjustment events when
	  the container is destroyed. All this fixes some memory
	  leaks.

2010-05-03  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.PopupWindow/TooltipWindow.cs: Dispose
	  Pango.Layout.

2010-05-03  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Dispose pango attributes.

2010-05-03  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditorData.cs: Don't create empty
	  gtk.adjustments on every text editor data creation.

2010-05-03  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/DashedLineMargin.cs: release resources in
	  dashed line margin.

2010-05-03  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditorData.cs: Cleanly unregister from
	  document & caret on dispose.

2010-04-30  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: Fixed 'Bug 601184 -
	  Flickering tooltips'.

2010-04-30  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs:
	* Mono.TextEditor/DefaultEditActions.cs: Fixed 'Bug 601189 –
	  Deindent on selection loses last line'.

2010-04-29  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs: Fixed 'Bug 600671 - Text
	  painting gets into a weird state'.

2010-04-29  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: Fixed 'Bug 600609 - Parameter
	  tooltips should hide when scrolling editor'.

2010-04-29  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Fixed mac caret drawing
	  bug.

2010-04-28  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: fixed 'Bug 599633 -
	  Convert to block selection includes unexpected line'.

2010-04-28  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: fixed block mode update.

2010-04-27  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/TextEditor.cs: Tweak search animation.
	  Disable RedrawOnAllocate because we do it anyway.

2010-04-26  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs: Addad Tag property.

2010-04-22  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: Fixed 'Bug 598203 - Tooltip
	  shows too fast, follows mouse, and flickers'.

2010-04-22  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/EditMode.cs:
	* Mono.TextEditor/ClipboardActions.cs:
	* Mono.TextEditor/TextLinkEditMode.cs: Optimized text link
	  mode & fixed a mac issue.

2010-04-21  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor/CodeSegmentEditorWindow.cs:
	* Mono.TextEditor/CodeSegmentPreviewWindow.cs: Fixed 'Bug
	  597670 - Focussed fold tooltip has too many lines'.

2010-04-21  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/CodeSegmentPreviewWindow.cs: Fixed 'Bug
	  597668 - Focus message obscures text in small fold
	  tooltips'.

2010-04-21  Mike Krüger  <mkrueger@novell.com>

	* Styles/OblivionStyle.xml:
	* Styles/TangoLightStyle.xml: Fixed 'Bug 597662 - Symbol
	  highlight makes caret hard to see'.

2010-04-21  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditorContainer.cs: Fixed
	  'SetChidrenPositions'

2010-04-20  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/LineSegment.cs: fixed GetIndentation.

2010-04-16  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: handled rare x11 exception.

2010-04-16  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs: Optimized error bubbles.

2010-04-16  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditorData.cs: Handled possible null
	  ref.

2010-04-15  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: Fixed 'Bug 596511 - Code
	  completion removes block selection and only affects 1 line'

2010-04-15  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor/ClipboardActions.cs: Fixed some block
	  selection mode issues.

2010-04-12  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextLinkEditMode.cs: Worked on text link
	  mode.

2010-04-12  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs: Added GetLineIndent method to
	  document.

2010-04-09  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextEditorContainer.cs: Fixed 'Bug 594836 -
	  Performance degradation in the text editor'.

2010-04-08  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.TextEditor/TextEditor.cs: When losing focus, don't hide
	  the tooltip if it is getting the new focus.

2010-04-07  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/GutterMargin.cs: Fixed 'Bug 571338 -
	  multiline selection in monodevelop blows monkeys'.

2010-04-07  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Added work around for
	  'Bug 591459 - Visual glitches when highlighting text'.

2010-03-23  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/SimpleEditMode.cs: Fixed shortcut key bug.

2010-03-19  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Check for invalid column
	  positions.

2010-03-18  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/JaySyntaxMode.cs: Fixed
	  ms-build problem 'Bug 589118 – JaySyntaxMode.xml resource
	  name problem => initializer exception'

2010-03-16  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: For block select, use
	  Command modifier on Mac and Super modifier on Linux, because
	  we can't access the Alt modifier from mouse events on either
	  platform.

2010-03-16  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: fixed 'Bug 588454 - Abysmal
	  performance of the text editor over VNC'.

2010-03-15  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/TextEditor.cs: Use command-scroll instead of
	  control-scroll on Mac, because control-scroll is used by the
	  window manager.

2010-03-12  Mike Krüger  <mkrueger@novell.com>

	* Makefile.am:
	* Mono.TextEditor.csproj:
	* Mono.TextEditor/PieceTable.cs: Implemented experimental
	  piece table IBuffer implementation.

2010-03-12  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs: Removed wait update.

2010-03-11  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs:
	* Mono.TextEditor/TextEditor.cs: Fixed some error bubble
	  calculating issues.

2010-03-09  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/SyntaxMode.cs: Fixed failing
	  unit tests.

2010-03-09  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/JaySyntaxMode.cs: Improved jay
	  syntax mode.

2010-03-08  Mike Krüger  <mkrueger@novell.com>

	* Makefile.am:
	* Mono.TextEditor.csproj:
	* SyntaxModes/JaySyntaxMode.xml:
	* Mono.TextEditor.Highlighting/SyntaxMode.cs:
	* Mono.TextEditor.Highlighting/JaySyntaxMode.cs:
	* Mono.TextEditor.Highlighting/SyntaxModeService.cs: Added jay
	  syntax mode (needed 'semantic' highlighting engine for
	  this).

2010-03-08  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.TextEditor.csproj: Make it a real 3.5 project.

2010-03-05  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs: Added some insanity checks.

2010-03-05  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/LineSegment.cs: Added bounds check.

2010-03-03  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextViewMargin.cs: Fixed 'Bug 584884 - Find
	  markers render over line numbers'.

2010-03-02  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs: Worked on 'Bug 584479 -
	  Exception while undoing'.

2010-03-02  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/SyntaxModeService.cs: added
	  some debug code.

2010-03-01  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs: Finishing old parser thread
	  before starting a new one.

2010-03-01  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/GutterMargin.cs: Fixed 'Bug 571337 - if a
	  section of code is collapsed in monodevelop, when you select
	  and copy, it only gets the top line'.

2010-02-26  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextMarker.cs:
	* Mono.TextEditor.Highlighting/SemanticRule.cs: Re-activated
	  url marker.

2010-02-26  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Fixed 'Bug 583459 - When
	  the fold marker very wide, preview shows offscrre'.

2010-02-26  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor.Highlighting/SyntaxMode.cs:
	* Mono.TextEditor/CodeSegmentEditorWindow.cs:
	* Mono.TextEditor/CodeSegmentPreviewWindow.cs: Fixed 'Bug
	  583461 - Fold preview scrolling is strange'.


2010-02-25  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/ISearchEngine.cs:
	* Mono.TextEditor/TextEditorData.cs:
	* Mono.TextEditor.Highlighting/SyntaxMode.cs:
	* Mono.TextEditor.Highlighting.Regex/Regex.cs: Fixed text
	  editor unit tests.

2010-02-24  Mike Krüger  <mkrueger@novell.com>

	* Styles/OblivionStyle.xml: changed color style

2010-02-24  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: fixed hideselection bug.

2010-02-24  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Highlighting/WorkerThread.cs: Actually write
	  exceptions to console.

2010-02-23  Sanjoy Das   <sanjoy@playingwithpointers.com>

	* MonoDevelop.SourceEditor2/MonoDevelop.SourceEditor/IdeViMode.cs:
	* Mono.Texteditor/Mono.TextEditor.Vi/ViMode.cs:
	* Mono.Texteditor/Mono.TextEditor.Vi/ViMacro.cs: Macro support for Vi 
	  mode.

2010-02-23  Sanjoy Das   <sanjoy@playingwithpointers.com>

	* Mono.Texteditor/Mono.TextEditor.Vi/ViMode.cs:
	* Mono.Texteditor/Mono.TextEditor.Vi/ViMark.cs: Added support 
	  for marks in Vi mode.

2010-02-23  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/Span.cs: made span property
	  setter public.

2010-02-23  Mike Krüger  <mkrueger@novell.com>

	* Styles/OblivionStyle.xml: changed oblivion color.

2010-02-22  Mike Krüger  <mkrueger@novell.com>

	* Makefile.am:
	* Mono.TextEditor.csproj:
	* Mono.TextEditor.Theatrics/AnimatedBox.cs:
	* Mono.TextEditor.Theatrics/AnimatedVBox.cs:
	* Mono.TextEditor.Theatrics/AnimatedWidget.cs: Added animated
	  box.

2010-02-22  Mike Krüger  <mkrueger@novell.com>

	* Styles/OblivionStyle.xml: changed main search result color
	  in oblivion.

2010-02-22  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs: Added helper function.

2010-02-19  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Worked on search &
	  replace.

2010-02-18  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: fix caret problem.

2010-02-18  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: Only request caret blink on
	  caret move when the text editor has the focus.

2010-02-18  Mike Krüger  <mkrueger@novell.com>

	* Styles/TangoLightStyle.xml:
	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor/TextEditorData.cs:
	* Mono.TextEditor.Highlighting/Style.cs: Worked on search &
	  replace.

2010-02-18  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/SyntaxMode.cs: fixed null ref.

2010-02-18  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/SyntaxMode.cs: fixed possible
	  null reference.

2010-02-18  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/TextEditor.cs: Remove debug code.

2010-02-18  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/TextEditor.cs: Enable pixbuf animation
	  scaling on Mac since it seem to work now the drawable is a
	  pixmap.

2010-02-18  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: worked on search result
	  animation.

2010-02-18  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/TextEditor.cs: Tweak search result animation
	  a bit. Use pixbuf scaling instead of re-rendering text
	  larger - avoid jarring from snapping. Disabled on Mac
	  because drawable-to-pixmap rendering broken there.

2010-02-17  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.TextEditor.csproj: Fix file format issue.

2010-02-17  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/ClipboardActions.cs: Fixed 'Bug 580395 -
	  Exception when deleting several lines in a C# file'.

2010-02-17  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor.Highlighting/SyntaxMode.cs:
	* Mono.TextEditor/FoldingScreenbackgroundRenderer.cs: Worked
	  on new search result animation.

2010-02-16  Michael Hutchinson  <mhutchinson@novell.com>

	* Makefile.am:
	* Mono.TextEditor.csproj:
	* Styles/IrBlackStyle.xml: Added IR Black style from Anirudh
	  Sanjeev.

2010-02-16  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Theatrics/AnimatedWidget.cs: Quick hack to
	  make less ugly on Mac, because Mac GTK doesn't yet support
	  offscreen drawing.

2010-02-16  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Fixed search update bug.

2010-02-16  Lluis Sanchez Gual  <lluis@novell.com>

	* gtk-gui/generated.cs: Flush.

	* SyntaxModes/ILSyntaxMode.xml:
	* SyntaxModes/CPPSyntaxMode.xml:
	* SyntaxModes/LuaSyntaxMode.xml:
	* SyntaxModes/PythonSyntaxMode.xml: Added some missing
	  properties.

2010-02-16  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: made search results
	  public.

2010-02-15  Mike Krüger  <mkrueger@novell.com>

	* Makefile.am:
	* Mono.TextEditor.csproj:
	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextEditorContainer.cs: Moved text editor
	  container to own class.

2010-02-12  Mike Krüger  <mkrueger@novell.com>

	* Makefile.am:
	* Mono.TextEditor.csproj:
	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/IAnimation.cs:
	* Mono.TextEditor/IAnimationDrawer.cs:
	* Mono.TextEditor.Theatrics/Animation.cs: now using the
	  theatrics framework for animations (text editor now supports
	  multiple animations as well).

2010-02-12  Mike Krüger  <mkrueger@novell.com>

	* Makefile.am:
	* Mono.TextEditor.csproj:
	* Mono.TextEditor.Theatrics:
	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor.Theatrics/Actor.cs:
	* Mono.TextEditor.Theatrics/Stage.cs:
	* Mono.TextEditor.Theatrics/Pulsator.cs:
	* Mono.TextEditor.Theatrics/Choreographer.cs:
	* Mono.TextEditor.Theatrics/AnimatedWidget.cs:
	* Mono.TextEditor.Theatrics/SingleActorStage.cs: Added banshee
	  Theatrics framework & text editor can now contain animated
	  widgets.

2010-02-10  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: re-implemented int ptr
	  constructor

2010-02-10  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: fixed
	  'https://bugzilla.novell.com/show_bug.cgi?id=577848'.

2010-02-10  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: Now creating an own gdk
	  window - no longer using the Gtk.EventBox 'hack'/should fix
	  'Bug 577848 - MissingIntPtrCtorException appears randomly'.

2010-02-07  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: added intprt constructor.

2010-02-04  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: Added some changes for
	  container childs.

2010-02-04  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: some refactorings.

2010-02-02  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditorData.cs: Added OpenStream method.

2010-01-28  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Added hovered line
	  events.

2010-01-26  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/ITooltipProvider.cs:
	* Mono.TextEditor/TextLinkEditMode.cs: Some API changes
	  required for pin watches.

2010-01-22  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: Fixed extending text line
	  markers update bug.

2010-01-19  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/CodeSegmentPreviewWindow.cs: Hide inform
	  string during dnd.

2010-01-19  Mike Krüger  <mkrueger@novell.com>

	* Makefile.am:
	* Mono.TextEditor.csproj:
	* Mono.TextEditor/EditMode.cs:
	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor/SimpleEditMode.cs:
	* Mono.TextEditor/CodeSegmentEditorWindow.cs:
	* Mono.TextEditor/CodeSegmentPreviewWindow.cs: Implemented
	  'Bug 433318 - Allow scrolling the text boxes that appear
	  when hovering over a folded region'.

2010-01-18  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/EditMode.cs:
	* Mono.TextEditor/Selection.cs:
	* Mono.TextEditor/DeleteActions.cs:
	* Mono.TextEditor/TextEditorData.cs:
	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor/CodeSegmentPreviewWindow.cs: Implemented
	  'Bug 571367 - Block selection should allow change/replace
	  test by'.

2010-01-18  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditorOptions.cs: Fixed mousewheel zoom
	  bug.

2010-01-18  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: added font null check.

2010-01-14  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/SyntaxModeService.cs: Use a
	  manualresetevent instead of an active wait.

2010-01-13  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs:
	* Mono.TextEditor/TextEditor.cs: Worked on 'Bug 570164 - Click
	  positioning on wrapped message bubble is wrong'.

2010-01-13  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/DefaultEditActions.cs: Added move
	  blockup/down actions.

2010-01-13  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs:
	* Mono.TextEditor.Highlighting/SyntaxModeService.cs: Wait for
	  parser service update before document changing.

2010-01-11  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/EditMode.cs:
	* Mono.TextEditor/Platform.cs:
	* Mono.TextEditor/SimpleEditMode.cs: Kill a few more trivial
	  GTK 2.12 FIXMEs.

2010-01-08  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextMarker.cs:
	* Mono.TextEditor/TextViewMargin.cs: Worked on collapsible
	  error bubbles.

2010-01-08  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: added missing property.

2010-01-08  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: ruler divider line is now
	  drawn in background.

2010-01-07  Michael Hutchinson  <mhutchinson@novell.com>

	* SyntaxModes/CSyntaxMode.xml:
	* SyntaxModes/CPPSyntaxMode.xml: Use the C++ syntax mode for
	  highlighting .h files, since they're often C++. Fixes "Bug
	  468416 - *.h aren't colorized as c++ headers".

2010-01-07  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/TextEditor.cs: Fix some GTK 2.12 FIXMEs.

2010-01-07  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: VRuler now draws
	  correctly with multiple line text markers.

2010-01-06  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: fixed hruler drawing bug.

2010-01-06  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting.Regex/Regex.cs: fixed 'Bug
	  568483 - IndexOutOfRangeException in CSharpSyntaxMode'.

2010-01-06  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting.Regex/Regex.cs: fixed 'Bug
	  568483 - IndexOutOfRangeException in CSharpSyntaxMode'.

2010-01-05  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs:
	* Mono.TextEditor/LineSplitter.cs: Remove lines with extending
	  markers, when the line is removed.

2010-01-05  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Fixed 'Bug 567317 -
	  Underscores not always visible in text editor when usign
	  specific fonts, like Courier New'.

2010-01-04  Mike Krüger  <mkrueger@novell.com>

	* SyntaxModes/CSyntaxMode.xml:
	* SyntaxModes/CPPSyntaxMode.xml: Fixed 'Bug 564387 - #if 0
	  grayed out until #endif'.

2010-01-04  Mike Krüger  <mkrueger@novell.com>

	* SyntaxModes/CSharpSyntaxMode.xml: fixed 'Bug 564378 - Inline
	  comments in c# with ///< screw up code coloring'.

2010-01-04  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs: fixed 'Bug 560510 -
	  Preprocessor enabled code shows as comment anyway'.

2010-01-04  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor.Highlighting/SyntaxModeService.cs: Fixed
	  'Bug 560510 - Preprocessor enabled code shows as comment
	  anyway'.

2009-12-12  Levi Bard  <taktaktaktaktaktaktaktaktaktak@gmail.com>

	* Mono.TextEditor/TextViewMargin.cs: Make bracket matching
	  more selective for cursor types that enclose a character.
	  Fixes #562289.

2009-12-11  Levi Bard  <taktaktaktaktaktaktaktaktaktak@gmail.com>

	* Mono.TextEditor.Vi/ViMode.cs:
	* Mono.TextEditor.Vi/ViActions.cs:
	* Mono.TextEditor.Vi/ViActionMaps.cs: Make line-end behavior
	  more consistent with vim. Fixes #562299.

2009-12-11  Levi Bard  <taktaktaktaktaktaktaktaktaktak@gmail.com>

	* Mono.TextEditor.Vi/ViMode.cs: Select the highlighted
	  character by default when entering visual mode. Fixes
	  #562304.

2009-12-11  Levi Bard  <taktaktaktaktaktaktaktaktaktak@gmail.com>

	* Mono.TextEditor.Vi/ViMode.cs: Make inline paste behave more
	  like vim. Fixes #562294.

2009-12-08  Levi Bard  <taktaktaktaktaktaktaktaktaktak@gmail.com>

	* Mono.TextEditor.Vi/ViMode.cs: Add Ctrl-[ as a workalike for
	  Esc, Ctrl-C.

2009-12-02  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Highlighting/SyntaxModeService.cs: Name
	  threads to make debugging easier.

2009-12-02  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: Fixed 'Bug 559805 - X
	  selection not set, middle-click paste broken'.

2009-12-02  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/TextEditor.cs: Do a Repaint instead of
	  QueueDraw in OptionsChanged. We're no longer always setting
	  the style, so the widget doesn't get invalidated
	  accidentally any more, so we have to force it to make sure
	  it's all updated.

2009-12-02  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Highlighting/DefaultStyle.cs: Don't attach
	  to a widget, because that leaked easily. Instead, override
	  the new UpdateFromGtkStyleMethod.

	* Mono.TextEditor.Highlighting/Style.cs: New
	  UpdateFromGtkStyleMethod from styles that want to derive
	  their colours from the current widget's GTK style.

	* Mono.TextEditor.Highlighting/SyntaxModeService.cs: Only use
	  the style, not the whole widget.

	* Mono.TextEditor/TextEditorOptions.cs:
	* Mono.TextEditor/ITextEditorOptions.cs: Track API.

	* Mono.TextEditor/TextEditor.cs: Track API, and update the
	  syntax style when the GTK style changes.

2009-12-02  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/TextEditor.cs: On an options change event,
	  only update the style object if the style ID changed. Fixes
	  excessive creation of default style objects that attached
	  themselves to the widget's style event and leaked badly.
	  There's still a leak when it actually changes, but no longer
	  when every/any MD pref changes. Also avoid refreshing all
	  the options on a GTK style change; just update the widget
	  bg.

2009-12-02  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/TextEditorOptions.cs: Only emit change
	  events when values actually change - make change events
	  consistent for all properties. Only emit a single change
	  event for a CopyFrom instead of once per property.

2009-11-26  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs:
	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor.PopupWindow/TooltipWindow.cs:
	  LogicalToVisualLine now works when logical line is beyond
	  the last line/fixed some compiler warnings.

2009-11-25  Mike Krüger  <mkrueger@novell.com>

	* Styles/TangoLightStyle.xml:
	* Mono.TextEditor/Document.cs: Made error bubbles lighter for
	  tango colors.

2009-11-24  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/BookmarkActions.cs: Applied patch from Tyson
	  S. Maxwell <tyson.maxwell@gmail.com> fixing Bug 557637 -
	  Bookmarked line 1 is not selected when going to the next
	  bookmark.

2009-11-24  Mike Krüger  <mkrueger@novell.com>

	* Styles/OblivionStyle.xml:
	* Mono.TextEditor/Margin.cs:
	* Styles/TangoLightStyle.xml:
	* Mono.TextEditor/Document.cs:
	* Mono.TextEditor/IconMargin.cs:
	* Mono.TextEditor/TextMarker.cs:
	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/GutterMargin.cs:
	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor/FoldMarkerMargin.cs:
	* Mono.TextEditor/DashedLineMargin.cs:
	* Mono.TextEditor.Highlighting/Style.cs: Worked on error
	  bubbles.

2009-11-23  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Highlighting/Style.cs: Added new styles.

2009-11-20  Levi Bard  <taktaktaktaktaktaktaktaktaktak@gmail.com>

	* Mono.TextEditor.Vi/ViMode.cs: Support delete key in command
	  mode.

2009-11-19  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/FoldMarkerMargin.cs: Implemented 'Code focus
	  toggle and follow-cursor'.

2009-11-18  Lluis Sanchez Gual  <lluis@novell.com>

	* Makefile.am: Use system mono.cairo.

2009-11-18  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/FoldMarkerMargin.cs: Fixed a bug where the
	  fold marker margin draws out of bounds.

2009-11-13  Mike Krüger  <mkrueger@novell.com>

	* SyntaxModes/CSharpSyntaxMode.xml: Added let 'keyword'.

2009-11-10  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.PopupWindow/TooltipWindow.cs: Track bugfixes
	  and changes from MonoDevelop.Components.

	* Mono.TextEditor/DashedLineMargin.cs: Tweak some naming.

2009-11-10  Rodrigo B. de Oliveira <rbo@acm.org>

	* SyntaxModes/BooSyntaxMode.xml: updated to the latest boo syntax and fixed triple quoted string highlighting.

2009-11-10  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: Fixed horziontal scrolling
	  bug.

2009-11-06  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs: Fixed 'Bug 553089 - Some text
	  editor lines are not rendered'.

2009-11-06  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/SyntaxModeService.cs: Handled
	  possible null reference exception.

2009-11-06  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/GapBuffer.cs: Fixed 'Bug 552562 - Crasher in
	  auto-save thread'.

2009-11-05  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: Fixed 'Bug 552778 - Redraw
	  issues when scrolling with mouse wheel'.

2009-11-05  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: Only render the lines once in
	  an update - this should fix many of the slowness complaints.

2009-11-05  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: Handled possible endless loop
	  in ScrollToCaret.

2009-11-04  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/GapBuffer.cs: gap buffer is now threadsafe.

2009-11-04  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/DashedLineMargin.cs: fixed 'Bug 548035 -
	  Dashed line down left margin is uneven'.

2009-11-02  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Disable pulse on
	  inserting matching brace.

2009-11-02  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/DefaultEditActions.cs: fixed 'Bug 551674 -
	  Tab key doesn't always create correct number of spaces'.

2009-11-01  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/DashedLineMargin.cs: Fix "Bug 548035 -
	  Dashed line down left margin is uneven" by rendering solid
	  background before rendering dashes.

2009-10-29  Lluis Sanchez Gual  <lluis@novell.com>

	* Makefile.am:
	* Mono.TextEditor.csproj: Reference Mono.Cairo package.

	* gtk-gui/generated.cs: Flush.

2009-10-29  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextViewMargin.cs: Fixed 'Bug 550943 -
	  Search highlighting can get out of sync'.

2009-10-22  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/FoldMarkerMargin.cs: Only generate motion
	  events, when the mouse is inside the text area (code focus
	  did sometimes pop up during text editor open without a mouse
	  hover).

2009-10-22  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: Fixed 'Bug 548734 - drag &
	  drop code does not in the correct position'.

2009-10-21  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextEditorOptions.cs:
	* Mono.TextEditor/ITextEditorOptions.cs: Added enable
	  animations option.

2009-10-20  Mike Krüger  <mkrueger@novell.com>

	* Makefile.am:
	* Mono.TextEditor.csproj:
	* SyntaxModes/CssSyntaxMode.xml:
	* Mono.TextEditor.Highlighting/Rule.cs:
	* Mono.TextEditor.Highlighting/SyntaxMode.cs: Fixed 'Bug
	  548235 - Incorrect highlighting of keywords with a hyphen'.

2009-10-16  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextViewMargin.cs: When entering a bracket,
	  pulse the matching bracket. Based on patch from
	  Anirudh Sanjeev <anirudh@anirudhsanjeev.org>.

2009-10-15  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Fixed possible null
	  reference.

2009-10-15  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: set maximum radius.

2009-10-15  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/EditMode.cs:
	* Mono.TextEditor/TextEditor.cs: Fixed 'Bug 547092 - Text
	  editor hides mouse pointer during keyboard shortcuts'.

2009-10-15  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/FoldingScreenbackgroundRenderer.cs: Fixed
	  'Bug 547093 - Code focus misaligned with wrapped method
	  signature'.

2009-10-14  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/TextEditor.cs: Make the animations a bit
	  more noticeable.

2009-10-14  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: taking care of the
	  hadjustment.

2009-10-14  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextViewMargin.cs: Added caret pulse
	  animation.

2009-10-14  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: fixed background drawing
	  bug in conjunction with the current line marker.

2009-10-14  Mike Krüger  <mkrueger@novell.com>

	* Makefile.am:
	* Mono.TextEditor.csproj:
	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/IAnimation.cs: Added IAnimation interface
	  for adding more animation effects.

2009-10-14  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Added caret line
	  highlighting.

2009-10-14  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/SearchRequest.cs:
	* Mono.TextEditor/TextEditorData.cs: Animate search result is
	  now exposed.

2009-10-14  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/FoldMarkerMargin.cs: Improved code focus -
	  see 'Bug 546676 - Usability of code focus'.

	* Mono.TextEditor.Highlighting/SyntaxModeService.cs: Added
	  more descriptive exceptions for loading styles & mode files.

2009-10-13  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Hide selection drawing
	  during code focus.

2009-10-13  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/FoldingScreenbackgroundRenderer.cs: adjusted
	  the colors a bit.

2009-10-13  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/FoldingScreenbackgroundRenderer.cs: Made the
	  fold marker highlighting a bit more obvious.

2009-10-13  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/Rule.cs: Case insensitive
	  languages take fewer memory.

2009-10-13  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextViewMargin.cs: Added animation support.

2009-10-13  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/FoldingScreenbackgroundRenderer.cs: made the
	  folding background marker a lot lighter.

2009-10-13  Mike Krüger  <mkrueger@novell.com>

	* Makefile.am:
	* Mono.TextEditor.csproj:
	* Mono.TextEditor/Margin.cs:
	* Mono.TextEditor/HslColor.cs:
	* Mono.TextEditor/Document.cs:
	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor/BookmarkMarker.cs:
	* Mono.TextEditor/FoldMarkerMargin.cs:
	* Mono.TextEditor/IBackgroundRenderer.cs:
	* Mono.TextEditor/FoldingScreenbackgroundRenderer.cs: Worked
	  on background renderers

2009-10-12  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/BookmarkActions.cs:
	* Mono.TextEditor/CaretMoveActions.cs:
	* Mono.TextEditor/SelectionActions.cs:
	* Mono.TextEditor/ITextEditorOptions.cs:
	* Mono.TextEditor/DefaultEditActions.cs: made some action
	  classes static.

2009-10-11  Mike Krüger  <mkrueger@novell.com>

	* Makefile.am:
	* Mono.TextEditor.csproj:
	* Mono.TextEditor/Caret.cs:
	* Mono.TextEditor/Margin.cs:
	* Mono.TextEditor/Platform.cs:
	* Mono.TextEditor/EditMode.cs:
	* Mono.TextEditor/Document.cs:
	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/IconMargin.cs:
	* Mono.TextEditor/RedBlackTree.cs:
	* Mono.TextEditor/DeleteActions.cs:
	* Mono.TextEditor/LineSegmentTree.cs:
	* Mono.TextEditor/FoldMarkerMargin.cs:
	* Mono.TextEditor/DashedLineMargin.cs: Removed some backing
	  stores. Dashed line is now an own margin.

2009-10-09  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextViewMargin.cs: Secured caret blinking
	  thread.

2009-10-09  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Update bracket
	  highlighting on undo/redo.

2009-10-08  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: removed line update.

2009-10-07  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Fixed document update
	  bug.

2009-10-07  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Compare real spans for
	  the cache - span length is sometimes not enough.

2009-10-06  Levi Bard  <taktaktaktaktaktaktaktaktaktak@gmail.com>

	* Mono.TextEditor/TextEditor.cs: Expose RedrawMarginLines.

2009-10-06  Levi Bard  <taktaktaktaktaktaktaktaktaktak@gmail.com>

	* Mono.TextEditor/TextEditor.cs: Expose RedrawMarginLine.

2009-10-06  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: text editor can now be
	  reparented.

2009-10-05  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Fixed markup syntax mode
	  'link' click.

2009-10-05  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: added repaint when caret line
	  changes.

2009-10-05  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: Render all margings in a
	  line.

2009-10-05  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextViewMargin.cs: Overworked caret
	  blinking/fixed some scrolling redraw issues & optimized
	  margin re-drawing.

2009-10-04  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Only create a bracket
	  search thread when there is a bracket to search.

2009-10-02  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: Scrolling redraw is done in
	  the scroll event again.

2009-10-02  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor/CodeSegmentPreviewWindow.cs: Fixed code
	  segment preview window sizing.

2009-10-02  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/FoldMarkerMargin.cs: Fixed dashed line
	  drawing for the folder marker margin.

2009-10-02  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Margin.cs:
	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextViewMargin.cs: Fixed scrolling update
	  bug. TextMargin clip bounds are now set when they change
	  instead of every redraw.

2009-10-01  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: removed some unnecessary
	  code.

2009-10-01  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/GutterMargin.cs: Fixed gutter forced
	  repaint.

2009-10-01  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/EditMode.cs: Commented out some code that
	  may've caused too much redraw operations.

2009-10-01  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/DefaultStyle.cs:
	* Mono.TextEditor.Highlighting/MarkupSyntaxMode.cs: Better
	  handling of the last null ref exception.

2009-10-01  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/MarkupSyntaxMode.cs: Fixed
	  possible null reference exception.

2009-10-01  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs: fixed indenting.

2009-10-01  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs:
	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor/IBracketMatcher.cs: Threaded the highlight
	  matching bracket algorithm - can be costly for large files.

2009-10-01  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: Fixed center caret
	  hadjustment value.

2009-10-01  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs:
	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextViewMargin.cs: Worked on hscrollbar
	  logic

2009-10-01  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Caret.cs:
	* Mono.TextEditor/Document.cs:
	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/HelperMethods.cs: Fixed 'Bug 543200 - Files
	  with hscrollbar open scrolled one character to the
	  right'/optimized file opening.

2009-09-30  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: Subscripe to the position
	  change event after the first OptionsChanged.

2009-09-29  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs:
	* Mono.TextEditor/TextViewMargin.cs: Optimized folding tree
	  memory usage/fixed caret clip rectangle.

2009-09-29  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor/CaretMoveActions.cs: Fixed page up/down
	  behavior.

2009-09-29  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: Only allow discrete values
	  for HAdjustment/check if hadjustment really changed. (This
	  could fix the hscrollbar flashes.)

2009-09-25  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: fixed eol selection end
	  offset.

2009-09-25  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Corrected
	  whitespacemarker drawing at the edge of selected text.

2009-09-24  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/CodeSegmentPreviewWindow.cs: Fixed 'Bug
	  541585 - Gtk-criticals in code segment preview window'.

2009-09-23  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/SimpleEditMode.cs: Fix
	  InsertNewLinePreserveCaretPosition bindings on Mac.

2009-09-23  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: Fixed 'Bug 541177 - Bottom of
	  text editor not updated'.

2009-09-23  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Vi/ViMode.cs: Shorten overlong line.

2009-09-23  Mike Krüger  <mkrueger@novell.com>

	* Styles/TangoLightStyle.xml: switched green/blue color.

2009-09-23  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Added function to purge
	  the layout cache.

2009-09-23  Mike Krüger  <mkrueger@novell.com>

	* Styles/OblivionStyle.xml:
	* Styles/TangoLightStyle.xml:
	* Styles/VisualStudioStyle.xml:
	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor.Highlighting/Style.cs: Added new
	  highlighting type for semantic highlighting.

2009-09-22  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Handled possible
	  exception.

2009-09-21  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/SimpleEditMode.cs: Add some emacs shortcuts
	  to the Mac for miguel.

2009-09-21  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.TextEditor/TextEditor.cs: Reduce time for showing the
	  tooltip. Closes bug 531209 - Tooltip-delay when inspecting
	  variables is too slow.

2009-09-21  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/FoldActions.cs: Added toggle all folds
	  command.

2009-09-18  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/CodeSegmentPreviewWindow.cs: Reduced the
	  maximum size of the code segment preview.

2009-09-18  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/CodeSegmentPreviewWindow.cs: Code segment
	  preview has now a small inner margin.

2009-09-18  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: tooltip/code preview now hide
	  on scrolling events.

2009-09-18  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor/CodeSegmentPreviewWindow.cs: Code segment
	  preview is no longer fixed size.

2009-09-18  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/CodeSegmentPreviewWindow.cs: Made code
	  segment preview font smaller.

2009-09-18  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: dnd is now atomic.

2009-09-18  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextEditorData.cs: Fixed a dnd bug.

2009-09-18  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextLinkEditMode.cs: Fixed text link update.

2009-09-17  Mike Krüger  <mkrueger@novell.com>

	* Styles/VisualStudioStyle.xml: this/base is no longer bold in
	  vs highlighting.

2009-09-17  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.csproj: Set the target framework to 3.5

2009-09-17  Mike Krüger  <mkrueger@novell.com>

	* Makefile.am:
	* Mono.TextEditor.csproj:
	* Mono.TextEditor/TextRenderer.cs:
	* Mono.TextEditor/TextViewMargin.cs: Fixed 'Bug 539797 - Text
	  editor trying/failing to load strange font'.

2009-09-16  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextViewMargin.cs: Fixed some compiler
	  warnings.

2009-09-16  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditorData.cs: Fixing search request
	  search changed registering.

2009-09-15  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/ClipboardActions.cs: Worked on formatting.

2009-09-15  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextLinkEditMode.cs: Corrected text link
	  mode bug.

2009-09-15  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextLinkEditMode.cs: Worked on text link
	  mode - it's now possible to update the text while in text
	  link mode & fixed some text link bugs.

2009-09-15  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Worked on bug 'Bug 538800
	  - Tab positions are at wrong offsets.'.

2009-09-15  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: using the right tab array
	  for coordinate translation.

2009-09-14  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: Added some isdispose checks.

2009-09-14  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/Chunk.cs: Fixed "Bug 538298 -
	  Exception thrown".

2009-09-14  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditorData.cs: Added method SetSelection
	  for offsets.

2009-09-14  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Caret.cs:
	* Mono.TextEditor/LineSegment.cs:
	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor/TextEditorData.cs:
	* Mono.TextEditor/ClipboardActions.cs: Fixed text selection
	  ruler background color.

2009-09-14  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Fixed "Bug 538060 - text
	  not visible when "Show column ruler" option enabled".

2009-09-14  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditorData.cs:
	* Mono.TextEditor/ClipboardActions.cs: fixed 'Bug 538379 -
	  Situation where CUT over an "box selection" cause a strange
	  final result, see screenshots...'.

2009-09-11  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/ClipboardActions.cs: Fixed "Bug 538197 -
	  Paste of box selection copy, doesn't pastes as a box
	  content, it pastes as flow content, even being box
	  content...".

2009-09-11  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor/TextLinkEditMode.cs: Fixed 'Bug 538186 -
	  Refactoring operations on document while links are active
	  leave strange links'.

2009-09-10  Levi Bard  <taktaktaktaktaktaktaktaktaktak@gmail.com>

	* Mono.TextEditor/SelectionActions.cs: Fix selection in vi
	  mode.

2009-09-10  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextViewMargin.cs: Fixed "Bug 537939 - Text
	  editor doesn't correctly repaint when inline search string
	  changes".

2009-09-09  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Fixed mouse selection
	  issue.

2009-09-08  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Fixed "Bug 537392 - It is
	  hard to see the cursor blinking when it is "over a
	  breakpoint line", hard to see where it is...".

2009-09-08  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor/TextLinkEditMode.cs: Fixed some minor issues
	  in textlink mode.

2009-09-07  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Selection.cs: Added constructor.

2009-09-07  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Caret.cs:
	* Mono.TextEditor/Document.cs:
	* Mono.TextEditor/LineSegment.cs:
	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor/TextEditorData.cs:
	* Mono.TextEditor/ClipboardActions.cs: Overworked coordinate
	  translation. fixed some bugs with folding coordinate
	  translation. Refactored getvisualcolumn helper method.

2009-09-04  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/ISearchEngine.cs: Support case-insensitive
	  search in the regex search.

2009-09-04  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: Fixed memory leak.

2009-09-03  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextViewMargin.cs: Fixed possible memory
	  issue.

2009-09-03  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: Fixed repaint problem.

2009-09-03  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: Implemented update queue -
	  this should solve the speed problems.

2009-09-03  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs:
	* Mono.TextEditor/TextViewMargin.cs: Don't update bracket
	  highlighting in atomic undo.

2009-09-03  Christian Hergert  <chris@dronelabs.com>

	* Mono.TextEditor/TextViewMargin.cs: Make sure that the
	caret is clipped to the visible region of the Gdk.Drawable.
	This fixes a rendering issue on OS X where the cursor could
	be drawn outside of the TextView.

2009-09-03  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/FoldActions.cs:
	* Mono.TextEditor/TextEditorData.cs:
	* Mono.TextEditor/FoldMarkerMargin.cs: Fold actions now re
	  calculate the vertical scrollbar.

2009-09-03  Christian Hergert  <chris@dronelabs.com>

	* Mono.TextEditor/TextEditor.cs: Do not write directly to
	the GdkWindow unless it is currently viewable.  Fixes
	rendering issue on OS X where pieces of multiple views
	render on top of each other.

2009-09-03  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/IconMargin.cs:
	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/GutterMargin.cs: Optimized redrawing.

2009-09-03  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/GutterMargin.cs: Handled some redraw issues.

2009-09-03  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: Removed unneccessary call.

2009-09-02  Christian Hergert  <chris@dronelabs.com>

	* Mono.TextEditor/TextEditor.cs: Track required exposure area
	manually so we always expose a large enough area to cover all
	the pending QueueDrawArea()'s before setting repaint == false.

2009-09-02  Christian Hergert  <chris@dronelabs.com>

	* Mono.TextEditor/TextLinkEditMode.cs: Add IsIdentifier
	  property indicating if the TextLink has restricted input.
	  Space, Control+Tab and Control+Return can be used when the
	  TextLink is not an Identifier.

2009-08-27  Christian Hergert  <chris@dronelabs.com>

	* Mono.TextEditor/TextViewMargin.cs: Be a bit more resilient to
	erroneous exposure regions.

2009-08-27  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Vi/ViWordFindStrategy.cs:
	* Mono.TextEditor.PopupWindow/ListWidget.cs: Fixed compiler
	  warnings.

2009-08-26  Lluis Sanchez Gual  <lluis@novell.com>

	* gtk-gui/gui.stetic: Update gtk# dependency.

2009-08-26  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.TextEditor.csproj: Updated dependencies. We now depend
	  on gtk# 2.12.8, Mono 2.4, and Mono.Addins 0.4.

2009-08-26  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs: Little performance fix.

2009-08-26  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs:
	* Mono.TextEditor/TextMarker.cs:
	* Mono.TextEditor/GutterMargin.cs:
	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor/TextEditorData.cs:
	* Mono.TextEditor/TextLinkEditMode.cs:
	* Mono.TextEditor/DefaultEditActions.cs:
	* Mono.TextEditor.PopupWindow/ListWidget.cs:
	* Mono.TextEditor.Highlighting/SemanticRule.cs: Fixed some
	  performance graveyards - complex text editor operations
	  should be recognizable faster.

2009-08-26  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/ITextEditorOptions.cs: Made it easier to
	  work with the text editor control by allowing that options
	  can be set directly. This doesn't affect monodevelop.

2009-08-25  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/CaretMoveActions.cs: Fixed "Bug 513056 -
	  Left-arrowing with cursor at end of line sometimes does not
	  work for a while".

2009-08-24  Mike Krüger  <mkrueger@novell.com>

	* Makefile.am:
	* Styles/Styles.xsd:
	* Mono.TextEditor.csproj:
	* Mono.TextEditor.Highlighting/SyntaxModeService.cs: Fixed Bug
	  529544 - Source editor should validate styles when adding
	  them & Bug 531014 - Syntax Highlighting: Style sheet file
	  has to be called [something]Style.xml.

2009-08-24  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextViewMargin.cs: Worked on "Bug 533332 -
	  Caret is cometimes painted in wrong location".

2009-08-24  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Caret.cs: fixed "Bug 533295 - Cursor
	  incorrectly positioned when moving up/down".

2009-08-24  Mike Krüger  <mkrueger@novell.com>

	* SyntaxModes/CSyntaxMode.xml:
	* SyntaxModes/ILSyntaxMode.xml:
	* SyntaxModes/LuaSyntaxMode.xml:
	* SyntaxModes/BooSyntaxMode.xml:
	* SyntaxModes/CPPSyntaxMode.xml:
	* SyntaxModes/RubySyntaxMode.xml:
	* SyntaxModes/JavaSyntaxMode.xml:
	* SyntaxModes/ValaSyntaxMode.xml:
	* SyntaxModes/VBNetSyntaxMode.xml:
	* SyntaxModes/CSharpSyntaxMode.xml:
	* SyntaxModes/PythonSyntaxMode.xml:
	* SyntaxModes/MakefileSyntaxMode.xml:
	* SyntaxModes/JavascriptSyntaxMode.xml:
	* Mono.TextEditor.Highlighting/SyntaxMode.cs: Fixed "Bug
	  530511 - Syntax highlighting not escaping strings
	  correctly".

2009-08-19  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Corrected clipping.

2009-08-18  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Revert changes to
	  horizontal clipping, as they caused rendering regressions.
	  Keep vertical clipping changes.

2009-08-18  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Fixed clipping for mac
	  (vwduder).

2009-08-14  Levi Bard  <taktaktaktaktaktaktaktaktaktak@gmail.com>

	* Mono.TextEditor.Vi/ViActionMaps.cs: 
	* Mono.TextEditor.Vi/ViWordFindStrategy.cs: 
	  Add vi-like word-breaking for wWbB.

2009-08-06  Michael Hutchinson  <mhutchinson@novell.com>

	* SyntaxModes/XmlSyntaxMode.xml: Fix BlockCommentEnd value.

2009-08-03  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Worked on coordinate
	  calculation. (Selecting in assembly browser should work now
	  and the new translation function works correct with
	  kerning).

2009-07-31  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Worked on selection
	  drawing/fixed a possible array out of range exception.

2009-07-29  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Caret.cs:
	* Mono.TextEditor/Document.cs:
	* Mono.TextEditor/TextLinkEditMode.cs: Ensure that links in
	  text link mode are never inside folded regions.

2009-07-24  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextLinkEditMode.cs:
	* Mono.TextEditor.PopupWindow/TooltipWindow.cs: Fixed "Bug
	  524871 - Redraw issues in link mode". Fixed some tooltip
	  issues.

2009-07-24  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextMarker.cs:
	* Mono.TextEditor/TextLinkEditMode.cs: Fixed "Bug 524870 - F2
	  rename can be activated multiple times".

	* Mono.TextEditor/Document.cs: Fixed that StackUndoToDepth
	  creates an empty undo opertion (could dirty a document under
	  some circumstances).

2009-07-23  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/TextEditor.cs: Use a method of creating a
	  pixmap for the invisible cursor that doesn't cause a
	  Gdk-Critical on Mac.

2009-07-23  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextLinkEditMode.cs: Fixed "Bug 524313 -
	  Wrong caret position when exiting local rename link mode".

2009-07-23  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextLinkEditMode.cs: Added some null checks.

2009-07-22  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs:
	* Mono.TextEditor/TextLinkEditMode.cs: Text link edits are now
	  atomic.

2009-07-22  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextLinkEditMode.cs: Fixed "Bug 523905 -
	  Inline variable rename unnecessarily dirties document".

2009-07-21  Michael Hutchinson  <mhutchinson@novell.com>

	* Makefile.am:
	* Mono.TextEditor.csproj: Remove unused ref.

2009-07-17  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/ISearchEngine.cs: Fixed search & replace bug
	  that could occur when caret is positinoed in or right after
	  the matched pattern and there is only one match.

2009-07-17  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: Fixed caret center method.

2009-07-16  Mike Krüger  <mkrueger@novell.com>

	* Makefile.am:
	* Mono.TextEditor.csproj: Added removed gtk-dotnet reference.

2009-07-16  Mike Krüger  <mkrueger@novell.com>

	* Makefile.am:
	* Mono.TextEditor.csproj:
	* Mono.TextEditor.Highlighting/Rule.cs: Added ruby syntax
	  highlighting from 

	* SyntaxModes/RubySyntaxMode.xml: Added ruby syntax
	  highlighting from Levi Bard
	  <taktaktaktaktaktaktaktaktaktak@gmail.com>

2009-07-15  Mike Krüger  <mkrueger@novell.com>

	* SyntaxModes/CSharpSyntaxMode.xml: Applied "[PATCH] New
	  keywords for C#3: var, select, etc (including all LINQ
	  keywords)".

2009-07-14  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/Span.cs:
	* Mono.TextEditor.Highlighting/SyntaxModeService.cs: changed
	  some setters to protected.

2009-07-14  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextLinkEditMode.cs: It's no longer needed
	  to provide a list provider for text link edit mode.

2009-07-11  Matt Enright  <awickedshimmy@gmail.com>

	* Mono.TextEditor.Vi/ViMode.cs: Reset insertion cursor.

2009-07-09  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/ClipboardActions.cs: Removed debug message.

2009-07-06  Michael Hutchinson  <mhutchinson@novell.com>

	* Makefile.am: Remove unused dep.

2009-07-06  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting.Regex/Regex.cs: Regex pattern
	  is now accessible.

	* Mono.TextEditor/FoldActions.cs: Added patch "Bug 517487 -
	  [PATCH] Can't unfold in vi mode.".

2009-06-24  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/FoldActions.cs: Fixed "Bug 515825 - Toggle
	  fold does not work if cursor sent to the end of folded
	  line".

2009-06-23  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: Moved paste text event after
	  the selection/caret is set.

2009-06-23  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: dnd now fires a paste text
	  event.

2009-06-19  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor/TextEditorData.cs:
	* Mono.TextEditor/ClipboardActions.cs:
	* Mono.TextEditor.Highlighting/SemanticRule.cs: Worked on code
	  formatting.

2009-06-19  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.TextEditor/TextRenderer.cs: Comment out unused
	  renderers.

2009-06-19  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextViewMargin.cs: Fixed "Bug 514278 –
	  Matched word highlight not removed when closing search bar".

2009-06-19  Mike Krüger  <mkrueger@novell.com>

	* AssemblyInfo.cs: Commented out empty assembly key file
	  attribute (Bug 513981 - Project template causes CS1726
	  errors).

2009-06-18  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/LineSplitter.cs: Fixed possible null
	  reference.

2009-06-18  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Fixed unlikely (but
	  possible) null reference.

2009-06-17  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor.Highlighting/Chunk.cs:
	* Mono.TextEditor.Highlighting/MarkupSyntaxMode.cs: Fixed "Bug
	  513772 - Assembly browser not working in current SVN
	  version?".

2009-06-16  Mike Krüger  <mkrueger@novell.com>

	* SyntaxModes/CPPSyntaxMode.xml:
	* Mono.TextEditor/TextViewMargin.cs: Fixed c++ highlighting.

2009-06-15  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/TextRenderer.cs: Don't use Cairo text
	  renderer on Mac. It crashes a lot.

2009-06-12  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextMarker.cs:
	* Mono.TextEditor/LineSegment.cs:
	* Mono.TextEditor/GutterMargin.cs:
	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor/TextLinkEditMode.cs:
	* Mono.TextEditor.Highlighting/Rule.cs:
	* Mono.TextEditor.Highlighting/Match.cs:
	* Mono.TextEditor.Highlighting/SyntaxMode.cs:
	* Mono.TextEditor.Highlighting/SemanticRule.cs: Overworked
	  rendering backend.

2009-06-10  Levi Bard <taktaktaktaktaktaktaktaktaktak@gmail.com>

	* Mono.TextEditor.Vi/ViMode.cs:
	* Mono.TextEditor.Vi/ViActions.cs:
	* Mono.TextEditor.Vi/ViActionMaps.cs:
	  Make left/right keybindings more consistent with vim.

2009-06-10  Levi Bard <taktaktaktaktaktaktaktaktaktak@gmail.com>

	* Mono.TextEditor/Caret.cs:
	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor.Vi/ViMode.cs:
	  Vi-style visual cursor.

2009-06-09  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.TextEditor.csproj: Fix gtk-dotnet reference.

2009-06-09  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.TextEditor.csproj: Fixed gtk# reference.

2009-06-08  Levi Bard <taktaktaktaktaktaktaktaktaktak@gmail.com>

	* Mono.TextEditor/FoldActions.cs:
	* Mono.TextEditor.Vi/ViMode.cs:
	  Vi-style folding.

2009-06-08  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/CaretMoveActions.cs: Fixed "Bug 510224 -
	  Moving cursor past folded code with arrow keys sometimes
	  unfolds code and sometimes doesn't".

	* Mono.TextEditor.Highlighting/SyntaxModeService.cs: 

2009-06-08  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/GapBuffer.cs: Fixed "Bug 510316 – Pasting in
	  a lot of text at the end of a file causes crash or unhandled
	  exception".

2009-06-04  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/Rule.cs: Removed debug message.

2009-06-04  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: 

2009-06-03  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/Rule.cs: Fixed possible crash
	  for files with wrong encodings.

2009-06-03  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/IBracketMatcher.cs: Fixed "Bug 509350 -
	  Issuing multiple "Join Lines" sometimes causes MD to hang".

2009-06-03  Mike Krüger  <mkrueger@novell.com>

	* Makefile.am:
	* Mono.TextEditor.csproj:
	* SyntaxModes/CSyntaxMode.xml:
	* Mono.TextEditor/Document.cs:
	* SyntaxModes/XmlSyntaxMode.xml:
	* SyntaxModes/JavaSyntaxMode.xml:
	* SyntaxModes/ValaSyntaxMode.xml:
	* SyntaxModes/VBNetSyntaxMode.xml:
	* SyntaxModes/CSharpSyntaxMode.xml:
	* Mono.TextEditor/IBracketMatcher.cs:
	* Mono.TextEditor.Highlighting/Rule.cs: Overworked the bracket
	  matcher. It's now more general & syntax modes now contain
	  some more meta data about the language.

2009-06-02  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs: Fixed "Bug 509022 -
	  Brace-matching gets confused by quote characters within
	  comments".

2009-06-02  Mike Krüger  <mkrueger@novell.com>

	* SyntaxModes/ActionScriptSyntaxMode.xml: Applied patch from
	  Federico Di Gregorio <fog@initd.org> ("Bug 507379 -
	  ActionScript 3.0 syntax highlight")

2009-06-01  Levi Bard <taktaktaktaktaktaktaktaktaktak@gmail.com>

	* Mono.TextEditor/TextEditor.cs: Changes to support annotation 
	  view in VersionControl addin.

2009-05-29  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.TextEditor.csproj: Don't define debug for now. It is
	  causing some issues on windows.

2009-05-28  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Properly initialize the
	  renderer when drawing the overwrite cursor. Fixes bug
	  #507738.

2009-05-26  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.TextEditor/Platform.cs: Avoid throwing some exceptions
	  using preventive checks. Patch by Carlo Kok.

2009-05-26  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.TextEditor\TextViewMargin.cs: More chunk merging fixes.

2009-05-26  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.TextEditor\TextEditor.cs: Fix nullref.

	* Mono.TextEditor\TextViewMargin.cs: Properly compare chunk
	  styles when trying to merge.

2009-05-25  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.TextEditor\TextRenderer.cs: Use the pango renderer on
	  windows, the gdi renderer still has some issues.

	* Mono.TextEditor\Margin.cs: Added BeginRender/EndRender,
	  which are called just before and after renering the lines of
	  text. It can be used to initialize/finalize drawing
	  resources.

	* Mono.TextEditor\FoldMarkerMargin.cs: Use DrawLine instead of
	  DrawPoint to draw the separator line.

	* Mono.TextEditor\TextEditor.cs: Call the new
	  Margin.BeginRender/EndRender methods. Optimized rendering a
	  bit.

	* Mono.TextEditor\TextViewMargin.cs: Some optimizations. Avoid
	  setting the clip area to gcs if it already was set. Don't
	  special case rendering of whitespace if the 'draw space
	  marker' option is not set. Don't draw the background for
	  each text chunk. Instead, draw the default background for
	  the whole line at the beginig, and then only draw the
	  background if it is different from the default.

	* Mono.TextEditor\Platform.cs: Fix windows check.

2009-05-25  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Merge consecutive chunks
	  that have the the same style, so the text for all those
	  chunks can be measured and rendered together.

2009-05-25  Lluis Sanchez Gual  <lluis@novell.com>

	* Makefile.am:
	* Mono.TextEditor.csproj:
	* Mono.TextEditor/TextRenderer.cs:
	* Mono.TextEditor/TextViewMargin.cs: Abstracted the code that
	  renders text into a new TextRenderer class. Created
	  subclasses for Pango, Cairo and Gdi+.

2009-05-14  Levi Bard <taktaktaktaktaktaktaktaktaktak@gmail.com>

	* Mono.TextEditor/TextEditorData.cs: Fix upward highlighting 
	  in vi mode.

2009-05-14  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/SyntaxMode.cs:
	* Mono.TextEditor.Highlighting/SemanticRule.cs: URL semantic
	  rules now work again.

2009-05-14  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs:
	* Mono.TextEditor/TextEditorData.cs: Fixed "Bug 503696 -
	  Clicking on hyperlink in Assembly Browser led to
	  NulReferenceException and crash".

2009-05-13  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/SyntaxMode.cs: Worked on
	  semantic highlighting.

2009-05-12  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextEditorData.cs:
	* Mono.TextEditor.Highlighting/Span.cs:
	* Mono.TextEditor.Highlighting/SyntaxMode.cs:
	* Mono.TextEditor.Highlighting/SyntaxModeService.cs: Worked on
	  semantic highlighting.

2009-05-11  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditorData.cs: Fixed "Bug 501995 - Find
	  and Replace skips first occurrence if 'Find Next' pressed".

2009-05-07  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/Rule.cs:
	* Mono.TextEditor.Highlighting/SyntaxMode.cs:
	* Mono.TextEditor.Highlighting/MarkupSyntaxMode.cs:
	* Mono.TextEditor.Highlighting/SyntaxModeService.cs: Worked on
	  highlighting engine to better support customized
	  highlighting.

2009-05-05  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/SimpleEditMode.cs: Add subword actions for
	  Linux/Windows as well as Mac.

2009-05-05  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/EditMode.cs:
	* Mono.TextEditor/Platform.cs: Fixed build with GTK# 2.8.

2009-04-30  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/EmacsWordFindStrategy.cs: Fix subword
	  behaviour on digits boundaries. Tidy using type alias.

2009-04-30  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/SharpDevelopWordFindStrategy.cs: Make a
	  method private.

	* Mono.TextEditor/EmacsWordFindStrategy.cs: Implement subword
	  splitting (camelCase/PascalCase).

2009-04-30  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/SharpDevelopWordFindStrategy.cs: Implement
	  subword (camelCase/PascalCase) word splitting.

	* Mono.TextEditor/EmacsWordFindStrategy.cs: Track API.

2009-04-30  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs:
	* Mono.TextEditor/TextEditorData.cs:
	* Mono.TextEditor/DefaultEditActions.cs: Improved removing
	  trailing whitespace feature.

2009-04-30  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/CaretMoveActions.cs: Fix Mac Bug 497904 -
	  Cursor position incorrect when moving cursor after
	  selection. Also a minor non-Mac fix for up/down on
	  first/last lines.

2009-04-30  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/SimpleEditMode.cs: Restore select up/down
	  for Mac.

2009-04-29  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/DeleteActions.cs:
	* Mono.TextEditor/SimpleEditMode.cs:
	* Mono.TextEditor/TextEditorData.cs:
	* Mono.TextEditor/CaretMoveActions.cs:
	* Mono.TextEditor/SelectionActions.cs:
	* Mono.TextEditor/IWordFindStrategy.cs:
	* Mono.TextEditor/EmacsWordFindStrategy.cs:
	* Mono.TextEditor/SharpDevelopWordFindStrategy.cs: Add subword
	  move/select commands.

2009-04-29  Michael Hutchinson  <mhutchinson@novell.com>

	* Makefile.am:
	* Mono.TextEditor.csproj: Updated.

	* Mono.TextEditor/TextEditor.cs: Use raw keymapping code from
	  keybinding service so we can extract Meta and Alt modifiers
	  when on Mac. More comprehensive handling of the modifiers
	  that reach the EditMode and that prevent the key being
	  treated as character input.

	* Mono.TextEditor/SimpleEditMode.cs: Add Mac command bindings,
	  used when on Mac.

	* Mono.TextEditor/SelectionActions.cs: Add MoveDownLineEnd and
	  MoveUpLineStart actions for Mac.

	* Mono.TextEditor/Platform.cs: Added platform detection code.

	* Mono.TextEditor/EditMode.cs: Better keycode handling. Allows
	  binding other modifiers than Shift and Control.

	* Mono.TextEditor/CaretMoveActions.cs: Add DownLineEnd and
	  UpLineStart actions for Mac. Made Left/Right behave
	  correctly on Mac when there's a selection.

2009-04-29  Levi Bard <taktaktaktaktaktaktaktaktaktak@gmail.com>

	* Mono.TextEditor.Vi/ViMode.cs: Highlight matches for 
	  vi mode searches.

2009-04-29  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextViewMargin.cs: Fixed an issue I had
	  while enabled compositing in metacity.

2009-04-29  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: Remove scroll timer on
	  dispose.

2009-04-29  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Fixed "Bug 497566 -
	  Mouse-based word selection is a bit weird".

2009-04-28  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/LineSplitter.cs: Return no longer removes
	  bookmarks from lines.

2009-04-28  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/DefaultEditActions.cs: Fixed update issues
	  with indent selection commands.

2009-04-28  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/SyntaxMode.cs: Fixed "Bug
	  498581 - Syntax highlighting engine crashes MD".

2009-04-27  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.TextEditor.csproj: Fix build.

2009-04-27  Mike Krüger  <mkrueger@novell.com>

	* SyntaxModes/ILSyntaxMode.xml:
	* Mono.TextEditor.Highlighting/Rule.cs:
	* Mono.TextEditor.Highlighting/SyntaxMode.cs: Delimiters are
	  now configurable in the syntax mode (IL syntax mode made
	  this required).

2009-04-27  Mike Krüger  <mkrueger@novell.com>

	* Makefile.am: Reverted makefile.

2009-04-27  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/SyntaxMode.cs: reverted to old
	  delimeters.

	* Makefile.am: 

2009-04-27  Mike Krüger  <mkrueger@novell.com>

	* Makefile.am:
	* Mono.TextEditor.csproj:
	* SyntaxModes/ILSyntaxMode.xml:
	* Mono.TextEditor.Highlighting/SyntaxMode.cs: Added IL syntax
	  mode.

2009-04-25  Mike Krüger  <mkrueger@novell.com>

	* Makefile.am:
	* Mono.TextEditor.csproj:
	* SyntaxModes/LuaSyntaxMode.xml: Added lua syntax mode.

2009-04-24  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs:
	* Mono.TextEditor/TextEditor.cs: Fixed "Bug 497118 - Code
	  folding makes debugging annoying".

2009-04-24  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs:
	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/ClipboardActions.cs: Fixed some minor text
	  editor issues.

2009-04-24  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Improved search pattern
	  update.

2009-04-24  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor/SelectionActions.cs: Select All now works
	  correct.

2009-04-24  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditorData.cs: Fixed selected lines
	  property. Several IDE commands used that (ex.
	  comment/uncomment). They should now work correctly again.

2009-04-24  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/SearchRequest.cs: Only fire change event
	  when the value actually changed.

2009-04-24  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextLinkEditMode.cs: Fixed bug in code
	  templates.

2009-04-24  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs:
	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/ISearchEngine.cs:
	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor/TextEditorData.cs: Fixed "Bug 495626 - Regex
	  searches are slow, and CPU usage is high while results are
	  highlighted".

2009-04-23  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/DefaultEditActions.cs: Implement actions for
	  scrolling PageDown and PageUp.

2009-04-23  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/SyntaxMode.cs: Fixed bug in
	  markup highlighter.

2009-04-17  Mike Kestner  <mkestner@novell.com>

	* Mono.TextEditor.csproj: don't require specific
	gtk-sharp version.

2009-04-17  Michael Hutchinson  <mhutchinson@novell.com>

	* gtk-gui/objects.xml: Unused, remove.

2009-04-17  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.csproj: Revert the (presumably accidental)
	  2008->2005 format change, since it broke MSBuild
	  compatibility.

2009-04-17  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Caret.cs: Fixed bug in caret movement.

2009-04-16  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Caret.cs: Respect caret behind eol setting
	  in SetColumn method.

2009-04-16  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor/ClipboardActions.cs: Handled possible
	  cut&paste exceptions.

2009-04-16  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/SyntaxMode.cs: fixed "Bug
	  495263 - when trying to edit an 'unrecognized' xml file, an
	  exception occurs (and sometimes crashes MD) when I try to
	  edit.".

2009-04-16  Mike Krüger  <mkrueger@novell.com>

	* ChangeLog:
	* Mono.TextEditor.Vi/ViMode.cs:
	* Mono.TextEditor/TextEditorData.cs:
	* Mono.TextEditor/SelectionActions.cs: Added vi mode patch
	  from levi bard.

2009-04-15  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/TextEditor.cs: Don't interpret keystrokes as
	  text input when alt, meta or super modifiers are active.

2009-04-15  Levi Bard <taktaktaktaktaktaktaktaktaktak@gmail.com>

	* Mono.TextEditor.Vi/ViMode.cs:
	* Mono.TextEditor/SelectionActions.cs:
	* Mono.TextEditor/TextEditorData.cs: Fix line-visual vi mode.

2009-04-15  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Vi/ViMode.cs:
	* Mono.TextEditor/ClipboardActions.cs: Fixed some issues in
	  vim mode.

2009-04-15  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/Rule.cs:
	* Mono.TextEditor.Highlighting/SyntaxMode.cs: Fixed text
	  editor issues.

2009-04-15  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Selection.cs:
	* Mono.TextEditor.Vi/ViMode.cs:
	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/LineSegment.cs:
	* Mono.TextEditor/GutterMargin.cs:
	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor/TextEditorData.cs:
	* Mono.TextEditor/ClipboardActions.cs:
	* Mono.TextEditor/TextLinkEditMode.cs:
	* Mono.TextEditor/SelectionActions.cs:
	* Mono.TextEditor/DefaultEditActions.cs:
	* Mono.TextEditor.Highlighting/SyntaxMode.cs: Worked on the
	  text editor. Added block selection mode & fixed some bugs.

	* Makefile.am:
	* gtk-gui/objects.xml:
	* Mono.TextEditor.csproj: 

2009-04-14  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/SyntaxMode.cs: removed debug
	  message.

2009-04-14  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/Rule.cs:
	* Mono.TextEditor.Highlighting/SyntaxMode.cs: fixed 'Bug
	  494534 - ignorecase="true" attribute isn't working on xml
	  "Syntax Mode" files.'.

2009-04-13  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/SyntaxMode.cs: fixed little
	  issue with regex match highlighting.

2009-04-09  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/Rule.cs:
	* Mono.TextEditor.Highlighting/SyntaxMode.cs:
	* Mono.TextEditor.Highlighting.Regex/Regex.cs:
	* Mono.TextEditor.Highlighting/SyntaxModeService.cs:
	  Optimized/Refactored the highlighting engine. (Bug 387486 -
	  Syntax scheme improvements).

2009-04-08  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Caret.cs: Virtual spaces now works with
	  up/down keys.

2009-04-08  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Changed the virtual space
	  click behavior.

2009-04-08  Mike Krüger  <mkrueger@novell.com>

	* SyntaxModes/XmlSyntaxMode.xml:
	* Mono.TextEditor.Highlighting.Regex:
	* Mono.TextEditor/ClipboardActions.cs:
	* Mono.TextEditor.Highlighting/Span.cs:
	* Mono.TextEditor.Highlighting/Rule.cs:
	* Mono.TextEditor.Highlighting/Match.cs:
	* Mono.TextEditor.Highlighting/SyntaxMode.cs:
	* Mono.TextEditor.Highlighting.Regex/Regex.cs:
	* Mono.TextEditor.Highlighting.Regex/RegexMatch.cs:
	* Mono.TextEditor.Highlighting/SyntaxModeService.cs:
	  Overworked the syntax highlighting & implemented "Bug 480133
	  - XML highlighting doesn't deal well with incomplete tags".

	* Makefile.am:
	* gtk-gui/objects.xml:
	* Mono.TextEditor.csproj: 

2009-04-08  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: activated virtual leading
	  whitespace click.

2009-04-08  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditorData.cs: Added some virtual
	  leading whitespace fixes.

2009-04-08  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditorData.cs: Added some fixes for
	  virtual leading whitespace feature.

2009-04-07  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextLinkEditMode.cs: Fixed some drawing
	  issues in text link mode (templates).

2009-04-07  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextLinkEditMode.cs: fixed possible out of
	  range exception.

2009-04-07  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextLinkEditMode.cs: Fixed possible null
	  ref.

2009-04-07  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/SimpleEditMode.cs:
	* Mono.TextEditor/DefaultEditActions.cs: Added
	  ctrl+return/shift+return commands.

2009-04-03  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/SyntaxModeService.cs: Fixed
	  small issue in last bugfix.

2009-04-03  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Caret.cs:
	* SyntaxModes/CSyntaxMode.xml:
	* Mono.TextEditor/EditMode.cs:
	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextLinkEditMode.cs:
	* Mono.TextEditor.Highlighting/Span.cs:
	* Mono.TextEditor.Highlighting/Rule.cs:
	* Mono.TextEditor.Highlighting/Style.cs:
	* Mono.TextEditor.Highlighting/Match.cs:
	* Mono.TextEditor.Highlighting/Marker.cs:
	* Mono.TextEditor.Highlighting/Keywords.cs:
	* Mono.TextEditor.PopupWindow/ListWidget.cs:
	* Mono.TextEditor.Highlighting/SyntaxMode.cs:
	* Mono.TextEditor.Highlighting/SyntaxModeService.cs: fixed
	  "Bug 491089 - Oblivion syntax highlight error". Cleaned up
	  some code.

2009-04-02  Mike Krüger  <mkrueger@novell.com>

	* SyntaxModes/VBNetSyntaxMode.xml:
	* Mono.TextEditor.Highlighting/Rule.cs:
	* Mono.TextEditor.Highlighting/Keywords.cs:
	* Mono.TextEditor.Highlighting/SyntaxMode.cs: The ignorecase
	  attribute can now be specified on any level
	  (SyntaxMode/Rule/Keywords). (impl. request Bug 491356 -
	  TextEditor should recognize non-sensitive highlighting
	  mode.)

2009-03-30  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Handeled invalid folding
	  marker.

2009-03-30  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: Fixed 'Bug 489850 - Implement
	  mouse-cursor hide on typing'.

2009-03-27  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: fixed "Bug 489000 -
	  Cursor blinks when another window has focus".

2009-03-23  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: Fixed "Bug 487736 - Clipboard
	  ring and code snippets not shown anymore in the toolbox".

2009-03-23  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/ClipboardActions.cs: Fixed "Bug 487422 -
	  Ctrl+C/V/X should copy/paste/cut the whole line if no
	  selection is made like in VS".

2009-03-22  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextLinkEditMode.cs: Handled possible
	  exception.

2009-03-22  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextLinkEditMode.cs:
	* Mono.TextEditor.PopupWindow/ListWindow.cs:
	* Mono.TextEditor.PopupWindow/ListWidget.cs:
	* Mono.TextEditor.PopupWindow/TooltipWindow.cs:
	* Mono.TextEditor.PopupWindow/IListDataProvider.cs: Cleaned up
	  some source.

2009-03-22  Mike Krüger  <mkrueger@novell.com>

	* Makefile.am:
	* Mono.TextEditor.csproj: 

	* Mono.TextEditor/TextLinkEditMode.cs:
	* Mono.TextEditor.PopupWindow/ListWindow.cs:
	* Mono.TextEditor.PopupWindow/ListWidget.cs:
	* Mono.TextEditor.PopupWindow/IListDataProvider.cs: Fixed
	  headers.

2009-03-22  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextLinkEditMode.cs:
	* Mono.TextEditor.PopupWindow/ListWindow.cs:
	* Mono.TextEditor.PopupWindow/IListDataProvider.cs: Used
	  template data provider.

2009-03-22  Mike Krüger  <mkrueger@novell.com>

	* Makefile.am:
	* Mono.TextEditor.csproj: 

	* Mono.TextEditor/TextLinkEditMode.cs:
	* Mono.TextEditor.PopupWindow/ListWindow.cs:
	* Mono.TextEditor.PopupWindow/IListDataProvider.cs: Changed
	  list provider interface.

2009-03-22  Mike Krüger  <mkrueger@novell.com>

	* Styles/BrownStyle.xml:
	* Styles/OblivionStyle.xml:
	* Styles/TangoLightStyle.xml: Updated template colors (but I'm
	  up for color suggestions).

	* Mono.TextEditor/TextLinkEditMode.cs: Fixed some minor issues
	  in text link mode.

2009-03-22  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextLinkEditMode.cs:
	* Mono.TextEditor.PopupWindow/ListWindow.cs: Added icons to
	  the template completion list.

2009-03-22  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextLinkEditMode.cs: Worked on templates.

2009-03-21  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextLinkEditMode.cs: Worked on template
	  callbacks.

2009-03-21  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextLinkEditMode.cs: Worked on multi item
	  callback.

2009-03-21  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextLinkEditMode.cs:
	* Mono.TextEditor.PopupWindow/ListWindow.cs: Worked on text
	  link mode.

2009-03-21  Mike Krüger  <mkrueger@novell.com>

	* Makefile.am:
	* Styles/C64Style.xml:
	* Styles/BrownStyle.xml:
	* Mono.TextEditor.csproj:
	* Styles/OblivionStyle.xml:
	* Mono.TextEditor/Caret.cs:
	* Mono.TextEditor/Margin.cs:
	* Styles/TangoLightStyle.xml:
	* Styles/VisualStudioStyle.xml:
	* Mono.TextEditor/TextMarker.cs:
	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor/TextLinkEditMode.cs:
	* Mono.TextEditor.Highlighting/Style.cs:
	* Mono.TextEditor.PopupWindow/ListWindow.cs: Worked on text
	  link editor mode.

2009-03-21  Mike Krüger  <mkrueger@novell.com>

	* Makefile.am:
	* gtk-gui/objects.xml:
	* Mono.TextEditor.csproj:
	* Mono.TextEditor.PopupWindow:
	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextLinkEditMode.cs:
	* Mono.TextEditor.PopupWindow/TooltipWindow.cs: Text links now
	  show tooltips. Set the tooltip popup hotkey to Ctrl+F1.

2009-03-20  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextLinkEditMode.cs: Implemented function
	  callbacks.

2009-03-20  Mike Krüger  <mkrueger@novell.com>

	* Styles/C64Style.xml:
	* Styles/BrownStyle.xml:
	* Styles/OblivionStyle.xml:
	* Styles/TangoLightStyle.xml:
	* Styles/VisualStudioStyle.xml:
	* Mono.TextEditor/TextMarker.cs:
	* Mono.TextEditor/LineSegment.cs:
	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor/TextLinkEditMode.cs:
	* Mono.TextEditor.Highlighting/Style.cs: Worked on text link
	  edit mode.

2009-03-13  Levi Bard <taktaktaktaktaktaktaktaktaktak@gmail.com>

	* Mono.TextEditor.Vi/ViMode.cs: Clear selection when pasting.

2009-03-13  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs: ComitUpdateAll after text set.

2009-03-13  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs: fire commit update on text
	  replace.

2009-03-11  Levi Bard <taktaktaktaktaktaktaktaktaktak@gmail.com>

	* Mono.TextEditor.Vi/ViMode.cs: Fix visual mode anchoring,
	  return to normal mode when entire command buffer deleted.

2009-03-11  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/SemanticRule.cs: applied '
	  [PATCH] Collapsed comment areas cause editor to throw
	  unhandled exception'.

2009-03-09  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Highlighting/IXmlProvider.cs:
	* Mono.TextEditor.Highlighting/SyntaxModeService.cs: Fix
	  resource disposal issues that prevented addins adding syntax
	  modes and colour schemes, and probably caused resource
	  stream leaks.

2009-03-08  Mike Krüger  <mkrueger@novell.com>

	* Styles/OblivionStyle.xml: fixed "Bug 482804 - Highlight
	  current line doesnt work in Oblivion theme".

2009-03-05  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Fixed "Bug 476015 -
	  general crash _wapi_handle_unref: Attempting to unref unused
	  handle 0x496".

2009-03-05  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: Removed debug messages.

2009-03-05  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: fixed "Bug 482120 - Selection
	  isn't repainted correctly when it's reduced
	  programmatically".

2009-03-04  Mike Krüger  <mkrueger@novell.com>

	* Makefile.am:
	* Mono.TextEditor.csproj:
	* SyntaxModes/CSharpSyntaxMode.xml:
	* SyntaxModes/MakefileSyntaxMode.xml: Added makefile syntax
	  mode.

2009-03-04  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/GapBuffer.cs: Corrected insignificant
	  algortihm glitch in gap buffer.

2009-03-04  Mike Krüger  <mkrueger@novell.com>

	* Makefile.am: fixed makefile.

2009-03-03  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: fixed "Bug 480308 - Editor
	  not scrolling horizontally".

2009-03-03  Mike Krüger  <mkrueger@novell.com>

	* Styles/TangoLightStyle.xml: Changed diff header style for
	  tango light.

2009-03-03  Mike Krüger  <mkrueger@novell.com>

	* Makefile.am:
	* Mono.TextEditor.csproj:
	* Styles/OblivionStyle.xml:
	* Styles/TangoLightStyle.xml:
	* SyntaxModes/DiffSyntaxMode.xml:
	* Mono.TextEditor.Highlighting/Span.cs:
	* Mono.TextEditor.Highlighting/Style.cs:
	* Mono.TextEditor.Highlighting/SyntaxMode.cs: Added diff file
	  syntax mode.

2009-03-02  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: Worked on horizontal
	  scrolling behavior.

2009-03-02  Mike Krüger  <mkrueger@novell.com>

	* Styles/OblivionStyle.xml: fixed "Bug 480800 - please
	  highlight //TODO items as gedit does in oblivion style"

2009-02-26  Michael Hutchinson  <mhutchinson@novell.com>

	* SyntaxModes/ValaSyntaxMode.xml:
	* SyntaxModes/PythonSyntaxMode.xml:
	* Mono.TextEditor.Highlighting/Span.cs: Remove unused
	  constraint attribute.

	* SyntaxModes/AspNetSyntaxMode.xml: Better highlighting for
	  comments and cdata.

	* SyntaxModes/XmlSyntaxMode.xml: Better highlighting for
	  cdata.

2009-02-26  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.TextEditor.csproj: Flush.

2009-02-25  Mike Krüger  <mkrueger@novell.com>

	* Styles/C64Style.xml: Fixed description.

2009-02-24  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor.Highlighting/SyntaxMode.cs: Optimized pango
	  output a bit.

2009-02-24  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/Match.cs: fixed C# number
	  matching.

2009-02-24  Mike Krüger  <mkrueger@novell.com>

	* SyntaxModes/CSharpSyntaxMode.xml: Added highlighting for
	  undocumented keywords.

2009-02-22  Mike Krüger  <mkrueger@novell.com>

	* SyntaxModes/CSyntaxMode.xml:
	* SyntaxModes/BooSyntaxMode.xml:
	* SyntaxModes/JavaSyntaxMode.xml:
	* SyntaxModes/ValaSyntaxMode.xml:
	* SyntaxModes/VBNetSyntaxMode.xml:
	* SyntaxModes/PythonSyntaxMode.xml:
	* SyntaxModes/CSharpSyntaxMode.xml:
	* SyntaxModes/JavascriptSyntaxMode.xml: Corrected escape
	  strings.

2009-02-22  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/SyntaxMode.cs:
	* Mono.TextEditor.Highlighting/SyntaxModeService.cs: fixed
	  "Bug 478459 - Syntax highlighting broken with tripple-quote
	  literal strings".

2009-02-20  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/TextEditor.cs: Fix crash on documents with
	  only one line. Also fix scrollable width when the last line
	  is the longest line, e.g. when there is only one line.

2009-02-20  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/ITooltipProvider.cs: Tooltip proviters now
	  get informed about the modifier state.

2009-02-20  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/LinkEventArgs.cs:
	* Mono.TextEditor/TextViewMargin.cs: Link events are now
	  informed about the button and modifier state.

2009-02-20  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: fixed hruler width.

2009-02-20  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: removed debug message.

2009-02-20  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: fixed horizontal adjustment
	  behavior.

2009-02-19  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Fixed a bug where clip
	  rectangles are not set on first draw (text may have been
	  drawn over the line number margin at first draw for
	  example).

2009-02-18  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: removed gtk keyboard snooper.

2009-02-18  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: Used MergeUndoOperations for
	  drag&drop move operation.

	* Mono.TextEditor/Document.cs: Added MergeUndoOperations for
	  another way to merge undo operations.

2009-02-18  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: Only handle the control keys
	  in the snooper func.

2009-02-18  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: fixed key snooper id.

2009-02-18  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextViewMargin.cs: fixed "Bug 445395 -
	  drag/drop text in editor".

2009-02-17  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.csproj: Flush.

	* Mono.TextEditor/TextEditor.cs: Include the key & state in
	  OnIMProcessedKeyPressEvent calls if possible, i.e. if the
	  char matches the unprocessed one, since the IMMultiContext
	  captures a lot of the character keystrokes.

2009-02-17  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/EditMode.cs:
	* Mono.TextEditor/TextEditor.cs: Handle UTF32 code points from
	  IMContext. Don't pass most recent keypress through with
	  IMContext multi-press commits, so that it doesn't append the
	  space/enter that was used to terminate the multi-press
	  input.

2009-02-17  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: enabled the preview editor
	  string.

2009-02-17  Mike Krüger  <mkrueger@novell.com>

	* Makefile.am:
	* Mono.TextEditor.csproj:
	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor/SimpleEditMode.cs:
	* Mono.TextEditor/DefaultEditActions.cs:
	* Mono.TextEditor/UnicodePreviewEditMode.cs: Made the preview
	  string more general (input method now handles it).

2009-02-17  Mike Krüger  <mkrueger@novell.com>

	* Makefile.am:
	* Mono.TextEditor.csproj:
	* Mono.TextEditor/EditMode.cs:
	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/SimpleEditMode.cs:
	* Mono.TextEditor/TextEditorData.cs:
	* Mono.TextEditor/DefaultEditActions.cs:
	* Mono.TextEditor/UnicodePreviewEditMode.cs: Worked on unicode
	  preview (but disabled it).

2009-02-17  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Fixed text editor line
	  marker bug.

2009-02-17  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Changed GetPixel method.

2009-02-17  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/Style.cs: Changed color styles
	  a bit.

2008-02-13  Levi Bard <taktaktaktaktaktaktaktaktaktak@gmail.com>

	* Mono.TextEditor/ISearchEngine.cs: Fix crash on empty search.

2009-02-13  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: Handle system style changes.

2009-02-13  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Fixed drawing issue with
	  current line marker in color styles & syntax modes that
	  define the same bg color than the default one for keywords.

2009-02-12  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/GutterMargin.cs:
	* Mono.TextEditor/TextViewMargin.cs: Dispose Gdk cursors, else
	  finalisers destroy them outside of the GUI thread and often
	  crash MD due to X asserts resulting in _XCBUnlockDisplay
	  errors.

2009-02-12  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Worked on
	  ColumnToVisualX.

2009-02-11  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: fixed "Bug 474600 -
	  Completion window's trigger position is wrong at start and
	  end of line".

2009-02-09  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/IconMargin.cs:
	* Mono.TextEditor/LineSegment.cs:
	* Mono.TextEditor/TextViewMargin.cs: LineSegment.Markers is
	  now always != null. Removing all unneccessary null checks.

2009-02-09  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextMarker.cs: fixed style text marker.

2009-02-07  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.csproj: Don't treat warning as errors,
	  because csc still outputs warnings for this project.

2009-02-07  Michael Hutchinson  <mhutchinson@novell.com>

	* gtk-gui/gui.stetic:
	* Mono.TextEditor.csproj: Fix GTK# version.

2009-02-06  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/Style.cs:
	* Mono.TextEditor.Highlighting/ChunkStyle.cs: fixed "Bug
	  473258 - Current line highlight not correctly drawn".

2009-02-06  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/SyntaxModeService.cs: validate
	  now gives back an result.

2009-02-06  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor.Highlighting/ChunkStyle.cs:
	* Mono.TextEditor.Highlighting/MarkupSyntaxMode.cs: Fixed link
	  feature.

2009-02-06  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.TextEditor.mds:
	* Mono.TextEditor.mdp:
	* Mono.TextEditor.csproj: Migrated to MSBuild file format.

2009-02-05  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Vi/ViMode.cs: Add a hook for subclasses to
	  add insert actions.

2009-02-05  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.mdp: 

	* Mono.TextEditor/Document.cs:
	* Mono.TextEditor/EditMode.cs:
	* Mono.TextEditor.Vi/ViMode.cs:
	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor.Vi/ViActions.cs:
	* Mono.TextEditor/DeleteActions.cs:
	* Mono.TextEditor/ISearchEngine.cs:
	* Mono.TextEditor/TextEditorData.cs:
	* Mono.TextEditor/ClipboardActions.cs:
	* Mono.TextEditor/ReplaceEventArgs.cs:
	* Mono.TextEditor/DefaultEditActions.cs: fixed "Bug 472714 -
	  MonoDevelop automatic indentation does not follow "Convert
	  tabs to spaces" option".

2009-02-04  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Remove debug code.

2009-02-04  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Vi/ViMode.cs: When the selection changes
	  externally and there's no selection, only reset the state if
	  the current state is Visual.

2009-02-04  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Worked on visual ->
	  document translation.

2009-02-03  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Highlighting/Style.cs:
	* Mono.TextEditor.Highlighting/DefaultStyle.cs:
	* Mono.TextEditor.Highlighting/SyntaxModeService.cs:
	  Implement namespace-like fallbacks for colours and chunk
	  styles.

2009-02-03  Lluis Sanchez Gual  <lluis@novell.com>

	* Makefile.am:
	* gtk-gui/objects.xml:
	* Mono.TextEditor.mdp: Updated references.

2009-02-03  Lluis Sanchez Gual  <lluis@novell.com>

	* gtk-gui/generated.cs: Flush.

2009-02-01  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/ClipboardActions.cs: Track
	  TextEditorOptions API.

2009-02-01  Michael Hutchinson  <mhutchinson@novell.com>

	* Makefile.am:
	* Mono.TextEditor.mdp: Updated.

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextEditorData.cs:
	* Mono.TextEditor.Highlighting/SyntaxMode.cs: Use the
	  read-only ITextEditorOptions interface to avoid accidental
	  modification.

	* Mono.TextEditor/TextEditorOptions.cs: Implement
	  ITextEditorOptions. Rename the "Options" instance to
	  "DefaultOptions" and make it read-only.

	* Mono.TextEditor/ITextEditorOptions.cs: Read-only interface
	  ITextEditorOptions extracted from TextEditorOptions.

2009-02-01  Michael Hutchinson  <mhutchinson@novell.com>

	* Makefile.am: Track changes in MD's assembly handling.
	  Mono.Cairo is no longer considered to be a "system"
	  assembly.

2009-01-30  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: implemented ITextEditorDataProvider.

2009-01-30  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/EditMode.cs:
	* Mono.TextEditor/ClipboardActions.cs: Fixed virtual positions.

2009-01-30  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Caret.cs:
	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor/CaretMoveActions.cs: Added click support for caret
	beyond eol.

2009-01-29  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditorData.cs:
	* Mono.TextEditor/CaretMoveActions.cs: Encapsulated virtual space
	management.

2009-01-29  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs: Worked on line changed markers.

2009-01-29  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Caret.cs:
	* Mono.TextEditor/EditMode.cs:
	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor/TextEditorData.cs:
	* Mono.TextEditor/CaretMoveActions.cs:
	* Mono.TextEditor/ClipboardActions.cs: Added support for caret behind
	eol

2009-01-29  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs: worked on line changed markers.

2009-01-28  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs:
	* Mono.TextEditor/LineSplitter.cs: Worked on line changed markers.

2009-01-28  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs: Optimized line changed markers a bit.

2009-01-28  Mike Krüger  <mkrueger@novell.com>

	* gtk-gui/objects.xml:
	* Styles/OblivionStyle.xml:
	* Styles/TangoLightStyle.xml:
	* Mono.TextEditor/Document.cs:
	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor/FoldMarkerMargin.cs:
	* Mono.TextEditor.Highlighting/Style.cs: Added line dirty/changed
	markers.

2009-01-28  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/MarkupSyntaxMode.cs: fixed 'Bug 469928 -
	Text editor in assembly browser hung randomly'.

2009-01-27  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.mdp: treat warnings as errors.

2009-01-27  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs:
	* SyntaxModes/XmlSyntaxMode.xml: fixed "Bug 469628 - XML attribute
	highlighting broken"

2009-01-27  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Remove debug code.

2009-01-26  Michael Hutchinson  <mhutchinson@novell.com>

	* gtk-gui/gui.stetic:
	* Mono.TextEditor.mdp: Flush project format changes.

2009-01-26  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/Rule.cs:
	* Mono.TextEditor.Highlighting/SyntaxMode.cs:
	* Mono.TextEditor.Highlighting/SyntaxModeService.cs: Reduced memory
	consumption of syntax highlighting parser.

2009-01-26  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor/ClipboardActions.cs:
	* Mono.TextEditor.Highlighting/Chunk.cs:
	* Mono.TextEditor.Highlighting/SyntaxMode.cs:
	* Mono.TextEditor.Highlighting/MarkupSyntaxMode.cs: Reduced memory
	footprint. Chunks are now represented as a primitve list instead of
	creating a collection object for each chunk request.

2009-01-26  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: set clip region.

2009-01-26  Mike Krüger  <mkrueger@novell.com>

	* SyntaxModes/CSyntaxMode.xml:
	* SyntaxModes/XmlSyntaxMode.xml:
	* SyntaxModes/JavaSyntaxMode.xml:
	* SyntaxModes/ValaSyntaxMode.xml:
	* SyntaxModes/CSharpSyntaxMode.xml:
	* SyntaxModes/JavascriptSyntaxMode.xml:
	* Mono.TextEditor.Highlighting/Match.cs:
	* Mono.TextEditor.Highlighting/SyntaxMode.cs: Hard coded the number
	regular expression for speed up.

2009-01-26  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs:
	* Mono.TextEditor/LineSegment.cs:
	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor.Highlighting/Rule.cs:
	* Mono.TextEditor.Highlighting/Keywords.cs:
	* Mono.TextEditor.Highlighting/SyntaxMode.cs: Optimized text editor
	speed & reduced memory footprint.

2009-01-24  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor.Highlighting/SyntaxMode.cs: Optimized text editor
	drawing for very large chunks.

2009-01-23  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/ClipboardActions.cs: fixed 'Bug 468808 - Cannot
	copy/paste in files'.

2009-01-21  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextViewMargin.cs: Optimized text editor drawing when
	selection is changed.

2009-01-20  Lluis Sanchez Gual  <lluis@novell.com>

	* Makefile.am:
	* Mono.TextEditor.mdp:
	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/ISearchEngine.cs:
	* Mono.TextEditor/SearchRequest.cs:
	* Mono.TextEditor/TextEditorData.cs: Moved search parameters to a new
	SearchRequest class, this allows creating a search engine independent
	from the one provided by TextEditor.

2009-01-20  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs:
	* Mono.TextEditor/FoldSegment.cs:
	* Mono.TextEditor/FoldMarkerMargin.cs: Folding now uses a tree instead
	of a list (should speed up folding in files with many foldings).

2009-01-16  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs: optimized folding performace.

2009-01-16  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs: fixed possible exception as modifing
	Offset is not always allowed on an unknown segment.

2009-01-16  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs:
	* Mono.TextEditor/DefaultEditActions.cs: fixed "Bug 433777 -
	Auto-expanding is a little aggressive".

2009-01-15  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/WorkerThread.cs: worker threads are now
	using thread pools.

2009-01-15  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Made GetLink method more robust.

2009-01-15  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/MarkupSyntaxMode.cs: Markup syntax mode
	now takes default color from style.

2009-01-14  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Fix NRE on docs without
	highlighting.

2009-01-14  Mike Krüger  <mkrueger@novell.com>

	* Styles/C64Style.xml:
	* Styles/BrownStyle.xml:
	* Styles/OblivionStyle.xml:
	* Styles/TangoLightStyle.xml:
	* Styles/VisualStudioStyle.xml:
	* Mono.TextEditor.Highlighting/Style.cs:
	* Mono.TextEditor.Highlighting/MarkupSyntaxMode.cs: Added link color
	support & markup can now re-use style defined colors

2009-01-14  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/SyntaxMode.cs:
	* Mono.TextEditor.Highlighting/MarkupSyntaxMode.cs: fixed cut & paste
	issue.

2009-01-14  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/LinkEventArgs.cs:
	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor.Highlighting/Span.cs: Added link support.

2009-01-13  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Vi/ViActions.cs: Add a ToggleCase action.

	* Mono.TextEditor.Vi/ViMode.cs: Implement ~, :$, :0. Make u work while
	there's a selection.

2009-01-13  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/ClipboardActions.cs:
	* Mono.TextEditor.Highlighting/SyntaxMode.cs: Worked on copy operation
	with markup syntax mode.

2009-01-08  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.TextEditor/TextEditor.cs: Don't add/remove bookmarks when
	clicking on the icon bar. It will now add/remove breakpoints.

2009-01-07  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: fixed Bug 459732 - Cursor placed in
	the wrong position.

2009-01-06  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/SyntaxMode.cs:
	* Mono.TextEditor.Highlighting/SyntaxModeService.cs: fixed 'Bug 458159 -
	crash when editing javascript'.

2009-01-06  Mike Krüger  <mkrueger@novell.com>

	* SyntaxModes/ChangeLogSyntaxMode.xml:
	* Mono.TextEditor.Highlighting/Span.cs:
	* Mono.TextEditor.Highlighting/SyntaxMode.cs:
	* Mono.TextEditor.Highlighting/SyntaxModeService.cs: fixed "Bug 457677 -
	Changelog syntax highlighting gets broken when an extra asterisk is
	found".

2008-12-19  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.TextEditor/TextEditorOptions.cs: Cache the font description once
	created.

	* gtk-gui/objects.xml: Updated.

2008-12-18  Lluis Sanchez Gual  <lluis@novell.com>

	* Mono.TextEditor/DocumentLocation.cs: Fix build for recent mcs
	versions.

2008-12-15  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Vi/ViMode.cs: Fix some actions that're made up of
	sub-actions so that they take place in one atomic undo instead of
	multiple undos. Tweaks to make auto-visual mode work better with
	undo/redo.

	* Mono.TextEditor/EditMode.cs: Add utility method for executing two
	actions in one atomic undo.

2008-12-15  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/TextEditorData.cs: The selectionRange field should be
	set to null when the selection's length is 0. Makes
	IsSomethingSelected work correctly.

2008-12-12  Lluis Sanchez Gual  <lluis@novell.com>

	* Makefile.am:
	* Mono.TextEditor.mdp: Remove duplicate ref.

2008-12-12  Lluis Sanchez Gual  <lluis@novell.com>

	* Makefile.am:
	* Mono.TextEditor.mdp: All projects now require fx 3.5.

2008-12-08  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Vi/ViMode.cs: Implement J, M.

	* Mono.TextEditor.Vi/ViActions.cs: Add a Join action.

2008-12-08  Michael Hutchinson  <mhutchinson@novell.com>

	* gtk-gui/objects.xml: Updated.

	* Mono.TextEditor.Vi/ViMode.cs: When selection is changed independently
	of the vi edit mode, switch into visual mode automatically.

	* Mono.TextEditor/EditMode.cs:
	* Mono.TextEditor/TextEditor.cs: Pass selection change events through to
	the edit mode.

2008-12-05  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Vi/ViMode.cs: Implement H, L.

2008-11-27  Grzegorz Sobański  <silk@boktor.net>

	* Mono.TextEditor.Vi/ViMode.cs: Implement gg.

2008-12-05  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Vi/ViMode.cs: Implement Y, based on patch by Grzegorz
	Sobański. Closes Bug 449293 - [PATCH] ViMode - implement Y. Also fix
	NREs when pasting an empty clipboard.

2008-12-04  Lluis Sanchez Gual  <lluis@novell.com>

	* Makefile.am: Make it work for parallel build.

2008-12-02  Levi Bard <taktaktaktaktaktaktaktaktaktak@gmail.com>

	* Mono.TextEditor.Vi/ViMode.cs: Match vim's post-replace caret positioning.

2008-11-26  Levi Bard <taktaktaktaktaktaktaktaktaktak@gmail.com>

	* Mono.TextEditor.Vi/ViMode.cs: Match vim's post-yank caret positioning.

2008-11-26  Grzegorz Sobański  <silk@boktor.net>

	* Mono.TextEditor.Vi/ViActionMaps.cs: handle Insert key in insert 
	  and replace mode.

2008-11-26  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor.Highlighting/ChunkStyle.cs:
	* Mono.TextEditor.Highlighting/MarkupSyntaxMode.cs: Worked on markup
	syntax mode.

2008-11-26  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/GutterMargin.cs: taken out line change command handler
	in gutter margin.

2008-11-25  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/TextMarker.cs: Fix end location of underline marker.

2008-11-25  Levi Bard <taktaktaktaktaktaktaktaktaktak@gmail.com>

	* Mono.TextEditor.Vi/ViMode.cs: Implement sS.

2008-11-24  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor.Highlighting/SyntaxMode.cs:
	* Mono.TextEditor.Highlighting/SyntaxModeService.cs: fixed 'Bug 448006 -
	MD crashes while editing XML files'.

2008-11-24  Mike Krüger  <mkrueger@novell.com>

	* SyntaxModes/CSharpSyntaxMode.xml:
	* Mono.TextEditor.Highlighting/Span.cs:
	* Mono.TextEditor.Highlighting/SyntaxMode.cs:
	* Mono.TextEditor.Highlighting/SyntaxModeService.cs: fixed 'Bug 447547 -
	Error occurred when highlighting multiline strings(@"")'.

2008-11-21  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: fixed off by 1 error.

2008-11-21  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor.Highlighting/MarkupSyntaxMode.cs: Worked on markup
	syntax mode.

2008-11-21  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextMarker.cs:
	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor.Highlighting/MarkupSyntaxMode.cs: Added support for
	underlining highlighting styles.

2008-11-20  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Highlighting/ChunkStyle.cs: Remove Console.WriteLine.

2008-11-20  Mike Krüger  <mkrueger@novell.com>

	* Makefile.am:
	* Mono.TextEditor.mdp:
	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor.Highlighting/Chunk.cs:
	* Mono.TextEditor.Highlighting/SyntaxMode.cs:
	* Mono.TextEditor.Highlighting/ChunkStyle.cs:
	* Mono.TextEditor.Highlighting/MarkupSyntaxMode.cs: Worked on markup
	syntax mode.

2008-11-19  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/ClipboardActions.cs: Add missing '!'. Fixes pasting.

2008-11-19  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor/ClipboardActions.cs: Used CanEdit instead of readonly

2008-11-19  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor/ClipboardActions.cs: Recognizing readonly property for
	cut&paste operations.

2008-11-18  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/TextMarker.cs: Add properties to UnderlineMarker to
	limit it to part of a line.

2008-11-17  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/TextMarker.cs: Make underline marker use named
	colours. Fix some spelling.

	* Mono.TextEditor.Highlighting/Style.cs: Define colour names for error
	and warning underlines.

2008-11-11  Levi Bard <taktaktaktaktaktaktaktaktaktak@gmail.com>

	* Mono.TextEditor.Vi/ViMode.cs: Implement y.

2008-11-10  Levi Bard <taktaktaktaktaktaktaktaktaktak@gmail.com>

	* Mono.TextEditor.Vi/ViActionMaps.cs: Allow Page(Up|Down).

2008-11-10  Levi Bard <taktaktaktaktaktaktaktaktaktak@gmail.com>

	* Mono.TextEditor.Vi/ViMode.cs: Allow backspace for search/ex.

2008-11-10  Mike Krüger  <mike@icsharpcode.net>

	* Mono.TextEditor/ClipboardActions.cs: fixed possible null reference
	exception.

2008-11-07  Levi Bard <taktaktaktaktaktaktaktaktaktak@gmail.com>

	* Mono.TextEditor.Vi/ViMode.cs: Implement p P.

2008-11-07  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/TextEditor.cs: Add helper for generating menu for
	selecting input method.

2008-11-06  Michael Hutchinson  <mhutchinson@novell.com>

	* Makefile.am: Fix build dependencies.

2008-11-06  Mike Krüger  <mike@icsharpcode.net>

	* Mono.TextEditor.Highlighting/SyntaxMode.cs: Fixed 'Bug 442110 - Syntax
	highlighting parser problem with escaped backslash'.

2008-11-05  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Vi/ViMode.cs: Made the "I" command open insert mode
	before the first non-whitespace character on the line, not the line
	start. Fixes "Bug 438177 - [vi] 'I' behavior inconsistent with vi".

2008-11-05  Mike Krüger  <mike@icsharpcode.net>

	* Mono.TextEditor/Margin.cs:
	* Mono.TextEditor/IBuffer.cs:
	* Mono.TextEditor/Segment.cs:
	* Mono.TextEditor/Document.cs:
	* Mono.TextEditor/EditMode.cs:
	* Mono.TextEditor/GapBuffer.cs:
	* Mono.TextEditor.Vi/ViMode.cs:
	* Mono.TextEditor/TextEditor.cs:
	* Mono.TextEditor/IconMargin.cs:
	* Mono.TextEditor/FoldSegment.cs:
	* Mono.TextEditor/SearchResult.cs:
	* Mono.TextEditor/RedBlackTree.cs:
	* Mono.TextEditor/LineSplitter.cs:
	* Mono.TextEditor/GutterMargin.cs:
	* Mono.TextEditor/HelperMethods.cs:
	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor/TextEditorData.cs:
	* Mono.TextEditor/BookmarkActions.cs:
	* Mono.TextEditor/LineSegmentTree.cs:
	* Mono.TextEditor/ClipboardActions.cs:
	* Mono.TextEditor/CaretMoveActions.cs:
	* Mono.TextEditor/FoldMarkerMargin.cs:
	* Mono.TextEditor/ReplaceEventArgs.cs:
	* Mono.TextEditor/DocumentLocation.cs:
	* Mono.TextEditor/CodeSegmentPreviewWindow.cs: Done some minor cosmetic
	changes. Fixed all warning messages.

2008-11-05  Mike Krüger  <mike@icsharpcode.net>

	* Mono.TextEditor/TextEditor.cs: fixed 'Bug 437049 - Horizontal keyboard
	scrolling sometimes does not work'.

2008-11-04  Mike Krüger  <mike@icsharpcode.net>

	* Mono.TextEditor.Highlighting/SyntaxMode.cs: added bounds checking for
	'Bug 429905 - Tooltip folded region preview can crash MD'.

2008-10-31  Full Name  <Email Address>

	* Mono.TextEditor/Document.cs: fixed 'Bug 433729 - Copy/Paste/Folding
	the top comment of a file, you get a wrong display.'.

2008-10-27  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs:
	* Mono.TextEditor.Highlighting/ChunkStyle.cs: fixed 'Bug 438946 – Editor
	does not respect Bold font setting for font'.

2008-10-24  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Caret.cs:
	* Mono.TextEditor/DeleteActions.cs: fixed 'Bug 438696 - Error in text
	editor extension chain.'.

2008-10-24  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/TextViewMargin.cs: Fixed caret drawing when scrolling
	horizontally.

2008-10-21  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs: fixed 'Bug 437110 - NRE when switching to
	another file'.

2008-10-20  Levi Bard <taktaktaktaktaktaktaktaktaktak@gmail.com>

	* Mono.TextEditor.Vi/ViMode.cs: Implement / ? n N.

2008-10-20  Levi Bard <taktaktaktaktaktaktaktaktaktak@gmail.com>

	* Mono.TextEditor/SelectionActions.cs,
	  Mono.TextEditor/SelectionActions.cs: Implement V.

2008-10-19  Mike Krüger  <mkrueger@novell.com>

	* SyntaxModes/AspNetSyntaxMode.xml: applied patch from 'Bug 436777 -
	Missing syntax highlighting / code completion for ASP.NET master
	pages'.

2008-10-15  Levi Bard <taktaktaktaktaktaktaktaktaktak@gmail.com>

	* Mono.TextEditor.Vi/ViMode.cs: Allow ex commands to apply to visual mode,
	add :s command.

2008-10-14  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/DeleteActions.cs: Add DeleteSelection.

	* Mono.TextEditor.Vi/ViMode.cs: Implement >{motion}, <{motion}, >>, <<
	for normal mode, and and c d > < for visual mode.

2008-10-13  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor.Vi/ViMode.cs: Implement A I c C x X D.

2008-10-13  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Document.cs: fixed 'Bug 434248 - Need to refresh
	texteditor after removing folded code'.

2008-10-12  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/TextEditor.cs: Don't use vi mode on default
	constructor.

	* Makefile.am:
	* Mono.TextEditor.mdp: Updated.

	* Mono.TextEditor.Vi/ViMode.cs:
	* Mono.TextEditor.Vi/ViActions.cs:
	* Mono.TextEditor.Vi/ViActionMaps.cs: Move vi code to new namespace.
	Move action lookup out of the way. Implement 'o' and 'O', and
	:{number}. Unbreak 'c' key and ':' commands by removing overzealous
	modifier check.

	* Mono.TextEditor/ViMode.cs:
	* Mono.TextEditor/ViActions.cs: Moved.

2008-10-11  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/ViActions.cs: Fix { } behaviour.

2008-10-11  Michael Hutchinson  <mhutchinson@novell.com>

	* Makefile.am:
	* Mono.TextEditor.mdp: Updated.

	* Mono.TextEditor/ViMode.cs:
	* Mono.TextEditor/ViActions.cs: Implemented { and }.

2008-10-11  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/ViMode.cs:
	* Mono.TextEditor/DeleteActions.cs: Implemented 'dd' and 'd{motion}' for
	simple motions.

2008-10-11  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/ViMode.cs: Refactor the dictionaries into switches to
	reduce overhead (also more readable for character commands). Split
	cursor and character navigation keys so that cursor keys can work in
	insert mode.

	* Mono.TextEditor/SelectionActions.cs: Add method for converting a
	movement action to a selection action.

2008-10-10  Michael Hutchinson  <mhutchinson@novell.com>

	* Mono.TextEditor/ViMode.cs: Add support for simple vi commands.

2008-10-10  Christian Hergert  <chris@dronelabs.com>

	* SyntaxModes/PythonSyntaxMode.xml: Python does not support multiline
	comments.
	* SyntaxModes/CSyntaxMode.xml: Add NULL as a literal keyword.

2008-10-10  Mike Krüger  <mkrueger@novell.com>

	* Mono.TextEditor/Caret.cs:
	* Mono.TextEditor/CaretMoveActions.cs:
	* Mono.TextEditor/FoldMarkerMargin.cs: fixed 'Bug 434165 - Page UP/Down
	Key on top/bottom of a code folded make the region Unfolded'.

2008-10-08  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditorData.cs: fixed 'Bug 432845 - Find and
	  replace doesn't work'.

2008-10-07  Michael Hutchinson <mhutchinson@novell.com> 

	* Mono.TextEditor.mdp, Makefile.am: Updated.
	* Mono.TextEditor/BookmarkActions.cs,
	  Mono.TextEditor/CaretMoveActions.cs,
	  Mono.TextEditor/ClipboardActions.cs,
	  Mono.TextEditor/DefaultEditActions.cs,
	  Mono.TextEditor/DeleteActions.cs, Mono.TextEditor/EditAction.cs,
	  Mono.TextEditor/EditMode.cs, Mono.TextEditor/SelectionActions.cs,
	  Mono.TextEditor/SimpleEditMode.cs, Mono.TextEditor/TextEditor.cs,
	  Mono.TextEditor/TextViewMargin.cs, Mono.TextEditor/ViMode.cs:
	  Switch to a delegate-based API so we aren't always newing up
	  objects in order to perform actions. Allows actions to be invoked
	  more easily, and tidies up API. Group actions logically in static
	  classes.

2008-10-07  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditorData.cs: fixed 'Bug 430805 - Cannot
	  middle-click-paste between source editors'.

2008-10-06  Gabriel Burt <gburt@novell.com> 

	* Mono.TextEditor/ViMode.cs: Added keybindings for ctrl-d and ctrl-u
	  (pg dn/up), % (go to matching bracket), and G (go to eof), and fix
	  keybinding for _ to go to first non-whitespace char instead of
	  start of line

2008-10-06  Michael Hutchinson <mhutchinson@novell.com> 

	* Mono.TextEditor/ViMode.cs, Mono.TextEditor/TextEditor.cs,
	  Mono.TextEditor/EditMode.cs: Add a way for the EditMode to pre-empt
	  the IM handling. This prevents the keystroke from reaching the
	  editor extension chain, hence preventing code completion from
	  triggering. Prevents accidental triggering of completion in vi
	  navigation.

2008-10-06  Michael Hutchinson <mhutchinson@novell.com> 

	* Mono.TextEditor/ViMode.cs: Implement 'u' for undo.

2008-10-06  Michael Hutchinson <mhutchinson@novell.com> 

	* Mono.TextEditor/ViMode.cs: Implement a simple vi-like editing mode.
	* Mono.TextEditor/TextEditor.cs, Mono.TextEditor/SimpleEditMode.cs,
	  Mono.TextEditor/EditMode.cs: Abstract out the editing into a mode
	  object.
	* Mono.TextEditor/DefaultEditActions.cs: Add soem new actions for
	  jumping to zero/home.
	* Mono.TextEditor.mdp, Makefile.am: Updated.

2008-10-06  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditorData.cs,
	  Mono.TextEditor/TextEditorOptions.cs: text editor options are now
	  disposable.

2008-09-30  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/SharpDevelopWordFindStrategy.cs,
	  Mono.TextEditor/Document.cs, Mono.TextEditor/TextEditorData.cs,
	  Mono.TextEditor/TextEditorOptions.cs,
	  Mono.TextEditor/DefaultEditActions.cs,
	  Mono.TextEditor/EmacsWordFindStrategy.cs,
	  Mono.TextEditor.Highlighting/SyntaxModeService.cs: Refactorey word
	  strategy (moved to text editor options/added '_' treatment switch).

2008-09-29  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/SharpDevelopWordFindStrategy.cs,
	  Mono.TextEditor/Document.cs, Mono.TextEditor/IWordFindStrategy.cs,
	  Mono.TextEditor/EmacsWordFindStrategy.cs: Added emacs/sharpdevelop
	  find word strategies.

2008-09-29  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs: fixed 'Bug 430512 - Editor
	  forcefully reformats my code incorrectly'.

2008-09-25  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs, Mono.TextEditor/TextViewMargin.cs:
	  fixed 'Bug 424443 - Many cursors shown when pressing the Down key
	  for a while'.

2008-09-25  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/Document.cs: fixed 'Bug 429738 - Middle-click paste
	  past end of row pastes in next line'.

2008-09-25  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditorData.cs, Mono.TextEditor.Tests,
	  Mono.TextEditor.Tests/Mono.TextEditor.Tests.mdp,
	  Mono.TextEditor.Tests/Mono.TextEditor.Tests,
	  Mono.TextEditor.Tests/Mono.TextEditor.Tests/DocumentTests.cs,
	  Mono.TextEditor.Tests/Mono.TextEditor.Tests/LineSplitterTests.cs,
	  Mono.TextEditor.Tests/Mono.TextEditor.Tests/UndoRedoTests.cs,
	  Mono.TextEditor.Tests/Mono.TextEditor.Tests/SearchTests.cs,
	  Mono.TextEditor.Tests/Mono.TextEditor.Tests/SelectionTests.cs,
	  Mono.TextEditor.Tests/Mono.TextEditor.Tests.DefaultEditActions,
	  Mono.TextEditor.Tests/Mono.TextEditor.Tests.DefaultEditActions/InsertTabTests.cs,
	  Mono.TextEditor.Tests/Mono.TextEditor.Tests.DefaultEditActions/SelectionSelectAllTests.cs,
	  Mono.TextEditor.Tests/Mono.TextEditor.Tests.DefaultEditActions/RemoveTabTests.cs,
	  Mono.TextEditor.Tests/Mono.TextEditor.Tests.DefaultEditActions/CaretMoveTests.cs,
	  Mono.TextEditor.Tests/Mono.TextEditor.Tests.DefaultEditActions/InsertNewLineTests.cs:
	  Moved text editor unit tests.

2008-09-22  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs: Handled tooltip provider exception, to
	  prevent a text editor crash.

2008-09-17  Lluis Sanchez Gual <lluis@novell.com> 

	* Mono.TextEditor.mdp: Updated projects.

2008-09-17  Lluis Sanchez Gual <lluis@novell.com> 

	* Mono.TextEditor/CodeSegmentPreviewWindow.cs: Fix crash caused by the
	  double buffer flag. Dispose resources on destroy.

2008-09-12  Lluis Sanchez Gual <lluis@novell.com> 

	* gtk-gui/generated.cs, gtk-gui/objects.xml: Updated generated code.

2008-09-08  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs: fixed "Bug 423278 - wrong view when
	  jumping in editor without scrollbar".

2008-08-21  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs: optimized copy/cut.

2008-08-21  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/Document.cs, Mono.TextEditor/LineSegmentTree.cs,
	  Mono.TextEditor/TextEditor.cs, Mono.TextEditor/LineSplitter.cs,
	  Mono.TextEditor.Highlighting/SyntaxModeService.cs: Optimized text
	  editor. Syntax update is now running on a single thread using a
	  queue. Optimized the offset2line number operation.

2008-08-21  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/Document.cs, Mono.TextEditor/TextEditor.cs,
	  Mono.TextEditor/GutterMargin.cs, Mono.TextEditor/TextViewMargin.cs:
	  Worked on gutter width change.

2008-08-21  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor.mdp: set referenced gtk sharp version back to 2.8.
	* Mono.TextEditor/CodeSegmentPreviewWindow.cs: fixed compiler warning.

2008-08-21  Mike Krüger <mkrueger@novell.com> 

	* TangoLightStyle.xml, JavascriptSyntaxMode.xml, Styles,
	  Styles/TangoLightStyle.xml, Styles/OblivionStyle.xml,
	  Styles/BrownStyle.xml, Styles/VisualStudioStyle.xml,
	  Styles/C64Style.xml, VBNetSyntaxMode.xml, BooSyntaxMode.xml,
	  CSharpSyntaxMode.xml, PythonSyntaxMode.xml, JavaSyntaxMode.xml,
	  CPPSyntaxMode.xml, CSyntaxMode.xml, ValaSyntaxMode.xml,
	  OblivionStyle.xml, ChangeLogSyntaxMode.xml, AspNetSyntaxMode.xml,
	  gtk-gui/objects.xml, BrownStyle.xml, XmlSyntaxMode.xml,
	  VisualStudioStyle.xml, C64Style.xml, SyntaxModes,
	  SyntaxModes/JavascriptSyntaxMode.xml,
	  SyntaxModes/ChangeLogSyntaxMode.xml,
	  SyntaxModes/AspNetSyntaxMode.xml, SyntaxModes/VBNetSyntaxMode.xml,
	  SyntaxModes/BooSyntaxMode.xml, SyntaxModes/CSharpSyntaxMode.xml,
	  SyntaxModes/XmlSyntaxMode.xml, SyntaxModes/JavaSyntaxMode.xml,
	  SyntaxModes/PythonSyntaxMode.xml, SyntaxModes/CPPSyntaxMode.xml,
	  SyntaxModes/CSyntaxMode.xml, SyntaxModes/ValaSyntaxMode.xml: Moved
	  resources to own subdirecttories.
	* Mono.TextEditor/TextViewMargin.cs: Fixed little issue with folding
	  markers and invalid lines.

2008-08-20  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/Document.cs, Mono.TextEditor/TextEditor.cs,
	  Mono.TextEditor/LineSegment.cs: Changed text editor interface
	  (add/remove marker moved to document).

2008-08-19  Lluis Sanchez Gual <lluis@novell.com> 

	* Mono.TextEditor/TextEditor.cs: Fix some memory leaks.
	* gtk-gui/objects.xml: Updated.

2008-08-16  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor.Highlighting/Style.cs,
	  Mono.TextEditor.Highlighting/IColorDefinition.cs: Worked on styles
	  (fixed 'Bug 405939 - Named colours in colour schemes should have
	  fallbacks').

2008-08-16  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/Document.cs, Mono.TextEditor/FoldMarkerMargin.cs,
	  Mono.TextEditor/TextEditor.cs: fixed 'Bug 405921 - Folding markers
	  are often not repainted'. Fixed bug on fold marker painting.

2008-08-15  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor.mdp, ChangeLogSyntaxMode.xml: Added changelog syntax
	  mode.

2008-08-14  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DocumentUpdateRequest.cs,
	  Mono.TextEditor/TextEditor.cs: Fixed some drawing issues.

2008-08-14  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs: fixed color style bug.

2008-08-14  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs,
	  Mono.TextEditor/CodeSegmentPreviewWindow.cs: optimized text editor
	  code segment preview & fixed some issues with the drag widget.

2008-08-13  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/Document.cs: fixed "Bug 416564 - Syntax highlighting
	  is lost when reloading a file".

2008-08-13  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditorOptions.cs: changed default setting for new
	  tabs after nontabs option.

2008-08-12  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditorOptions.cs,
	  Mono.TextEditor/DefaultEditActions.cs: fixed "Bug 416089 - Warn
	  about tabs after non-tabs".

2008-08-12  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs,
	  Mono.TextEditor/CodeSegmentPreviewWindow.cs: fixed "Bug 405912 -
	  Dragged text no longer shows preview".

2008-08-12  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor.Highlighting/SyntaxModeService.cs: Fixed "Bug 405926
	  - Addins cannot add syntax schemes or colour schemes to the text
	  editor".

2008-08-11  Michael Hutchinson <mhutchinson@novell.com> 

	* Mono.TextEditor/TextEditorOptions.cs: Fix spelling, sheme -> scheme.

2008-08-11  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditorOptions.cs,
	  Mono.TextEditor/DefaultEditActions.cs: fixed Bug 416088 - Remove
	  Whitespace From Newlines.

2008-08-07  Lluis Sanchez Gual <lluis@novell.com> 

	* Mono.TextEditor.mdp, Makefile.am: Updated.
	* Mono.TextEditor/Margin.cs, Mono.TextEditor/FoldMarkerMargin.cs,
	  Mono.TextEditor/TextEditor.cs, Mono.TextEditor/GutterMargin.cs,
	  Mono.TextEditor/TextViewMargin.cs, Mono.TextEditor/IMargin.cs:
	  Merged IMargin and AbstractMargin into a new Margin class. Methods
	  for handling mouse events are now internal, and new public events
	  have been added.
	* Mono.TextEditor/TextMarker.cs, Mono.TextEditor/LineSegment.cs,
	  Mono.TextEditor/IconMargin.cs, Mono.TextEditor/BookmarkMargin.cs,
	  Mono.TextEditor/BookmarkMarker.cs: Renamed BookmarkMargin into
	  IconMargin. Moved code for handling bookmarks to the new
	  BookmarkMarker. Allow IIconBarMarker objects to handle mouse
	  events.

2008-08-05  Lluis Sanchez Gual <lluis@novell.com> 

	* Mono.TextEditor/Document.cs, Mono.TextEditor/TextEditorData.cs,
	  Mono.TextEditor/TextEditor.cs, gtk-gui/objects.xml: Added delegate
	  which is called to check if a line is read-only. Removed ReadOnly
	  property from TextEditor since it is not used anymore (it was moved
	  to Document).

2008-07-22  Jeffrey Stedfast  <fejj@novell.com>

	* Mono.TextEditor/DefaultEditActions.cs (DeleteCaretLineToEnd):
	Mimic Emacs behavior when the cursor is in the last column of the
	line.

2008-07-18  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs: Fixed visual --> document location
	  bug in lines with open foldings.

2008-07-15  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor.Highlighting/SyntaxModeService.cs: fixed "Bug 408896
	  - Text editor: cannot insert apostrophe, parentheses, etc in text
	  files".

2008-07-14  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/Document.cs, Mono.TextEditor/BufferedTextReader.cs:
	  Added System.IO.TextReader support for the text buffer.

2008-07-14  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs: fixed 'Bug 385456 - Code folding'.

2008-07-14  Mike Krüger <mkrueger@novell.com> 

	* JavascriptSyntaxMode.xml, XmlSyntaxMode.xml: Added java script syntax
	  mode (Bug 400896 - Syntax Mode for Javascript).

2008-07-08  Lluis Sanchez Gual <lluis@novell.com> 

	* Mono.TextEditor/ITooltipProvider.cs, Mono.TextEditor/TextEditor.cs:
	  Allow specifying the alignment of tooltips.

2008-07-07  Lluis Sanchez Gual <lluis@novell.com> 

	* Mono.TextEditor/ITooltipProvider.cs, Mono.TextEditor/TextEditor.cs:
	  Add support for "interactive" tooltips (tooltips which can have
	  interactive widgets).

2008-07-06  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor.Highlighting/SyntaxModeService.cs,
	  Mono.TextEditor.Highlighting/IXmlProvider.cs: Worked on style
	  support.

2008-07-06  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor.Highlighting/SyntaxModeService.cs,
	  Mono.TextEditor.Highlighting/IXmlProvider.cs: Added support for
	  custom styles.

2008-07-04  Mike Krüger <mkrueger@novell.com> 

	* CSharpSyntaxMode.xml, XmlSyntaxMode.xml: fixed "Bug 405927 - Quotes
	  are mis-highlighted in C# XML comments".

2008-07-04  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs: fixed 'Bug 405923 - After using
	  middle-click insertion, the document jumps back to the location of
	  the selection'.

2008-07-04  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextMarker.cs: fixed 'Bug 405919 - Error underlines
	  are sometimes painted over the line numbers and folding markers'.

2008-07-04  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs: fixed 'Bug 405913 - Drag-n-dropping
	  text should move text, not copy it'.

2008-07-04  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextMarker.cs, Mono.TextEditor.Highlighting/Style.cs:
	  Added color styles for breakpoints.

2008-07-04  Mike Krüger <mkrueger@novell.com> 

	* OblivionStyle.xml: set searchtextbg for oblivion.

2008-07-04  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor.Highlighting/SyntaxModeService.cs: fixed 'Bug 404713
	  - Threading issues in text editor'.

2008-07-03  Lluis Sanchez Gual <lluis@novell.com> 

	* Mono.TextEditor.mdp, Mono.TextEditor/ITooltipProvider.cs,
	  Mono.TextEditor/TextEditor.cs, Makefile.am: Added support for
	  tooltips. It is now possible to register tooltip providers which
	  can create custom tooltip windows.

2008-07-02  Michael Hutchinson <mhutchinson@novell.com> 

	* Mono.TextEditor/Document.cs,
	  Mono.TextEditor.Highlighting/SyntaxModeService.cs: Fix a couple of
	  crasher race conditions.
	* Mono.TextEditor.Highlighting/WorkerThread.cs: Catch exceptions in
	  worker threads so that they don't crash MD.

2008-07-02  Lluis Sanchez Gual <lluis@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs, Mono.TextEditor/TextMarker.cs:
	  Added support for style overriding in text markers. Now a text
	  marker can easily change the text style without having to implement
	  the draw method. Also use the background defined by the style
	  object, if there is one.
	* Mono.TextEditor.Highlighting/ChunkStyle.cs: Added background color
	  property. Added copy constructor.

2008-07-01  Lluis Sanchez Gual <lluis@novell.com> 

	* Mono.TextEditor/TextMarker.cs, Mono.TextEditor/BookmarkMargin.cs:
	  Added width and height parameters to IIConBarMarker.DrawIcon.
	  Simplifies work to implementers.

2008-06-23  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditorData.cs, Mono.TextEditor/Segment.cs:
	  Optimized selection - fixing [Bug 402777] New: Mouse selection is
	  very slow.

2008-06-23  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs,
	  Mono.TextEditor/TextViewMargin.cs, Mono.TextEditor/Document.cs,
	  Mono.TextEditor/TextEditorData.cs, Mono.TextEditor/TextEditor.cs,
	  Mono.TextEditor/Caret.cs, Mono.TextEditor/LineSegment.cs:
	  Refactored text editor. Corrected Document -> TextEditorData ->
	  TextEditor layers.

2008-06-23  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs: fixed 'Bug 402543 - Crash
	  while pasting text from closed document.'.

2008-06-20  Lluis Sanchez Gual <lluis@novell.com> 

	* AssemblyInfo.cs: Disable version auto-increment.

2008-06-20  Lluis Sanchez Gual <lluis@novell.com> 

	* Mono.TextEditor/TextEditor.cs: Don't allow replacing text in
	  read-only mode.

2008-06-20  Lluis Sanchez Gual <lluis@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs: Restore accidentally removed
	  code.

2008-06-20  Lluis Sanchez Gual <lluis@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs,
	  Mono.TextEditor/TextEditorData.cs, Mono.TextEditor/TextEditor.cs,
	  gtk-gui/objects.xml: Implemented support for read-only editors.
	* Mono.TextEditor/TextEditorOptions.cs: Make the Font property safer
	  for incorrect font names. Implemented CopyFrom method.

2008-06-19  Lluis Sanchez Gual <lluis@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs,
	  Mono.TextEditor/TextViewMargin.cs, Mono.TextEditor/Document.cs,
	  Mono.TextEditor/FoldMarkerMargin.cs,
	  Mono.TextEditor/TextEditorData.cs,
	  Mono.TextEditor/CodeSegmentPreviewWindow.cs,
	  Mono.TextEditor/TextEditor.cs, Mono.TextEditor/Caret.cs,
	  Mono.TextEditor/BookmarkMargin.cs,
	  Mono.TextEditor/TextEditorOptions.cs,
	  Mono.TextEditor/GutterMargin.cs, Mono.TextEditor/LineSegment.cs,
	  Mono.TextEditor.Highlighting/SyntaxMode.cs: Added support for
	  editor-specific options. TextEditor now has an Options property and
	  all classes use that object to get options, instead of the static
	  instance.

2008-06-18  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs: added workaround to fix 400293.

2008-06-17  Mike Krüger <mkrueger@novell.com> 

	* VBNetSyntaxMode.xml, CSharpSyntaxMode.xml, JavaSyntaxMode.xml,
	  CSyntaxMode.xml, ValaSyntaxMode.xml: Updated highlighting files.

2008-06-17  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor.Highlighting/SyntaxMode.cs,
	  Mono.TextEditor.Highlighting/SyntaxModeService.cs: Fixed syntax
	  highlighting issue.

2008-06-15  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/RedBlackTree.cs: fixed possible null reference.

2008-06-11  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditorOptions.cs: changed visibility.

2008-06-11  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/RedBlackTree.cs: Fixed red black tree.

2008-06-11  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/RedBlackTree.cs: fixed 'Bug 381106 - Document view
	  state can become scrambled'.

2008-06-11  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor.Highlighting/SemanticRule.cs: fixed 'Bug 393118 - URL
	  is not underlined completely and indeed redirects to only the
	  domain'

2008-06-10  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs, Mono.TextEditor/LineSplitter.cs,
	  Mono.TextEditor/Document.cs, Mono.TextEditor/LineSegmentTree.cs,
	  Mono.TextEditor/TextEditor.cs, Mono.TextEditor/BookmarkMargin.cs,
	  Mono.TextEditor.Highlighting/SyntaxMode.cs,
	  Mono.TextEditor.Highlighting/SyntaxModeService.cs,
	  Mono.TextEditor.Highlighting/Rule.cs: Fixed some
	  warnings/refactored code a bit. Improved the handling of the
	  longest line.

2008-06-10  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs: Fixed tab placement bug.

2008-06-09  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs: Fixed horizontal scrollbar bug.

2008-06-09  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs: Fixed bug in
	  VisualToDocumentLocation

2008-06-09  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs: Fixed tab stop calculation - it
	  should work better now. Refactored visual <--> document location
	  logic.

2008-06-06  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs: fixed possible null reference
	  exception in VisualToDocumentLocation

2008-06-05  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs: Improved support for non
	  monospaced font.

2008-06-05  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs: fixed Bug 394285 - NRE in CaretThread

2008-06-04  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs: Fixed possible div by zero
	  exception.

2008-06-03  Lluis Sanchez Gual <lluis@novell.com> 

	* Mono.TextEditor/TextEditor.cs: Use the OnDestroyed event instead of
	  Dispose, since with the latest changes in gtk#, Dispose is not
	  called anymore when a widget is destroyed.

2008-05-28  Michael Hutchinson <mhutchinson@novell.com> 

	* XmlSyntaxMode.xml: Fix CDATA end tag.

2008-05-27 David Makovský <yakeen@sannyas-on.net>
 
	* Mono.TextEditor/DefaultEditActions.cs: parse double value with invariant culture (Patch by Jérémie Laval).

2008-05-26  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs: handled possible nullref.

2008-05-22  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor.Highlighting/SemanticRule.cs: fixed Bug 393118 - URL
	  is not underlined completely and indeed redirects to only the
	  domain

2008-05-22  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs: fixed 'Bug 393037 - CTRL+F and writing
	  text produces NRE'

2008-05-22  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs: fixed Bug 393411 - Pasted text
	  offset is wrong when there is a selection

2008-05-21  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor.Highlighting/SyntaxModeService.cs: fixed 'Bug 392655
	  - The 'stopateol' highlighting behaviour doesn't always work'.

2008-05-20  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs,
	  Mono.TextEditor/TextViewMargin.cs: fixed 'Bug 389561 - Regression:
	  Middle-click paste does not insert at cursor location'.

2008-05-20  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/Document.cs: fixed 'Bug 385844 - XML syntax
	  highlighting is unreliable' & 'Bug 389352 - Regression: big comment
	  is not coloured'.

2008-05-19  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs: Optimized background buffer.

2008-05-19  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/LineSplitter.cs, Mono.TextEditor/Document.cs,
	  Mono.TextEditor/IBuffer.cs, Mono.TextEditor/RedBlackTree.cs,
	  Mono.TextEditor/LineSegmentTree.cs, Mono.TextEditor/TextEditor.cs,
	  Mono.TextEditor/GapBuffer.cs, Mono.TextEditor/LineSegment.cs: Fixed
	  text editor memory leak.

2008-05-15  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextMarker.cs: fixed cut&paste error.

2008-05-15  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextMarker.cs: exposed color property of the text
	  marker

2008-05-15  Lluis Sanchez Gual <lluis@novell.com> 

	* Mono.TextEditor/TextMarker.cs: Moved the code that draws error
	  underlines to a new UnderlineMarker. Created LineBackgroundMarker,
	  to be used to change the background of a line.

2008-05-13  Mike Krüger <mkrueger@novell.com> 

	* CSharpSyntaxMode.xml, Mono.TextEditor.Highlighting/SyntaxMode.cs:
	  Worked on c# syntax mode. Fixed syntax highlighting bug (keyword
	  before span end now highlights correct).

2008-05-09  Michael Hutchinson <mhutchinson@novell.com> 

	* AspNetSyntaxMode.xml, XmlSyntaxMode.xml: Highlight doctypes. Fix
	  attribute highlighting.

2008-05-09  Michael Hutchinson <mhutchinson@novell.com> 

	* AspNetSyntaxMode.xml, XmlSyntaxMode.xml: Improve attribute regex.

2008-05-09  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/Document.cs: Fixed highlighting update bug.

2008-05-08  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor.Highlighting/SyntaxModeService.cs, XmlSyntaxMode.xml:
	  Fixed a syntax highlighting bug/worked on xml highlighting.

2008-05-08  Mike Krüger <mkrueger@novell.com> 

	* XmlSyntaxMode.xml: worked on xml highlighting.

2008-05-08  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs, Mono.TextEditor/TextEditor.cs:
	  fixed "Bug 387778 - MD Crash on Mouse Paste".

2008-05-07  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/BookmarkMargin.cs: fixed null ref exception.

2008-05-07  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/BookmarkMargin.cs: Bookmark margin now exposes it's
	  draw event.

2008-05-07  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs, Mono.TextEditor/TextMarker.cs,
	  Mono.TextEditor/BookmarkMargin.cs: Worked on text markers.

2008-05-07  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditorData.cs, Mono.TextEditor/ISearchEngine.cs:
	  implemented replace regex groups.

2008-05-07  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs: fixed Bug 387321 - Crash when Select
	  All + Copy + Select All + Paste.

2008-05-06  Michael Hutchinson <mhutchinson@novell.com> 

	* Mono.TextEditor/TextEditor.cs: Reset the IMContext even when there's
	  an exception during a commit.
	* AspNetSyntaxMode.xml, XmlSyntaxMode.xml: Improve highlighting
	  schemes.
	* Mono.TextEditor.Highlighting/Style.cs: Allow highlighting schemes to
	  access the "default" colour.

2008-05-06  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs, Mono.TextEditor/TextMarker.cs:
	  Worked on text markers.

2008-05-06  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs, Mono.TextEditor/TextEditorData.cs,
	  Mono.TextEditor/TextEditor.cs, Mono.TextEditor/ISearchEngine.cs:
	  Worked on regex search.

2008-05-05  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/ISearchEngine.cs: worked on regex search.

2008-05-02  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditorData.cs, Mono.TextEditor/TextEditor.cs,
	  Mono.TextEditor/ISearchEngine.cs: Abstracted the search engine.

2008-05-02  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs: Fixed Bug 385737 - Text editor shows
	  unnecessary horizontal scrollbar

2008-05-02  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs: fixed Bug 382556 - Text editor
	  should respect GTK settings.

2008-05-01  Michael Hutchinson <mhutchinson@novell.com> 

	* Mono.TextEditor/TextEditor.cs: Add focus in and focus out calls to
	  IMContext. Revert static IMContext changes., which for some reason
	  also fixes crash on double-click.

2008-04-30  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs: fixed resource deallocation.

2008-04-30  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs: Fixed an error in keyboard input when
	  multiple text editors are open.

2008-04-30  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs: Fixed possible null ref exception when
	  accessing disposed text editor.

2008-04-29  Michael Hutchinson <mhutchinson@novell.com> 

	* Mono.TextEditor/TextEditor.cs: Dispose the IMContext, and check that
	  it's realised when committing. Hopefully fixes possible NRE after
	  the document is disposed.

2008-04-23  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs: Replaced old some old coordination
	  translation code.

2008-04-21  Michael Hutchinson <mhutchinson@novell.com> 

	* Mono.TextEditor/TextEditor.cs: Attempt to fix major "Bug 382141 - ALL
	  keypresses are intepreted as newlines" by reworking input method
	  context handling.

2008-04-21  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs: fixed keyboard input.

2008-04-18  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs: fixed 'Bug 381115 - Ctrl+s prints an s
	  if there's nothing to save'.

2008-04-17  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs: fixed 'Bug 379935 - Can't type letters
	  with accents and other composed chars with the text editor'.

2008-04-16  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs: Removed work around.

2008-04-15  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs: fixed Bug 379236 - Pressing
	  "end" on a folded code block doesn't move to end

2008-04-15  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs: fixed Bug 378195 - Text editor has
	  visible caret when there is a selection

2008-04-08  Michael Hutchinson <mhutchinson@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs: Restore caret position after a
	  middle-click insertion, and restore selection when the insertion is
	  within the offset range space previously occupied by the selection.
	  Fixes "Bug 378188 - Strange selection deletion behaviour".

2008-04-04  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs: Optimized text editor drawing a
	  bit. Worked on folding preview.

2008-04-03  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs: fixed some selection issues in
	  some commands.

2008-04-03  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs,
	  Mono.TextEditor/TextViewMargin.cs, Mono.TextEditor/TextEditor.cs:
	  fixed 'Bug 376331 - Middle-click paste should not change
	  selection'.

2008-04-03  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/CodeSegmentPreviewWindow.cs,
	  Mono.TextEditor/LineSegment.cs,
	  Mono.TextEditor.Highlighting/SyntaxMode.cs: fixed 'Bug 376329 -
	  Folded region tooltip readability issues'

2008-04-02  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs: fixed 'Bug 324272 - in search and
	  replace, parenthesis matching should be disabled'

2008-04-02  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditorData.cs: worked on  bug 'Bug 376136 - Array
	  out of bounds selecting text'.

2008-04-02  Mike Krüger <mkrueger@novell.com> 

	

2008-04-02  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs, Mono.TextEditor/IMargin.cs,
	  Mono.TextEditor/TextEditor.cs,
	  Mono.TextEditor.Highlighting/SyntaxMode.cs: Optimized preview
	  window a bit.

2008-04-02  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor.mdp, Mono.TextEditor/TextViewMargin.cs,
	  Mono.TextEditor/IMargin.cs,
	  Mono.TextEditor/CodeSegmentPreviewWindow.cs,
	  Mono.TextEditor/LineSegmentTree.cs, Mono.TextEditor/TextEditor.cs,
	  Mono.TextEditor.Highlighting/SyntaxMode.cs, Makefile.am: Added
	  preview window for collapsed regions (feature request 363639).

2008-03-27  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/Document.cs: Removed debug message.

2008-03-21  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/LineSegmentTree.cs: fixed Bug 372273 - MD crash.

2008-03-19  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/Document.cs: Fixed 'Bug 372256 - Region wrapped when
	  Code Folding is disabled'

2008-03-18  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs: Removed some debug messages.

2008-03-18  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor.Highlighting/SyntaxMode.cs,
	  Mono.TextEditor.Highlighting/SyntaxModeService.cs: Fixed Bug 371702
	  - XmlEditor - crash with empty file.

2008-03-14  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor.mdp, CSharpSyntaxMode.xml, CSyntaxMode.xml,
	  Mono.TextEditor.Highlighting/SyntaxMode.cs,
	  Mono.TextEditor.Highlighting/SyntaxModeService.cs,
	  Mono.TextEditor.Highlighting/Rule.cs, Makefile.am: Fixed Bug 370303
	  - '#if 0' blocks should be coloured as comments.
	
	  Changed the way spans are scanned. The order of the span definition
	  is now important - no more constraints. The first defined span is
	  used first - so define /// before // for example.

2008-03-14  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs: fixed Bug 363951 - Numeric keyboard
	  does not work

2008-03-13  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs: Possible fix: 'Bug 368597 - Wrong
	  location of caret in the new managed editor'.

2008-03-13  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs: Fixed Bug 370133 - When jumping to a
	  line, caret should be placed in the middle of the window

2008-03-13  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/Document.cs,
	  Mono.TextEditor.Highlighting/SyntaxMode.cs,
	  Mono.TextEditor.Highlighting/SyntaxModeService.cs: fixed Bug 370135
	  - XML comment highlighting not working

2008-03-13  Mike Krüger <mkrueger@novell.com> 

	* ValaSyntaxMode.xml: Added vala syntax mode from levi bard.

2008-03-12  Michael Hutchinson <mhutchinson@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs: Implement AutoIndent
	  behaviour.

2008-03-07  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/Document.cs: Added some thread locks for the update logic.

2008-03-05  Michael Hutchinson <mhutchinson@novell.com> 

	* XmlSyntaxMode.xml: Apply XML highlighting to XAML , HTML and XHTML.

2008-03-05  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs: Improved the scrolling speed (should be
	  visible on old machines).

2008-03-05  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs: Window split now removes the split that
	  doesn't have the focus. (intelligent split)

2008-03-03  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/BookmarkMargin.cs: Clicking on the bookmark margin on an
	  invalid line no longer triggers the bookmark in the last line.

2008-03-03  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor.mdp, AspNetSyntaxMode.xml, Makefile.am: Started ASP.NET
	  highlighting.

2008-03-03  Mike Krüger <mkrueger@novell.com> 

	* CPPSyntaxMode.xml, CSyntaxMode.xml, Mono.TextEditor/Document.cs,
	  Mono.TextEditor.Highlighting/SyntaxMode.cs: It's now possible that
	  syntax highlighting files inherit from each other (C<-C++).

2008-03-03  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor.Highlighting/SyntaxMode.cs: Refactored highlighting
	  algorithm.

2008-03-03  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor.Highlighting/SyntaxMode.cs,
	  Mono.TextEditor.Highlighting/Style.cs,
	  Mono.TextEditor.Highlighting/ChunkStyle.cs: Worked on the syntax
	  highlighting algorithm.

2008-03-03  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/Document.cs: Added some worker threads.

2008-03-03  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs: Removed debug message.

2008-03-01  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor.Highlighting/SyntaxModeService.cs: Fixed syntax
	  highlighting bug

2008-03-01  Mike Krüger <mkrueger@novell.com> 

	* CSharpSyntaxMode.xml, Mono.TextEditor/TextViewMargin.cs,
	  Mono.TextEditor.Highlighting/SyntaxMode.cs,
	  Mono.TextEditor.Highlighting/Match.cs: Added support for regular
	  expressions (syntax highlighting).

2008-03-01  Mike Krüger <mkrueger@novell.com> 

	* PythonSyntaxMode.xml, Mono.TextEditor.Highlighting/SyntaxMode.cs: fixed
	  """, ''' pydocs

2008-03-01  Mike Krüger <mkrueger@novell.com> 

	* PythonSyntaxMode.xml: Added python syntax highlighting.

2008-02-29  Levi Bard <taktaktaktaktaktaktaktaktaktak@gmail.com>
 
 	* CPPSyntaxMode.xml, CSyntaxMode.xml: Added headers to highlighted mime
 	types.

2008-02-29  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs,
	  Mono.TextEditor.Highlighting/SyntaxModeService.cs: Freed up some
	  resources.

2008-02-29  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/FoldMarkerMargin.cs, Mono.TextEditor/BookmarkMargin.cs:
	  Fixed zooming bug.

2008-02-29  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs, Mono.TextEditor/TextEditorOptions.cs: Added
	  zoom commands to main menu.

2008-02-29  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs: Added a function.

2008-02-29  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs, Mono.TextEditor/TextViewMargin.cs,
	  Mono.TextEditor/Document.cs, Mono.TextEditor/TextUtil.cs,
	  Mono.TextEditor/TextEditorData.cs: Moved TextUtil functions into
	  Document.

2008-02-29  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor.Highlighting/SyntaxModeService.cs,
	  Mono.TextEditor.Highlighting/WorkerThread.cs: Abstracted safe threading
	  in a reuseable workerthread class.

2008-02-29  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs, Mono.TextEditor/TextUtil.cs: Fixed
	  Bracket highlighting on text operations.

2008-02-29  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs, Mono.TextEditor/TextUtil.cs:
	  changed next/prev word behaviour.

2008-02-29  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor.Highlighting/SyntaxModeService.cs: No longer using
	  Thread.Abort ().

2008-02-28  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditorData.cs, Mono.TextEditor/TextEditor.cs: Worked
	  on search&replace. (Bug 365439 - Replace usability issues)

2008-02-28  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs, Mono.TextEditor/Document.cs: Fixed some
	  bugs caused by a former change.

2008-02-28  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/LineSplitter.cs, Mono.TextEditor/TextEditorData.cs,
	  Mono.TextEditor/TextEditor.cs, Mono.TextEditor/GapBuffer.cs,
	  Mono.TextEditor/GutterMargin.cs,
	  Mono.TextEditor.Tests/Mono.TextEditor.Tests.pidb,
	  Mono.TextEditor.Tests/Mono.TextEditor.Tests.mdp,
	  Mono.TextEditor.Tests/Mono.TextEditor.Tests/LineSplitterTests.cs,
	  Mono.TextEditor.Tests/Mono.TextEditor.Tests/SelectionTests.cs: Fixed Bug
	  365570 - Crash in the editor.

2008-02-27  Mike Krüger <mkrueger@novell.com> 

	

2008-02-27  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor.Highlighting/SyntaxMode.cs,
	  Mono.TextEditor.Highlighting/SyntaxModeService.cs: Support for escape
	  chars.

2008-02-27  Mike Krüger <mkrueger@novell.com> 

	

2008-02-27  Mike Krüger <mkrueger@novell.com> 

	

2008-02-27  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditorData.cs: Refactored status bar.

2008-02-27  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/Document.cs, Mono.TextEditor/TextEditorData.cs: Removed
	  some debug messages

2008-02-27  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs, Mono.TextEditor/TextMarker.cs: Added
	  draw routine for a caret marker.

2008-02-27  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextMarker.cs: Added background marker support.

2008-02-27  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/Document.cs, Mono.TextEditor/TextEditorData.cs,
	  Mono.TextEditor/TextEditor.cs, Mono.TextEditor/Caret.cs,
	  Mono.TextEditor.Tests/Mono.TextEditor.Tests/UndoRedoTests.cs,
	  Mono.TextEditor.Highlighting/Caret.cs: Fixed Bug 362692 - Undoing all
	  changes should clear the modified flag of the editor.
	
	  Refactored structure a bit. Added unit tests for undo/redo operations.

2008-02-27  Aaron Bockover <abockover@novell.com>

	* OblivionStyle.xml: Made some style changes to be less bland

	* BrownStyle.xml: Renamed from UbuntuStyle

2008-02-27  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs: fixed drawing bug.

2008-02-27  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs: fixed not to draw invalid line bug.

2008-02-27  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs, Mono.TextEditor/Document.cs: Editor
	  now updates automatically when inserting/removing lines. (internal
	  change, does NOT affect users)

2008-02-26  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs: Fixed possible exception in
	  TextViewMargin.

2008-02-25  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor.Highlighting/SyntaxMode.cs: Fixed syntax highlighting bug.

2008-02-23  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs, Mono.TextEditor/GapBuffer.cs,
	  Mono.TextEditor.Tests/Mono.TextEditor.Tests.pidb,
	  Mono.TextEditor.Highlighting/Rule.cs,
	  Mono.TextEditor.Highlighting/ChunkStyle.cs: Cleaned some code.

2008-02-23  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs: possible fix for 363621.

2008-02-23  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor.mdp, Mono.TextEditor/Document.cs,
	  Mono.TextEditor/LineSegmentTree.cs, Mono.TextEditor/GapBuffer.cs,
	  Mono.TextEditor.Highlighting/SyntaxMode.cs: Added some assertions which
	  help to track errors.

2008-02-23  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor.Tests/Mono.TextEditor.Tests.pidb: Removed some unused
	  glade and gnome-sharp references (only the unused). But I'll continue to
	  remove glade, we need to lower the dependency tree a bit.

2008-02-22  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs, Mono.TextEditor/TextViewMargin.cs,
	  Mono.TextEditor/SearchOptions.cs, Mono.TextEditor/TextEditorData.cs,
	  Mono.TextEditor/TextEditor.cs, Mono.TextEditor/SearchResult.cs,
	  Mono.TextEditor.Tests/Mono.TextEditor.Tests/SearchTests.cs: Fixed Bug
	  364045 - Can't use Search Previous command to go through to all matches.
	  And wrote some unit tests for the search commands. 

2008-02-22  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/Document.cs: Fixed bug in logicaltovisuallocation.

2008-02-22  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs, Mono.TextEditor/SearchResult.cs: Search now
	  gives more information about the result.

2008-02-22  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs: Added support for custom drag sources.

2008-02-22  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs: Added try/catch, may help to track
	  the cut&paste problem.

2008-02-22  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs: Bug 363951 - Numeric keyboard does not work

2008-02-22  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs: Changed copy behaviour.

2008-02-22  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs: Added global copy event (for the
	  clipboard ring)

2008-02-21  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs: Fixed Bug 363631 - The selection does
	  not work for "*" symbol.

2008-02-21  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor.Highlighting/SyntaxMode.cs: fixed highlighting issue.

2008-02-21  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs: Fixed Bug 363762 - Scrollbar does not take
	  into account collapsed regions.

2008-02-21  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/Document.cs, Mono.TextEditor/TextUtil.cs: Fixed Bug 363771
	  - Strange behavior when typing on a new file.

2008-02-21  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs, Mono.TextEditor/Caret.cs,
	  Mono.TextEditor.Highlighting/SyntaxModeService.cs,
	  Mono.TextEditor.Highlighting/Caret.cs: Fixed Bug 363628 - MD text editor
	  does not recognize comments inside comments

2008-02-21  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor.Highlighting/SyntaxMode.cs: fixed Bug 363624 - variables
	  which contains keyword are wrongly recongnized

2008-02-21  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs: Fixed control key problem.

2008-02-20  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs: Fixed update at delet line/delete
	  line to end commands.

2008-02-20  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/BookmarkMargin.cs: Bookmark is now scaling better.

2008-02-19  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs,
	  Mono.TextEditor.Tests/Mono.TextEditor.Tests.pidb,
	  Mono.TextEditor.Tests/Mono.TextEditor.Tests.DefaultEditActions/InsertTabTests.cs:
	  Found insert tab case that failed.

2008-02-19  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs, Mono.TextEditor/TextEditorData.cs,
	  Mono.TextEditor.Tests/Mono.TextEditor.Tests.DefaultEditActions/SelectionSelectAllTests.cs:
	  Fixed "Bug 362983 - Text selected with Select All can't be unselected"

2008-02-19  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor.Tests/Mono.TextEditor.Tests.pidb: Copy to primary
	  clipboard is now lazy (Improves performance for large selections).

2008-02-19  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor.Tests/Mono.TextEditor.Tests.DefaultEditActions/InsertTabTests.cs,
	  Mono.TextEditor.Tests/Mono.TextEditor.Tests.DefaultEditActions/RemoveTabTests.cs:
	  Added Remove tab tests.

2008-02-19  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs, Mono.TextEditor/TextViewMargin.cs,
	  Mono.TextEditor/TextEditorData.cs, Mono.TextEditor/TextEditor.cs: Fixed
	  little issues found by unit testing.
	* Mono.TextEditor.Tests/Mono.TextEditor.Tests/SelectionTests.cs,
	  Mono.TextEditor.Tests/Mono.TextEditor.Tests.DefaultEditActions/InsertTabTests.cs:
	  Extended unit tests.

2008-02-19  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/Caret.cs: Bug 362895 - Caret missplaced when jumping to an
	  error.

2008-02-19  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs: fixed Bug 362879 - Bracket highlight
	  not removed.

2008-02-19  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs, Mono.TextEditor/TextEditorData.cs,
	  Mono.TextEditor.Tests/Mono.TextEditor.Tests.pidb: Fixed Bug 362887 -
	  Paste command pastes text to the wrong location.

2008-02-19  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor.Tests/Mono.TextEditor.Tests.mdp,
	  Mono.TextEditor.Tests/Mono.TextEditor.Tests.DefaultEditActions/InsertTabTests.cs:
	  Added some tests for the insert tab behavior.

2008-02-19  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs, Mono.TextEditor/Document.cs,
	  Mono.TextEditor/TextEditorData.cs, Mono.TextEditor/TextEditor.cs,
	  Mono.TextEditor.Tests/Mono.TextEditor.Tests.pidb: Fixed insert/remove
	  indent (Bug 362896 - Unindent action leaves selection in a weird state).

2008-02-19  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor.Tests/Mono.TextEditor.Tests.mdp,
	  Mono.TextEditor.Tests/Mono.TextEditor.Tests,
	  Mono.TextEditor.Tests/Mono.TextEditor.Tests/DocumentTests.cs,
	  Mono.TextEditor.Tests/Mono.TextEditor.Tests.DefaultEditActions/DocumentTests.cs,
	  Mono.TextEditor.Tests/Mono.TextEditor.Tests.DefaultEditActions/CaretMoveTests.cs,
	  Mono.TextEditor.Tests/Mono.TextEditor.Tests.DefaultEditActions/InsertNewLineTests.cs:
	  Worked on text editor unit tests.

2008-02-19  Lluis Sanchez Gual <lluis@novell.com> 

	* Makefile.am, Mono.TextEditor.mdp: Fixed assembly references.

2008-02-19  Lluis Sanchez Gual <lluis@novell.com> 

	* Mono.TextEditor/TextEditor.cs: Added key bindings for
	  control+shift+up/down. In OnLeaveNotifyEvent, reset the cursor only when
	  the mouse is really leaving the window.

2008-02-19  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs, Mono.TextEditor/TextViewMargin.cs,
	  Mono.TextEditor/Document.cs, Mono.TextEditor/Segment.cs,
	  Mono.TextEditor/LineSegment.cs: Fixed some warnings.

2008-02-19  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs: Fixed possible nullref.

2008-02-19  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs, Mono.TextEditor/TextViewMargin.cs,
	  Mono.TextEditor/Document.cs, Mono.TextEditor/TextEditorData.cs,
	  Mono.TextEditor/IMargin.cs, Mono.TextEditor/SelectionMarker.cs,
	  Mono.TextEditor/TextEditor.cs, Mono.TextEditor/GutterMargin.cs: Worked
	  on selection.

2008-02-18  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs: fixed Bug 322763 - Ctrl + Backspace
	  deletes the end of the line.

2008-02-18  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs: goto/delete next/prev word should
	  now be the same as in gtksourceview.

2008-02-18  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/Document.cs, Mono.TextEditor/TextEditor.cs: Implemented
	  undo operation dispose

2008-02-18  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/Document.cs, Mono.TextEditor/TextEditorData.cs,
	  Mono.TextEditor/TextEditor.cs: Fixed undo/redo bug.

2008-02-18  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs, Mono.TextEditor/Document.cs,
	  Mono.TextEditor/TextEditorData.cs, Mono.TextEditor/TextEditor.cs: Worked
	  on undo/redo.

2008-02-18  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs: fixed Bug 362691 - Mouse click doesn't
	  clear selection in some specific case

2008-02-18  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs, Mono.TextEditor/FoldMarkerMargin.cs,
	  Mono.TextEditor/IMargin.cs, Mono.TextEditor/TextEditor.cs,
	  Mono.TextEditor/BookmarkMargin.cs, Mono.TextEditor/GutterMargin.cs:
	  Worked on mouse behavior.
	
	  Fixing Bug 362683 - Double click + drag selection not working
	
	  Bug 362687 - Triple-click should select the whole line

2008-02-18  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs, Mono.TextEditor/FoldMarkerMargin.cs,
	  Mono.TextEditor/TextEditor.cs, Mono.TextEditor/BookmarkMargin.cs,
	  Mono.TextEditor/TextEditorOptions.cs: Implemented mouse wheel zoom.

2008-02-18  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs: Changed scroll to caret a bit.

2008-02-18  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs: Fixed tabs2spaces option.

2008-02-18  Mike Krüger <mkrueger@novell.com> 

	* BooSyntaxMode.xml: Added boo syntax mode.

2008-02-18  Mike Krüger <mkrueger@novell.com> 

	* VBNetSyntaxMode.xml: Fixed VB.NET syntax mode (comments).

2008-02-17  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextUtil.cs, Mono.TextEditor/TextEditor.cs: Worked on
	  search options.

2008-02-17  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs: Caret line highlighting works again.

2008-02-17  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs, Mono.TextEditor/Document.cs,
	  Mono.TextEditor/SearchOptions.cs, Mono.TextEditor/TextUtil.cs,
	  Mono.TextEditor/TextEditorData.cs, Mono.TextEditor/TextEditor.cs,
	  Mono.TextEditor/Segment.cs, Mono.TextEditor/LineSegment.cs,
	  Mono.TextEditor.Highlighting/Style.cs: Worked on search and replace.

2008-02-16  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs: Small refactorings.

2008-02-16  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs, Mono.TextEditor/TextViewMargin.cs,
	  Mono.TextEditor/Document.cs, Mono.TextEditor/Caret.cs,
	  Mono.TextEditor/LineSegment.cs: Caret now remembers it's column when
	  moving up/down.

2008-02-16  Mike Krüger <mkrueger@novell.com> 

	* OblivionStyle.xml, Mono.TextEditor/TextViewMargin.cs: Fixed caret drawing
	  issues.

2008-02-15  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs: Fixed ruler drawing.

2008-02-15  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs: Corrected ruler posititon.

2008-02-15  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs, Mono.TextEditor/Document.cs,
	  Mono.TextEditor/FoldMarkerMargin.cs, Mono.TextEditor/TextEditor.cs,
	  Mono.TextEditor/GutterMargin.cs: Refactored text editor.

2008-02-15  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs: Keypad control keys now work.

2008-02-15  Mike Krüger <mkrueger@novell.com> 

	

2008-02-15  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs, Mono.TextEditor/Document.cs,
	  Mono.TextEditor/IBuffer.cs, Mono.TextEditor/GapBuffer.cs,
	  Mono.TextEditor/GutterMargin.cs: Fixed gutter bug & refactored.

2008-02-15  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs, Mono.TextEditor/TextViewMargin.cs,
	  Mono.TextEditor/Document.cs, Mono.TextEditor/LineSplitter.cs,
	  Mono.TextEditor/TextUtil.cs, Mono.TextEditor/FoldMarkerMargin.cs,
	  Mono.TextEditor/TextEditorData.cs, Mono.TextEditor/TextMarker.cs,
	  Mono.TextEditor/SelectionMarker.cs,
	  Mono.TextEditor/DocumentUpdateRequest.cs, Mono.TextEditor/TextEditor.cs,
	  Mono.TextEditor/Caret.cs, Mono.TextEditor/BookmarkMargin.cs,
	  Mono.TextEditor/DocumentLocation.cs, Mono.TextEditor/GutterMargin.cs,
	  Mono.TextEditor.Highlighting/SyntaxMode.cs,
	  Mono.TextEditor.Highlighting/SemanticRule.cs,
	  Mono.TextEditor.Highlighting/SyntaxModeService.cs: Refactored text
	  editor. Fixed column ruler.

2008-02-15  Lluis Sanchez Gual <lluis@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs: Remove access to properties service
	  from performance critical methods. Greatly improves performance.

2008-02-15  Lluis Sanchez Gual <lluis@novell.com> 

	* Mono.TextEditor/TextEditor.cs: Added method for running an editor action.

2008-02-15  Lluis Sanchez Gual <lluis@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs, Mono.TextEditor/TextViewMargin.cs,
	  Mono.TextEditor/TextUtil.cs, Mono.TextEditor/TextEditor.cs: Implemented
	  'go to matching bracket' action.

2008-02-14  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs, Mono.TextEditor/TextMarker.cs,
	  Mono.TextEditor/TextEditor.cs,
	  Mono.TextEditor.Highlighting/SemanticRule.cs: Url textmarker now has a
	  type enum.

2008-02-14  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs: Fixed bug in ColumnToVisualX.

2008-02-14  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs: Commented out smooth scrooling (can't get
	  it right)

2008-02-14  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs, Mono.TextEditor/TextMarker.cs: Markers
	  are now drawn with selection information.

2008-02-14  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs: Fixed highlighting bracket drawing
	  issue.

2008-02-14  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs, Mono.TextEditor/TextEditor.cs,
	  Mono.TextEditor/Caret.cs: Fixed caret drawing error.

2008-02-14  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/ISegment.cs, Mono.TextEditor/TextViewMargin.cs,
	  Mono.TextEditor/Segment.cs, Mono.TextEditor/LineSegment.cs: Fixed
	  folding marker drawing.

2008-02-14  Mike Krüger <mkrueger@novell.com> 

	* TangoLightStyle.xml, OblivionStyle.xml, UbuntuStyle.xml,
	  Mono.TextEditor/TextViewMargin.cs, Mono.TextEditor/TextEditor.cs,
	  Mono.TextEditor.Highlighting/Style.cs, C64Style.xml: Fixed some drawing
	  issues & speed bug with ctrl+home.

2008-02-14  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/ISegment.cs, Mono.TextEditor/DefaultEditActions.cs,
	  Mono.TextEditor/TextViewMargin.cs, Mono.TextEditor/Document.cs,
	  Mono.TextEditor/TextEditorData.cs, Mono.TextEditor/TextMarker.cs,
	  Mono.TextEditor/TextEditor.cs, Mono.TextEditor/Segment.cs,
	  Mono.TextEditor/LineSegment.cs,
	  Mono.TextEditor.Highlighting/SyntaxModeService.cs: Refactored much. Tab
	  stops should now work. I've changed the update behaviour a bit - so
	  expect some drawing issues (something updated too late or not updated at
	  all).  Drawing itself should go faster, but I don't have hard data here.

2008-02-14  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs, Mono.TextEditor/TextEditor.cs: Fixed
	  mouse selection to the left bug.

2008-02-14  Lluis Sanchez Gual <lluis@novell.com> 

	* Mono.TextEditor/TextEditor.cs: Ignore leave events raised by pointer Grab,
	  since the pointer is not actually leaving the window.

2008-02-13  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs: Fixed Bug 361473 - Incorrect placement
	  of the cursor with mouse click.

2008-02-13  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs, Mono.TextEditor/TextMarker.cs,
	  Mono.TextEditor/TextEditor.cs: Optimized drawing.

2008-02-13  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs, Mono.TextEditor/TextEditor.cs: Fixed
	  drawing glicht caused by false adjustment.

2008-02-13  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs: Changed scrolling a bit.

2008-02-13  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs, Mono.TextEditor/FoldMarkerMargin.cs,
	  Mono.TextEditor/IMargin.cs, Mono.TextEditor/TextEditor.cs,
	  Mono.TextEditor/BookmarkMargin.cs, Mono.TextEditor/GutterMargin.cs:
	  Implemented shift+click behavior.

2008-02-13  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs: Changed delete action.

2008-02-13  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs, Mono.TextEditor/FoldMarkerMargin.cs,
	  Mono.TextEditor/IMargin.cs, Mono.TextEditor/TextMarker.cs,
	  Mono.TextEditor/TextEditor.cs, Mono.TextEditor/BookmarkMargin.cs,
	  Mono.TextEditor/GutterMargin.cs: Implemented smooth scrolling.

2008-02-12  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs: Fixed an error.

2008-02-12  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor.mdp, Mono.TextEditor/Document.cs,
	  Mono.TextEditor.Highlighting/SyntaxMode.cs,
	  Mono.TextEditor.Highlighting/SemanticRule.cs,
	  Mono.TextEditor.Highlighting/SyntaxModeService.cs,
	  Mono.TextEditor.Highlighting/Rule.cs, Makefile.am: Worked on semantic
	  highlighting.

2008-02-12  Mike Krüger <mkrueger@novell.com> 

	* CSharpSyntaxMode.xml, Mono.TextEditor/LineSplitter.cs,
	  Mono.TextEditor/TextMarker.cs, Mono.TextEditor/TextEditor.cs,
	  Mono.TextEditor/LineSegment.cs,
	  Mono.TextEditor.Highlighting/SyntaxMode.cs,
	  Mono.TextEditor.Highlighting/SyntaxModeService.cs,
	  Mono.TextEditor.Highlighting/Rule.cs: Started support for semantic
	  highlighting. Urls+email addresses in comments and strings are
	  highlighted.
	
	  (Yes I know that THIS doesn't need to be done with semantic
	  highlighting, but I need to test it out somewhere)

2008-02-12  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs, Mono.TextEditor/Document.cs,
	  Mono.TextEditor/FoldMarkerMargin.cs, Mono.TextEditor/BookmarkMargin.cs,
	  Mono.TextEditor/GutterMargin.cs,
	  Mono.TextEditor.Highlighting/SyntaxModeService.cs: Worked on memory
	  management.

2008-02-12  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextViewMargin.cs, Mono.TextEditor/Document.cs,
	  Mono.TextEditor/LineSegment.cs,
	  Mono.TextEditor.Highlighting/SyntaxModeService.cs: Syntax highlighting
	  update is now faster. (produced too many redraws)

2008-02-11  Mike Krüger <mkrueger@novell.com> 

	* TangoLightStyle.xml, Mono.TextEditor.Highlighting/Style.cs, C64Style.xml:
	  Reversed bookmark color.

2008-02-11  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs, Mono.TextEditor/TextViewMargin.cs,
	  Mono.TextEditor/TextEditor.cs: Middle mouse button paste now works.

2008-02-11  Mike Krüger <mkrueger@novell.com> 

	* TangoLightStyle.xml, Mono.TextEditor.mdp, bookmark.png, OblivionStyle.xml,
	  UbuntuStyle.xml, Mono.TextEditor/TextViewMargin.cs,
	  Mono.TextEditor/Document.cs, Mono.TextEditor/FoldMarkerMargin.cs,
	  Mono.TextEditor/IMargin.cs, Mono.TextEditor/TextEditor.cs,
	  Mono.TextEditor/BookmarkMargin.cs, Mono.TextEditor/TextEditorOptions.cs,
	  Mono.TextEditor/GutterMargin.cs, Mono.TextEditor.Highlighting/Style.cs,
	  Makefile.am, C64Style.xml: Worked on text editor - performance & drawing
	  improvements.

2008-02-11 Michael Hutchinson <mhutchinson@novell.com> 

	* Makefile.am: Fix location of installed assembly.

2008-02-11  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor.mdp, Mono.TextEditor/TextViewMargin.cs,
	  Mono.TextEditor/TextEditor.cs, Mono.TextEditor/GutterMargin.cs,
	  gtk-gui/objects.xml, Makefile.am: Optimized/Refactored the text editor.

2008-02-11  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/FoldMarkerMargin.cs, Mono.TextEditor/IMargin.cs,
	  Mono.TextEditor/TextEditor.cs, Mono.TextEditor/BookmarkMargin.cs,
	  Mono.TextEditor/GutterMargin.cs,
	  Mono.TextEditor.Highlighting/SyntaxMode.cs,
	  Mono.TextEditor.Highlighting/SyntaxModeService.cs,
	  Mono.TextEditor.Highlighting/Rule.cs: Optimized performance a bit. (To
	  get real performance gain, scrolling must be solved differently)

2008-02-10  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/LineSplitter.cs, Mono.TextEditor/TextEditor.cs,
	  Mono.TextEditor.Highlighting/SyntaxMode.cs: Fixed some drawing issues.

2008-02-09  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs, Mono.TextEditor/TextEditor.cs:
	  Primary clipboard now works.

2008-02-09  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs, Mono.TextEditor/Caret.cs: Overwrite mode
	  now works.

2008-02-09  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs: Fixed caret drawing bug (occurred when
	  caret was in line with foldings).

2008-02-08  Mike Krüger <mkrueger@novell.com> 

	* TangoLightStyle.xml, OblivionStyle.xml, UbuntuStyle.xml,
	  Mono.TextEditor.Highlighting/Style.cs,
	  Mono.TextEditor.Highlighting/DefaultStyle.cs, C64Style.xml: Style names
	  are not localized anymore (but descriptions are).

2008-02-08  Mike Krüger <mkrueger@novell.com> 

	* UbuntuStyle.xml: Added ubuntu style (but it could need some improvements).

2008-02-08  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor.Highlighting/DefaultStyle.cs: Changed default style
	  (folding on mouse over).

2008-02-08  Mike Krüger <mkrueger@novell.com> 

	* XmlSyntaxMode.xml: Worked on xml syntax highlighting

2008-02-08  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor.Highlighting/SyntaxModeService.cs: removed some redraws.

2008-02-08  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/Document.cs, Mono.TextEditor/LineSplitter.cs,
	  Mono.TextEditor.Highlighting/SyntaxMode.cs,
	  Mono.TextEditor.Highlighting/SyntaxModeService.cs: Fixed highlighting
	  bug.

2008-02-07  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs, Mono.TextEditor/TextEditorOptions.cs: Color
	  styles are now in options.

2008-02-06  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs: Worked on printing.

2008-02-05  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/Document.cs, Mono.TextEditor/FoldingType.cs,
	  Mono.TextEditor/TextEditor.cs, Mono.TextEditor/FoldSegment.cs: Added
	  some folding commands.

2008-02-05  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs, Mono.TextEditor/Document.cs,
	  Mono.TextEditor/Caret.cs, Mono.TextEditor/FoldSegment.cs: Improved
	  folding behavior.

2008-02-05  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs: Changed bracket highlighting in selected
	  regions.

2008-02-05  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs: Fixed click on invalid line bug.

2008-02-04  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor.Highlighting/SyntaxModeService.cs: Fixed highlighting
	  panel.

2008-02-04  Mike Krüger <mkrueger@novell.com> 

	* TangoStyle.xml: Tango bracket matching has now better colors.

2008-02-04  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor.mdp, TangoStyle.xml, OblivionStyle.xml,
	  Mono.TextEditor/TextUtil.cs, Mono.TextEditor/TextEditor.cs,
	  Mono.TextEditor/TextEditorOptions.cs,
	  Mono.TextEditor.Highlighting/SyntaxModeService.cs,
	  Mono.TextEditor.Highlighting/Style.cs, Makefile.am: Implemented bracket
	  matching.

2008-02-04  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs: Implemented Bug 354129 - Auto add
	  second brackets, quotation mark.

2008-02-04  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs, Mono.TextEditor/Document.cs:
	  Implemented Bug 313786 - New editor needs to handle cr/lf issues,
	  encoding.

2008-02-04  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/Document.cs: Implemented Bug 323946 - Undo/Redo
	  functionality are not context sensitive.

2008-02-03  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/Document.cs, Mono.TextEditor/LineSplitter.cs,
	  Mono.TextEditor/IBuffer.cs, Mono.TextEditor/LineSegmentTree.cs: Fixed
	  reload bug.

2008-02-03  Mike Krüger <mkrueger@novell.com> 

	* TangoStyle.xml: Changed literal color in tango style.

2008-02-03  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor.mdp, Makefile.am: bookmark.png wasn't a resource ?

2008-02-03  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs: Insert/Remove Indent now works
	  without selection.

2008-02-03  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs, Mono.TextEditor/TextEditorData.cs:
	  Some changes to remove code duplication.

2008-02-03  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs, Mono.TextEditor/TextEditorData.cs:
	  Fixed Insert/Remove tab selection range bug.

2008-02-03  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs, Mono.TextEditor/BookmarkMargin.cs: Some
	  changes for the splitting feature.

2008-02-03  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/LineSplitter.cs, Mono.TextEditor/TextEditor.cs,
	  Mono.TextEditor/GutterMargin.cs: Gutter redraws on width changes.

2008-02-03  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/LineSplitter.cs: Added some safety checks.

2008-02-01  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs: Fixed bug.

2008-02-01  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs: Changed the way the textedior
	  indents.

2008-02-01  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor.mdp, AssemblyInfo.cs, Mono.TextEditor/TextEditor.cs,
	  Mono.TextEditor.Highlighting/AssemblyInfo.cs, gtk-gui/gui.stetic,
	  Makefile.am: Added makefile.

2008-02-01  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/Document.cs, Mono.TextEditor/TextEditor.cs,
	  Mono.TextEditor/Segment.cs, Mono.TextEditor/FoldSegment.cs: Improved
	  folding updating.

2008-02-01  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/Document.cs, Mono.TextEditor/TextEditor.cs: Fixed
	  VisualToLogicalLine method.

2008-02-01  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs: Worked on folding.

2008-02-01  Mike Krüger <mkrueger@novell.com> 

	* TangoStyle.xml, Mono.TextEditor/Document.cs: Worked on folding.

2008-01-31  Mike Krüger <mkrueger@novell.com> 

	* VBNetSyntaxMode.xml, CSharpSyntaxMode.xml, JavaSyntaxMode.xml,
	  CPPSyntaxMode.xml, CSyntaxMode.xml,
	  Mono.TextEditor.Highlighting/SyntaxMode.cs,
	  Mono.TextEditor.Highlighting/SyntaxModeService.cs,
	  Mono.TextEditor.Highlighting/Style.cs, XmlSyntaxMode.xml: Implemented
	  lazy loading of syntax modes and styles.

2008-01-31  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor.mdp, TangoStyle.xml, VBNetSyntaxMode.xml,
	  JavaSyntaxMode.xml, CSyntaxMode.xml, CPPSyntaxMode.xml,
	  OblivionStyle.xml, Mono.TextEditor/Document.cs,
	  Mono.TextEditor.Highlighting/SyntaxMode.cs,
	  Mono.TextEditor.Highlighting/SyntaxModeService.cs, XmlSyntaxMode.xml,
	  C64Style.xml: Added some syntax highlighting files.

2008-01-31  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs, Mono.TextEditor/TextEditorData.cs,
	  Mono.TextEditor/TextEditorOptions.cs,
	  Mono.TextEditor.Highlighting/SyntaxMode.cs, XmlSyntaxMode.xml: Added
	  iterator for selected lines.

2008-01-30  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs: Fixed italic bug in rtf output.

2008-01-30  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/Document.cs: Added update after undo/redo.

2008-01-30  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor.mdp, OblivionStyle.xml, Mono.TextEditor/TextEditor.cs,
	  Mono.TextEditor.Highlighting/SyntaxMode.cs,
	  Mono.TextEditor.Highlighting/Match.cs,
	  Mono.TextEditor.Highlighting/Rule.cs,
	  Mono.TextEditor.Highlighting/Keywords.cs, TangoStyle.xml,
	  CSharpSyntaxMode.xml: Worked on styling.

2008-01-29  Mike Krüger <mkrueger@novell.com> 

	* OblivionStyle.xml, Mono.TextEditor/DefaultEditActions.cs,
	  Mono.TextEditor/TextEditor.cs, Mono.TextEditor.Highlighting/Style.cs,
	  Mono.TextEditor.Highlighting/DefaultStyle.cs, CSharpSyntaxMode.xml,
	  C64Style.xml: Worked on styling.

2008-01-29  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor.mdp, Mono.TextEditor/LineSplitter.cs,
	  Mono.TextEditor/TextEditorData.cs,
	  Mono.TextEditor.Highlighting/SyntaxMode.cs,
	  Mono.TextEditor.Highlighting/Style.cs,
	  Mono.TextEditor.Highlighting/Span.cs, CSharpSyntaxMode.xml,
	  XmlSyntaxMode.xml: Worked on highlighting.

2008-01-29  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs, Mono.TextEditor/LineSplitter.cs,
	  Mono.TextEditor/BookmarkMargin.cs: Worked on bookmark commands.

2008-01-29  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs: Added update request to the delete
	  action.

2008-01-28  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditorData.cs, Mono.TextEditor/TextEditor.cs,
	  Mono.TextEditor.Highlighting/Style.cs: Fixed delete selection bug (caret
	  offset didn't get updated), added primitive longest line management,
	  changed syntax colors a bit.

2008-01-27  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs, Mono.TextEditor/TextEditor.cs,
	  Mono.TextEditor/BookmarkMargin.cs,
	  Mono.TextEditor.Highlighting/SyntaxMode.cs: No/missing syntax
	  highlighting is now handled with a default syntax highlighting.

2008-01-27  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/FoldMarkerMargin.cs, Mono.TextEditor/IMargin.cs,
	  Mono.TextEditor/TextEditor.cs: Text cursor is now only for the text
	  region.

2008-01-27  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs, Mono.TextEditor/TextEditor.cs:
	  Improved drag & drop support.

2008-01-27  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs, Mono.TextEditor/DefaultEditActions.cs:
	  Paste now requests a redraw.

2008-01-27  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditorData.cs, Mono.TextEditor/TextEditor.cs:
	  Optimized re-draws a bit.

2008-01-26  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs,
	  Mono.TextEditor/FoldMarkerMargin.cs, Mono.TextEditor/IMargin.cs,
	  Mono.TextEditor/TextEditor.cs, Mono.TextEditor/BookmarkMargin.cs,
	  Mono.TextEditor/GutterMargin.cs,
	  Mono.TextEditor.Highlighting/SyntaxModeService.cs: Worked on text editor
	  mouse handling.

2008-01-25  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs, Mono.TextEditor.Highlighting/SyntaxMode.cs,
	  Mono.TextEditor.Highlighting/Style.cs: Worked on styles.

2008-01-25  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs: Fixed little issue in rtf output.

2008-01-25  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs: Optimized rtf color table output.

2008-01-25  Mike Krüger <mkrueger@novell.com> 

	* OblivionStyle.xml, Mono.TextEditor/DefaultEditActions.cs,
	  Mono.TextEditor/TextEditorOptions.cs, Mono.TextEditor/GutterMargin.cs,
	  Mono.TextEditor.Highlighting/SyntaxMode.cs,
	  Mono.TextEditor.Highlighting/Style.cs,
	  Mono.TextEditor.Highlighting/ChunkStyle.cs, CSharpSyntaxMode.xml,
	  C64Style.xml: Worked on Syntax highlighting

2008-01-25  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs, Mono.TextEditor/TextEditor.cs,
	  Mono.TextEditor/TextEditorOptions.cs: Optimized drawing a bit, added
	  syntax mode enabled option.

2008-01-25  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs, Mono.TextEditor/TextEditorOptions.cs: Added
	  property change event.

2008-01-25  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/DefaultEditActions.cs, Mono.TextEditor/TextEditorData.cs,
	  Mono.TextEditor/TextEditor.cs, Mono.TextEditor.Highlighting/Style.cs:
	  Editor is now capable of outputting rtf to clipboard.

2008-01-25  Mike Krüger <mkrueger@novell.com> 

	* OblivionStyle.xml, Mono.TextEditor/RedBlackTree.cs,
	  Mono.TextEditor/LineSegmentTree.cs, Mono.TextEditor/TextEditor.cs,
	  Mono.TextEditor.Highlighting/Style.cs,
	  Mono.TextEditor.Highlighting/DefaultStyle.cs, C64Style.xml: Selected
	  foreground colors are now part of the highlighting style.

2008-01-25  Lluis Sanchez Gual <lluis@novell.com> 

	* Mono.TextEditor/TextEditor.cs: Changes the mouse cursor to text when the
	  mouse is inside the editor. Changes the way cursor blinking is handled,
	  and make it work more like gtksourceview. Draws selected text using the
	  system selection color (usually white).

2008-01-23  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs: Worked on code completion.

2008-01-22  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor.Highlighting/SyntaxModeService.cs: Worked on style panel.

2008-01-22  Mike Krüger <mkrueger@novell.com> 

	* OblivionStyle.xml, Mono.TextEditor.Highlighting/Style.cs, C64Style.xml:
	  Color styles now have descriptions. Name/Description is now localizable.

2008-01-22  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditor.cs, Mono.TextEditor/TextEditorOptions.cs,
	  Mono.TextEditor/GutterMargin.cs: Added some text editor options -
	  options are now virtual.

2008-01-21  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor.mdp, Mono.TextEditor.mds: Added changelogs to the project
	  files.

2008-01-21  Mike Krüger <mkrueger@novell.com> 

	* Mono.TextEditor/TextEditorData.cs, Mono.TextEditor/TextEditor.cs: Worked
	  on selection logic.

